/**
 *app.js
 *路由主js
 *     --Created by Li Yubo on 2016/10/31 9:32.
 */
define([
  "vue",
  "common/config",
  "common/v-dialog"
], function (Vue,
             config, dialog) {
  var module = Vue.extend({
    destroyed: function () {
      //console.log("pipeline app vue.destroyed");
    },
    data: function () {
      //console.log("pipeline app vue.data");
      return {
        loadingShow: 0
      }
    },
    ready: function () {
      //console.log("pipeline app vue.ready");
      config.app = this;
    },
    route: {
      data: function (transition) {
        //console.log("pipeline app vue.route.data");
        return transition.next();
      },
      activate: function (transition) {
        //console.log("pipeline app vue.route.activate");
        return transition.next();
      },
      deactivate: function (transition) {
        //console.log("pipeline app vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      loading: function (flag, path) {
        this.loadingShow = flag;
      }
    },
    events: {
      loading: function (action) {
        var that = this;
        if (action) {
          this.loadingShow += 1;
        } else {
          setTimeout(function () {
            if (that.loadingShow > 0)that.loadingShow -= 1;
          }, 200);
        }
      },
      dialog: function (obj) {
        this.$broadcast("dialog.show", obj);
      }
    }
  });
  return module;
});