/**
 * config.js
 * 公共配置文件
 *     --Created by Li Yubo on 2016/10/24 17:19.
 */
define(["core", "common/host", "base64"], function (core, hostConfig, base64) {
  var config = {
    my_url: 'https://activities.toon.mobi',
    p_url: 'https://activities.toon.mobi/',
    url: 'https://activities.toon.mobi',
    vote_url: "https://activities-vote.toon.mobi/",
    toon_url: 'https://activities-api.toon.mobi',
    share_url: 'https://share.toon.mobi',
    activity_url: 'https://activities.toon.mobi/manifest.json',
    appId: '716',

    namespace: "cAlum.ugc.systoon.com",
    certificate: "578f2243102ad6c444b8291d",
    limit: 10,
    key: null,
    code: null,
    openId: null,
    logintype: 0,
    pageTitle: "",
    isAllowSubmit: true,
    COMMENT_MAX: 500,    //微服务-评论点赞最大评论字数，服务端最大5000，这里为了测试设定成了20
    COMMENT_UTL: "http://172.28.50.173:8080",    // 微服务-评论点赞: 微服务地址
    COMMENT_APPID: 2,  // 微服务-评论点赞: appid, 当前应用在微服务注册的id标识
    COMMENT_TOKEN: ""  // 微服务-评论点赞: token, 由当前app的服务端生成, 是每个接口的必填项, 如失效, 请向服务端重新获取
  };

  config.getQueryStringByName = function (name) {
    var result = location.search.match(new RegExp("[\?\&]" + name + "=([^\&]+)", "i"));
    return !result ? "" : result[1];
  };

  config.pagePath = config.my_url;
  config.frame = config.getQueryStringByName("frame");
  config.entry = config.getQueryStringByName("entry") || "";
  config.feedType = config.getQueryStringByName("feed_type");
  config.ac_id = config.getQueryStringByName("ac_id");
  config.toon_type = config.getQueryStringByName("toon_type");

  config.returnTag = config.getQueryStringByName("returnTag") ? JSON.parse(base64.decode(config.getQueryStringByName("returnTag"))) : '';

  config.session = {};
  config.app = null;
  config.defaultPoster = [
    {"url": "https://apr.qiniu.toon.mobi/yule.jpg"},//娱乐
    {"url": "https://apr.qiniu.toon.mobi/xingqu.jpg"},//兴趣
    {"url": "https://apr.qiniu.toon.mobi/huwai.jpg"},//户外
    {"url": "https://apr.qiniu.toon.mobi/zhanlan.jpg"},//展览
    {"url": "https://apr.qiniu.toon.mobi/image/active/yanchu.png"},//演出
    {"url": "https://apr.qiniu.toon.mobi/huiyi.jpg"},//会议
    {"url": "https://apr.qiniu.toon.mobi/yundong.jpg"},//运动
    {"url": "https://apr.qiniu.toon.mobi/jiangzuoshalong.jpg"}//讲座沙龙
  ];
  window.alert = function (msg, delay) {//所有弹出的提示信息
    if (!delay) {
      delay = 3000;
    }
    var $info = document.getElementById("__dialog__");
    if (!$info) {
      var inner = document.createElement("div");
      inner.id = "dialogText";
      inner.style.backgroundColor = "#000";
      inner.style.color = "#fff";
      inner.style.maxWidth = "7.133333rem";
      inner.style.minWidth = "1.3333333333333333rem";
      inner.style.display = "inline-block";
      inner.style.borderRadius = "0.13rem";
      inner.style.padding = "0.36666667rem";
      inner.style.textAlign = "center";
      inner.style.fontSize = "0.4rem";
      var out = document.createElement("div");
      out.id = "__dialog__";
      out.style.width = "100%";
      out.style.position = "absolute";
      out.style.top = "40%";
      out.style.textAlign = "center";
      out.style.zIndex = "100";

      out.appendChild(inner);
      document.body.appendChild(out);
      $info = document.getElementById("__dialog__");
    }
    document.getElementById("dialogText").innerHTML = msg;
    $info.style.display = "block";
    setTimeout(function () {
      document.getElementById("__dialog__").style.display = "none";
    }, delay);
  };
  window.confirm = function (args) {
    var _self = this;
    console.log("dialog events.dialog.show: ", args);
    var contain = document.createElement("div");
    var title = document.createElement("div");
    var bottom = document.createElement("div");
    var right = document.createElement("span");
    var left = document.createElement("span");
    contain.id = "contain";
    title.id = "title";
    bottom.id = "bottom";
    right.id = "right";
    left.id = "left";
    bottom.appendChild(left);
    bottom.appendChild(right);
    contain.appendChild(title);
    contain.appendChild(bottom);
    document.body.appendChild(contain);
    document.getElementById("title").innerHTML = args.content;
    document.getElementById("right").innerHTML = args.buttons[0].name;
    document.getElementById("left").innerHTML = args.buttons[1].name;
  };
  /*时间转化
   * time 时间秒数,必传
   * format 格式,非必传 yyyy年 MM月 dd日 hh小时 mm分 ss秒 D周几 DD星期几，比如传入"始于yyyy-MM-dd的hh:mm",则返回"始于2014-06-15的12:05"
   *
   * */
  config.formatTime = function (time, format) {
    if (!time || isNaN(time)) return "";
    //过去
    var stamp = new Date(time * 1000),
      year = stamp.getFullYear(),
      month = (stamp.getMonth() + 1) > 9 ? (stamp.getMonth() + 1) : "0" + (stamp.getMonth() + 1),
      day = stamp.getDate() > 9 ? stamp.getDate() : "0" + stamp.getDate(),
      hour = stamp.getHours() > 9 ? stamp.getHours() : "0" + stamp.getHours(),
      minute = stamp.getMinutes() > 9 ? stamp.getMinutes() : "0" + stamp.getMinutes(),
      sec = stamp.getSeconds() > 9 ? stamp.getSeconds() : "0" + stamp.getSeconds();

    if (format) {
      format = format.replace("yyyy", year);
      format = format.replace("MM", month);
      format = format.replace("dd", day);
      format = format.replace("hh", hour);
      format = format.replace("mm", minute);
      format = format.replace("ss", sec);
      var dayArr;
      if (format.indexOf("DD") >= 0) {
        dayArr = ["星期天", "星期一", "星期二", "星期三", "星期四", "星期五", "星期六"];
        format = format.replace("DD", dayArr[stamp.getDay()]);
      } else if (format.indexOf("D") >= 0) {
        dayArr = ["周日", "周一", "周二", "周三", "周四", "周五", "周六"];
        format = format.replace("D", dayArr[stamp.getDay()]);
      }
    } else {
      format = year + "-" + month + "-" + day + " " + hour + ":" + minute;
    }
    return format;
  };

  /*倒计时时间格式化*/
  config.formateTimes = function (time) {
    var sTime = time;
    var date = new Date();
    var nowTime = Math.floor(date.getTime() / 1000);
    // console.log('now',nowTime)
    var leftTime = sTime - nowTime;
    // console.log('left',leftTime)
    if (leftTime > 0) {
      var day = Math.floor(leftTime / 86400);
      var hour = Math.floor((leftTime / 3600) % 24);
      var min = Math.floor((leftTime / 60) % 60);
      var sec = Math.floor((leftTime) % 60);
      hour = hour < 10 ? "0" + hour : hour;
      min = min < 10 ? "0" + min : min;
      sec = sec < 10 ? "0" + sec : sec;
      var format = '';
      if (day > 0) {
        format = day + "天" + hour + ":" + min + ":" + sec;
      }
      if (day <= 0 && hour > 0) {
        format = hour + ":" + min + ":" + sec;
      }
      if (day <= 0 && hour <= 0) {
        format = min + ":" + sec;
      }
    } else {
      format = '进行中'
    }
    return format
  };
  config.dateTomiao = function (param) {
    var time = param ? param.replace(/\(.*?\)/g, "") : null;
    time = time.replace(/\./g, "/");
    if (!time) {
      return "null";
    } else {
      time = new Date(time);
      return time.getTime() / 1000;
    }
  }
  config.loading = function (flag, path) {
    if (config.app) config.app.loading(flag, path);
  };

  config.skipCard = function (params) {
    toongine.frame.openFrame({
      params: params,
      callback: function (res) {
        if (res.code != 0) {
          alert(res.msg);
        }
      }
    })
    //调起toon协议
    // var option = param;
    // var uri = "toon://frame?params=" + JSON.stringify(option);
    // window.location.href = uri;
  };
  config.chat = function (params) {
    toongine.chat.openChat({
      params: params,
      callback: function (res) {
        if (res.code != 0) {
          alert(res.msg);
        }
      }
    })

    // var option = param;
    // var uri = "toon://chat?params=" + JSON.stringify(option);
    // window.location.href = uri;
  };
  config.cardFlag = function (fid) {
    /*
     * cardFlag 1 个人名片；2：员工名片；3：群组名片
     * */
    var cardFlag;
    fid = fid ? fid : "";
    if (fid.indexOf("c") >= 0) {
      cardFlag = 1;
    } else if (fid.indexOf("s") >= 0) {
      cardFlag = 2;
    } else if (fid.indexOf("g") >= 0) {
      cardFlag = 3;
    } else {
      cardFlag = 1;
    }
    return cardFlag;
  };
  /**
   * 标题设置
   * @param transition
   */
  config.setTitle = function (transition) {
    var m = function (title) {
      document.title = title;
      toongine.page.setNavigationBarTitle({
        params: {
          title: title
        }
      })

      config.pageTitle = title;
      try {
        setTitle(title);
      } catch (e) {
      }
    };
    var pageName = transition.to.name;
    if (pageName === "index-list") {
      m("活动");
    } else if (pageName === "search") {
      m(transition.to.query.text);
    } else if (pageName === "active-info" || pageName === "no-active-info") {
      m("活动详情");
    } else if (pageName === "add-active") {
      m("发布活动");
    } else if (pageName === "describe") {
      m("活动描述");
    } else if (pageName === "apply") {
      m("确认报名");
    } else if (pageName === "add-apply-info") {
      m("报名必填信息");
    } else if (pageName === "register-list-page") {
      m("查看报名");
    } else if (pageName === "sign-list") {
      m("查看签到");
    } else if (pageName === "approval-list") {
      m("审核报名");
    } else if (pageName === "edit-active") {
      m("编辑活动");
    } else if (pageName === "error") {
      m("出错啦");
    } else if (pageName === "export-apply-info") {
      m("导出名单");
    } else if (pageName === "qr-code") {
      m("活动二维码");
    } else if (pageName === "del") {
      m("活动详情");
    } else if (pageName === "no-active-list") {
      m("活动");
    } else if (pageName === "edit-describe") {
      m("活动描述");
    } else if (pageName === "active-intro") {
      m("活动详情");
    } else if (pageName === "add-notice" || pageName === "notice-list") {
      m("活动公告");
    } else if (pageName === "no-signUp" || pageName === 'signUp-CheckIn') {
      m("签到");
    } else if (pageName === "activity-code") {
      m("签到二维码");
      //}else if(pageName==="heartbeat"){
      //    m("Ta们很心动");
    } else if (pageName === "discuss-area") {
      m("讨论区");
    } else if (pageName === "active-code") {
      m("活动二维码");
    } else if (pageName === "bbs-create") {
      m("发布评论");
    } else if (pageName === "my-list") {
      m("我的活动");
    } else if (pageName === "city-list") {
      m("城市列表");
    }
  };
  /**
   * 分享内容设置
   * @param type 1详情页，2其他页
   * @param obj 详情页的id,标题，描述
   */
  config.setShare = function (type, obj) {
    var toonType;
    var text;
    try {
      if (!config.session.toon_type) {
        toonType = config.toon_type ? config.toon_type : "113";
      } else if (config.session.toon_type == '102') {
        toonType = "102";
      } else {
        toonType = "113";
      }
      console.log("toon_type", toonType);
      //详情页
      if (type === 1) {
        //配置分享渠道
        document.getElementsByName("shareChannel")[0].setAttribute("content", "shareToon,shareWeChat,shareWeChatCircle,shareQQ,shareQQSpace");
        if (obj.id) {
          text = obj.st + " - " + obj.et;
          if (!obj.text) {
            obj.text = ""
          } else {
            obj.text = obj.text.substr(0, 100)
          }
          //图片设置
          document.getElementsByName("shareToonImageUrl")[0].setAttribute("content", obj.img);
          document.getElementsByName("shareWeChatImageUrl")[0].setAttribute("content", obj.img);
          document.getElementsByName("shareWeChatCircleImageUrl")[0].setAttribute("content", obj.img);
          document.getElementsByName("shareQQImageUrl")[0].setAttribute("content", obj.img);
          document.getElementsByName("shareQQSpaceImageUrl")[0].setAttribute("content", obj.img);
          //url设置
          document.getElementsByName("shareToonUrl")[0].setAttribute("content", config.p_url + "html/src/index.html?entry=101&ac_id=" + obj.id + "&toon_type=" + toonType);
          document.getElementsByName("shareWeChatUrl")[0].setAttribute("content", config.p_url + "share/shareactivity?entry=101&ac_id=" + obj.id + "&toon_type=" + toonType);
          document.getElementsByName("shareWeChatCircleUrl")[0].setAttribute("content", config.p_url + "share/shareactivity?entry=101&ac_id=" + obj.id + "&toon_type=" + toonType);
          document.getElementsByName("shareQQUrl")[0].setAttribute("content", config.p_url + "share/shareactivity?entry=101&ac_id=" + obj.id + "&toon_type=" + toonType);
          document.getElementsByName("shareQQSpaceUrl")[0].setAttribute("content", config.p_url + "share/shareactivity?entry=101&ac_id=" + obj.id + "&toon_type=" + toonType);
          //title设置
          document.getElementsByName("shareToonTitle")[0].setAttribute("content", obj.title);
          document.getElementsByName("shareWeChatTitle")[0].setAttribute("content", obj.title);
          document.getElementsByName("shareWeChatCircleTitle")[0].setAttribute("content", obj.title);
          document.getElementsByName("shareQQTitle")[0].setAttribute("content", obj.title);
          document.getElementsByName("shareQQSpaceTitle")[0].setAttribute("content", obj.title);
          //text设置
          document.getElementsByName("shareToonText")[0].setAttribute("content", text);
          document.getElementsByName("shareWeChatText")[0].setAttribute("content", text);
          document.getElementsByName("shareWeChatCircleText")[0].setAttribute("content", text);
          document.getElementsByName("shareQQText")[0].setAttribute("content", text);
          document.getElementsByName("shareQQSpaceText")[0].setAttribute("content", text);

        }
      }
    } catch (e) {
      console.log(e)
    }
  };
  config.isCurDate = function (end_time, start_time) {
    var end_t = end_time * 1000;
    var start_t = start_time * 1000;
    var end_date = new Date(end_t);
    var start_date = new Date(start_t);
    if (end_date.getFullYear() == start_date.getFullYear() && end_date.getMonth() == start_date.getMonth() && end_date.getDate() == start_date.getDate()) {
      return "1";
    } else {
      return "0";
    }
  };
  return config;
})
;
