/**
 * 收集用户行为信息
 */
define(['vue'], function (vue) {
  if (typeof Object.assign != 'function') {
    Object.assign = function (target) {
      'use strict';
      if (target == null) {
        throw new TypeError('Cannot convert undefined or null to object');
      }

      target = Object(target);
      for (var index = 1; index < arguments.length; index++) {
        var source = arguments[index];
        if (source != null) {
          for (var key in source) {
            if (Object.prototype.hasOwnProperty.call(source, key)) {
              target[key] = source[key];
            }
          }
        }
      }
      return target;
    };
  }

  var getQueryStringByName = function (name) {
    if (location.search) {
      var result = location.search.match(new RegExp("[\?\&]" + name + "=([^\&]+)", "i"));

    } else if (location.hash) {
      var result = location.hash.match(new RegExp("[\?\&]" + name + "=([^\&]+)", "i"));

    }

    if (result == null || result.length < 1) {
      return "";
    }
    return result[1];
  };
  /**
   * 生成UUID
   * @param  {[Number]} len   [长度]
   * @param  {[Number]} radix [基数]
   * @return {[String]}       [返回UUID]
   */
  var uuid = function (len, radix) {
    var chars = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz'.split('');
    var tempArr = [], i;
    radix = radix || chars.length;

    if (len) {
      for (i = 0; i < len; i++) tempArr[i] = chars[0 | Math.random() * radix];
    } else {
      var r;
      tempArr[8] = tempArr[13] = tempArr[18] = tempArr[23] = '-';
      tempArr[14] = '4';
      for (i = 0; i < 36; i++) {
        if (!tempArr[i]) {
          r = 0 | Math.random() * 16;
          tempArr[i] = chars[(i == 19) ? (r & 0x3) | 0x8 : r];
        }
      }
    }

    return tempArr.join('');
  };
  // 存储UUID 没有code 的时候使用
  if (!localStorage.getItem("UUID")) {
    localStorage.setItem("UUID", uuid());
  }
  var CODE = sessionStorage.getItem("CODE") || getQueryStringByName("code"),
    UUID = localStorage.getItem("UUID");

  var Analytics = {},
  // url = "http://172.28.28.236:8081/collectionWebLog/h5PageServlet/saveH5PageData";
    url = "http://da.syswin.com/collectionWebLog/h5PageServlet/saveH5PageData";

  /**
   * 发送用户行为数据方法
   * @param  {[Object]} [参数对象]
   * @return {[void]}   [无返回值]
   */
  Analytics.sendData = function (args) {
    var def = {
        "oc": "HD",	// 一级分类
        "ai": "89",		// 应用ID
        "sc": CODE, // 用户安全码
        "ck": UUID, // UUID
        "st": +new Date(), // 页面访问开始时间
        "dv": "2",		// 数据版本
        "ui": "",		// 用户ID
        "ci": "",		// 名片ID
        "iai": "",		// 应用实例ID
        "rf": "",		// 来源页面地址
        "ti": "",		// 当前页面标题
        "url": "",		// 当前页面地址
        "bd": ""		// 业务数据
      },
      params = Object.assign({}, def, args);
    console.log("埋点title", params.ti);
    params = JSON.stringify(params);
//        console.log("###### params: ", params);
//		$.post(url, params, function(res){
//			console.log("埋点数据发送成功！")
//		}, 'json');

    //$.ajax({
    //    url: url,
    //    type: "post",
    //    data: params,
    //    headers: {
    //        "Content-Type": "application/json"
    //    },
    //    success: function(data) {
    //        console.log(data)
    //    }
    //});

    vue.http.post(url, params).then(function (response) {
        console.log(JSON.stringify(response))
      },
      function (response) {
//                console.error("analytics.js 请求出错:"+response.code);
      }
    );
  };

  return Analytics;
});