(function (win) {

  win.toonCall = function (option, type, callback) {
    option = option || {};
    var flagId = new Date().getTime() + Math.random();
    option.flagId = flagId;
    var pp = encodeURI(JSON.stringify(option));
    //调起toon协议
//        var uri = "toon://" + type + "?params=" + pp;
    console.log("encode", pp, "*****", JSON.stringify(option));

    switch (type) {
      case 'groupChat/create':
        toongine.groupChat.create({
          params: option,
          callback: function (res) {
            if (res.code == 0) {
              if (callback) callback(res.data);
            } else {
              alert(res.msg);
            }
          }
        })
        break;
      case 'groupChat/joinMyself':
        toongine.groupChat.joinGroupChat({
          params: option,
          callback: function (res) {
            if (res.code == 0) {
              if (callback) callback(res.data);
            } else {
              alert(res.msg);
            }
          }
        })
        break;
      case 'card/chooseCard':
        toongine.card.chooseCard({
          params: option,
          callback: function (res) {
            if (res.code == 0) {
              if (callback) callback(res.data);
            } else {
              alert(res.msg);
            }
          }
        })
        break;
      default:
    }

    // var uri = "toon://" + type + "?params=" + JSON.stringify(option);
    // window.location.href = uri;

    /**获取返回数据**/
    // MAjax({
    //   url: "http://127.0.0.1:6780/getResult",
    //   type: "POST",
    //   data: 'params={"flagId":' + option.flagId + '}',
    //   success: function (e) {
    //     var e = JSON.parse(e);
    //     if (callback) callback(e.data);
    //   },
    //   error: function () {
    //     console.log("未返回信息" + uri);
    //   }
    // });

  };

  //上传图片
  win.uploadImages = function (option, callback) {

    var flagId = new Date().getTime() + Math.random();
    option.flagId = flagId;

    //调起手机拍照/相册
    // window.location.href = "toon://mwap/photo?params=" + JSON.stringify(option);

    var imgcount = 1;

    /**获取图片base64以及二进制流大小**/
    MAjax({
      url: "http://127.0.0.1:6780/getResult",
      type: "POST",
      data: 'params={"flagId":' + option.flagId + '}',
      success: function (e) {
        var res = JSON.parse(e);
        if (res.data.result && res.data.result == "cancel") {
          var result = "cancel";
          if (callback) callback(result);
          return false;
        } else {
          var data;
          if (res.data.imageArr) {
            imgcount = res.data.imageArr.length;
            for (var i = 0; i < imgcount; i++) {
              getUploadToken(res.data.imageArr[i], i);
            }
          } else {
            data = res.data;
            getUploadToken(data, 0);
          }
        }

      },
      error: function () {
        alert("未获取到图片信息");
      }
    });

    /***
     * 获取上传图片的token码
     ***/
    function getUploadToken(data, index) {

      MAjax({
        url: "http://qiniu.systoon.com/getToken.php",
        success: function (res) {
          uploadQNCloud(data, res, index);
        },
        error: function () {
          alert("未获取到uploadToken");
        }
      });
    }

    /***
     *上传七牛云
     ***/
    var imageURL = {};
    var success = 0;

    function uploadQNCloud(data, token, index) {
      MAjax({
        url: "http://upload.qiniu.com/putb64/" + data.size,
        type: "POST",
        data: data.base64,
        beforeSend: function (res, setHeader) {
          setHeader("Content-Type", "application/octet-stream");
          setHeader("Authorization", "UpToken " + token);
        },
        success: function (res) {
          //返回图片地址
          var domain = "http://apr.qiniu.toon.mobi/";
          imageURL[index] = domain + JSON.parse(res).key;
          success++;

          if (success == imgcount) {
            var arr = [];
            for (var i = 0; i < success; i++) {
              arr.push(imageURL[i]);
            }
            if (callback) callback(arr);
          }
        },
        error: function () {
          alert("上传失败");
        }
      });
    }

  };

  /**
   * 上传图片(带状态的)
   * @param option 参数,必传
   * @param callback 回调，返回参数说明{code:"01",data:{}};
   *      code:"10":原生返回数据失败。data:错误对象
   *           "11":认证失败，所有图片上传失败，data:错误信息对象
   *           "12":单张图片上传失败，data:图片id.
   *           "20":用户取消上传，data:"cancel"
   *           "21":原生返回成功，data:图片对象数组，对象仅含id
   *           "22":原生返回成功，data:图片对象数组，对象包含id,src(base64),width,height,size
   *           "23":图片上传成功，data:图片对象，对象包含id,url
   */

  //TODO:修改相册
  win.uploadImgStateful = function (option, res, callback) {
    var imageArr = res.data
    if (!callback) {
      return false;
    }
    if(res.code == -1) {
      callback({code: '20'})
      return false;
    }

    getImgSuccess(imageArr);

    function getImgSuccess(e) {
      var imgArr = [];

      for (var i = 0; i < e.length; i++) {
        imgArr[i] = {id: new Date().getTime() + Math.random() + ""};
      }
      callback({code: "21", data: imgArr});

      //获取图片宽高信息并返回
      var j, len = e.length;
      for (j = 0; j < len; j++) {
        imgArr[j] = {
          id: imgArr[j].id,
          size: e[j].size,
          imageType: e[j].imageType,
          src: "data:image/" + e[j].imageType + ";base64," + e[j].base64
          // width:originalArr[j].width,
          // height:originalArr[j].height
        };
      }
      callback({code: "22", data: imgArr});

      //上传
      getTokenOnce(imgArr, e, callback);
    }
  };

  function getTokenOnce(arr, dataArr, callBack) {
    MAjax({
      //url: "http://t200.signon.systoon.com/phpcode/getToken.php",
      url: "http://qiniu.systoon.com/getToken.php",
      success: function (res) {
        var k, len = arr.length;
        console.log(len)
        for (k = 0; k < len; k++) {
          console.log(55555555)
          uploadToCloud(dataArr[k], res, arr[k].id, callBack);
        }
      },
      error: function (e) {
        callback({code: "11", data: e});
      }
    });
  }

  function uploadToCloud(item, token, id, callback) {
    console.log(66666666666)
    MAjax({
      url: "http://upload.qiniu.com/putb64/" + item.size,
      type: "POST",
      data: item.base64,
      beforeSend: function (res, setHeader) {
        setHeader("Content-Type", "application/octet-stream");
        setHeader("Authorization", "UpToken " + token);
      },
      success: function (res) {
        //返回图片地址
        var urlTemp = {
          //url:"http://oa91tlxmn.bkt.clouddn.com/"+JSON.parse(res).key,
          url: "http://apr.qiniu.toon.mobi/" + JSON.parse(res).key,
          id: id
        };
        console.log(JSON.stringify(urlTemp));
        callback({code: "23", data: urlTemp});
      },
      error: function () {
        callback({code: "12", data: id});
      }
    });
  }


  /**
   * 重新上传图片
   * @param obj 图片对象，包含字段id,src(上传图片时返回的图片src)
   * @param callback 回调，参数同上传图片时回调
   */
  win.reUploadImg = function (obj, callback) {
    MAjax({
      url: "http://qiniu.systoon.com/getToken.php",
      success: function (res) {
        uploadToCloud3(obj, res, obj.id, callback);
      },
      error: function (e) {
        callback({code: "12", data: obj.id});
      }
    });

    function uploadToCloud3(item, token, id, callback) {
      //提取base64
      var base64 = item.src.split(",")[1];
      MAjax({
        url: "http://upload.qiniu.com/putb64/" + item.size,
        type: "POST",
        data: base64,
        beforeSend: function (res, setHeader) {
          setHeader("Content-Type", "application/octet-stream");
          setHeader("Authorization", "UpToken " + token);
        },
        success: function (res) {
          //返回图片地址
          var urlTemp = {
            //url:"http://oa91tlxmn.bkt.clouddn.com/"+JSON.parse(res).key,
            url: "http://apr.qiniu.toon.mobi/" + JSON.parse(res).key,
            id: id
          };
          callback({code: "23", data: urlTemp});
        },
        error: function () {
          callback({code: "12", data: id});
        }
      });
    }
  };

  function run(arr) {
    var list = [];

    function cb(size) {
      return function () {
        if (size-- < 0) {
          console.log("over");
        }
      }
    }

    for (var i = 0; i < arr.length; i++) {
      var item = {
        data: arr[i],
        url: null
      };
      list.push(item);
      u(item, cb)
    }
  }

  function u(data, cb) {
    setTimeout(function () {
      data.url = "http://www.baidu.com"
    }, 1000);
    cb();
  }

  /**
   * @原生ajax请求
   * @example
   ajax({
        url: "./TestXHR.php",              //请求地址
        type: "POST",                       //请求方式
        data: { name: "super", age: 20 },        //请求参数
        dataType: "json",
        success: function (response, xml) {
            // 此处放成功后执行的代码
        },
        fail: function (status) {
            // 此处放失败后执行的代码
        }
     });
   */
  var MAjax = function (options) {
    options = options || {};
    options.type = (options.type || "GET").toUpperCase();
    options.dataType = (options.dataType || "text").toUpperCase();
    options.cache = options.cache || "true ";
    options.timeout = parseInt(options.timeout) || 10000;

    //var params = formatParamsA(options.data);
    var params = options.data; //需求问题对于参数暂不做处理
    var protocol = /^([\w-]+:)\/\//.test(options.url) ? RegExp.$1 : window.location.protocol;
    var responseFields = {
      "XML": "responseXML",
      "TEXT": "responseText",
      "JSON": "responseJSON"
    };

    var headers = {};
    var setHeader = function (name, value) {
      headers[name.toLowerCase()] = [name, value];
    };

    var getHeader = function () {
      xhr.setRequestHeader = setHeader;
      for (name in headers) {
        nativeSetHeader.apply(xhr, headers[name]);
      }
    };

    //创建 - 非IE6 - 第一步
    if (window.XMLHttpRequest) {
      var xhr = new XMLHttpRequest();
    } else { //IE6及其以下版本浏览器
      var xhr = new ActiveXObject('Microsoft.XMLHTTP');
    }
    try {
      xhr.responseType = options.dataType;//'text'：返回类型为字符串，这是默认值。'arraybuffer'：返回类型为ArrayBuffer。'blob'：返回类型为Blob。'document'：返回类型为Document。'json'：返回类型为JSON object。
    } catch (e) {
      console.log("ajax不支持responseType");
    }
    if (!options.cache) { //禁用缓存
      xhr.setRequestHeader("If-Modified-Since", "0");
    }
    //接收 - 第三步
    xhr.onreadystatechange = function () {
      if (xhr.readyState == 4) {  //请求完成，响应就绪
        options.complete && options.complete.call(this, xhr);//响应就发送
        // var result = xhr.responseType == "text" ? xhr.responseText : xhr.responseXML; //返回值类型
        //var result = xhr[responseFields[options.dataType]]; //返回值类型
        var result = xhr.responseText;
        if ((xhr.status >= 200 && xhr.status < 300) || xhr.status === 304 || (xhr.status === 0 && protocol === 'file:') && typeof options.success == 'function') {//成功
          var dataType = options.dataType || xhr.getResponseHeader('content-type');
          try {
            if (dataType === 'SCRIPT') {
              (1, eval)(result);
            } else if (dataType === 'XML') {
              result = xhr.responseXML;
            } else if (dataType === 'JSON') {
              result = JSON.parse(result);
            }
          } catch (e) {
            console.log("error");
          }
          options.success && options.success(result, xhr.status);
        } else if (xhr.status >= 400 && xhr.status < 500) { //客户端出错，404啊神马的
          options.error && options.error(xhr, xhr.status);
        } else if (xhr.status >= 500) { //服务器端出错
          options.error && options.error(xhr, xhr.status);
        } else {
          options.error && options.error(xhr, xhr.status);
        }
      }
    }
    var nativeSetHeader = xhr.setRequestHeader;

    setHeader('Accept', '*/*');
    //连接 和 发送 - 第二步
    if (options.type == "GET") {
      xhr.open("GET", options.url + "?" + params, true);
      options.beforeSend && options.beforeSend.call(this, options, setHeader);
      getHeader();
      xhr.send(null);
    } else if (options.type == "POST") {
      xhr.open("POST", options.url, true);
      //设置表单提交时的内容类型
      setHeader("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
      options.beforeSend && options.beforeSend.call(this, options, setHeader);
      getHeader();
      xhr.send(params);
    }

    //格式化参数
    function formatParamsA(data) {
      var arr = [];
      for (var name in data) {
        arr.push(encodeURIComponent(name) + "=" + encodeURIComponent(data[name]));
      }
      arr.push(("v=" + Math.random()).replace("."));
      return arr.join("&");
    }

    function formatParamsB(obj) {
      var query = '', name, value, fullSubName, subName, subValue, innerObj, i;
      for (name in obj) {
        value = obj[name];
        if (value instanceof Array) {
          for (i = 0; i < value.length; ++i) {
            subValue = value[i];
            fullSubName = name + '[' + i + ']';
            innerObj = {};
            innerObj[fullSubName] = subValue;
            query += param(innerObj) + '&';
          }
        }
        else if (value instanceof Object) {
          for (subName in value) {
            subValue = value[subName];
            fullSubName = name + '[' + subName + ']';
            innerObj = {};
            innerObj[fullSubName] = subValue;
            query += param(innerObj) + '&';
          }
        }
        else if (value !== undefined && value !== null) {
          query += encodeURIComponent(name) + '=' + encodeURIComponent(value) + '&';
        }
      }
      return query.length ? query.substr(0, query.length - 1) : query;
    }
  }
})(window);
