define(["vue", "common/config", "common/api", "core", "bscroll", "scrollLoading", "scrollEase", "scrollBubble", "text!tplPath/scroll.html"], function(Vue, config, api, core, Bscroll, scrollLoading, ease, scrollBubble, tpl) {
  var scrollComponent = {};
  scrollComponent.canBack = false;
  scrollComponent.isDigit = function(patrn, param) {
    if (!patrn || !param) {
      return false;
    }
    return patrn.test(param);
  };
  Vue.events = new Vue({});
  scrollComponent.module = Vue.extend({
    template: tpl,
    data: function() {
      return {
        // scroll: {},
        refreshTxt: '',
        downing: false,
        bubbleY: 0,
        pullDownRefresh: false,
        beforePullDown: true,
        pulling: true,
        pullDownStyle: '',
        pullDownInitTop: -50,
        pullUpLoad: false,
        isPullUpLoad: true,
        onceEmit: true
      }
    },
    ready: function() {
      var that = this
      this.$nextTick(function() {
        that.initScroll()
      })
      this.eventsListen()
    },
    methods: {
      eventsListen: function() {
        var that = this
        Vue.events.$on('scrollRefresh', function() {
          that.refresh()
        })
        Vue.events.$on('freshData', function() {
          that.freshData()
        })
        Vue.events.$on('noFreshData', function() {
          that.noFreshData()
        })
        Vue.events.$on('moreData', function() {
          that.moreData()
        })
        Vue.events.$on('noMoreData', function() {
          that.noMoreData()
        })
      },
      freshData: function() {
        var that = this
        this.refresh()
        this.pulling = false
        this.refreshTxt = '刷新成功'
        this.downing = false
        setTimeout(function() {
          that.beforePullDown = true
          that.pullDownRefresh = false
        }, 600)
      },
      noFreshData: function() {
        var that = this
        this.pulling = false
        this.refreshTxt = '暂无更新数据'
        this.downing = false
        setTimeout(function() {
          that.beforePullDown = true
          that.pullDownRefresh = false
        }, 600)
      },
      moreData: function() {
        this.pullUpLoad = false
        this.refresh()
      },
      noMoreData: function() {
        this.isPullUpLoad = false
        this.refresh()
      },
      initScroll: function() {
        var that = this
        if (!that.$els.wrapper) {
          return
        }
        var options = {
          probeType: 3,
          // scrollX: true,
          pullUpLoad: true,
          deceleration: 0.002,
          click: true
        }
        that.scroll = new Bscroll(that.$els.wrapper, options)
        that.scroll.on('scroll', function(pos) {
          // that.pullUpLoad = true
          that.pullDownRefresh = true
          that.$emit('scroll', pos)
          if(pos.y<0) {
            that.pullDownRefresh = false
          }
          if (that.beforePullDown) {
            that.bubbleY = Math.max(0, pos.y + that.pullDownInitTop)
            that.pullDownStyle = 'top:' + Math.min(pos.y + that.pullDownInitTop, 10) + 'px'
          } else {
            that.bubbleY = 0
          }
        })
        that.scroll.on('scrollEnd', function () {
          if (that.scroll.y <= (that.scroll.maxScrollY + 50)) {
            if(that.onceEmit) {
              that.onceEmit = false
              that.pullUpLoad = true
              that.isPullUpLoad = true
              that.refresh()
              that.$emit('pullingup')
              setTimeout(function() {
                that.onceEmit = true
              },2000)
            }

          }
        })
        that.scroll.on('touchEnd', function(pos) {
          if (pos.y > 50) {
            that.beforePullDown = false
            that.downing = true
            that.pulling = true
            that.$emit('pullingdown')
          }
        })
      },
      refresh: function() {
        this.scroll && this.scroll.refresh()
      }
    },
    components: {
      Loading: scrollLoading,
      Bubble: scrollBubble
    }

  });
  return scrollComponent.module;
});
