/**
 * activity-code
 * 活动签到二维码页面
 * Created by 137376 on 2017/2/20.
 */
define(["vue", "common/config", "common/api", "common/qrcode", "text!tplPath/activity-code.html"], function (Vue, config, api, qrcode, tpl) {
  var codeModule = {};
  codeModule.init = function ($el, url) {
    var that = this;
    var qrcode = new QRCode($el, {
      width: 360,
      height: 360
    });
    qrcode.makeCode(url);
  };
  codeModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        id: null,
        url: null,
        el: null,
        title: null
      }
    },
    ready: function () {
      var self = this;
      self.el = document.getElementById("code-img");
      codeModule.init(self.el, self.url);

      setTimeout(function () {
        var $img = self.el.getElementsByTagName("img")[0];
        var opacityImg = document.getElementById("img-opacity");
        opacityImg.src = $img.src;
      }, 500);
    },
    route: {
      activate: function (transition) {
        var that = this;
        var param = JSON.parse(that.$route.query.param);
        that.id = param.id;
        that.url = param.url;
        that.title = param.title;
        that.username = param.username;
        that.subtitle = param.subtitle;
        that.fromscholl = param.fromscholl;
        return transition.next();
      }
    },
    methods: {
      //返回详情
      goInfo: function () {
        history.back();
      }
    },
    events: {}
  });
  return codeModule.module;
});
