/**
 *search
 *发布页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 *     --Edit by Shen Xiaowei on 2016/10/31 21:41
 */
define(["vue", "jq", "mobiscroller", "common/config", "common/api", "core", "text!tplPath/add-active.html"], function (Vue, $, mobiscroller, config, api, core, tpl) {
  var addActiveModule = {};
  addActiveModule.canBack = false;
  addActiveModule.isDigit = function (patrn, param) {
    if (!patrn || !param) {
      return false;
    }
    return patrn.test(param);
  };
  addActiveModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        baseParam: {
          title: null,
          activeType: null,
          start_time: null,
          end_time: null,
          locate: null,
          max: null,
          apply_end_time: null,
          price: null,
          checkin_start_time: null,
          checkin_end_time: null,
          latitude: null,
          longtitude: null,
          img: {
            img: ""
          } || this.img,
          u_no: null,
          c_fid: null,
          uid: null,
          description: null,
          custom_field: [
            {key: "姓名", value: "姓名", id: '1'},
            {key: "手机号", value: "手机号", id: '2'}
          ],
          images: [],
          mark: 1,
          allow_apply: 0,
          checktype: 0,
          need_checkin: 0,
          publicity: 0,
          tel: null,
          isgroup: 0

        },
        start_time: null,
        end_time: null,
        apply_end_time: null,
        checkin_start_time: null,
        checkin_end_time: null,
        userLogin: this.userLogin || {},
        defaultLogo: ["images/img/exercise.png", "images/img/exhibition.png", "images/img/outdoors.png", "images/img/interest.png", "images/img/show-pic.png", "images/img/meeting.png", "images/img/recreation.png", "images/img/chair.png"],
        activeTypeArr: ["娱乐", "兴趣", "户外", "展览", "演出", "会议", "运动", "讲座沙龙"],
        activeTypeText: null,
        userName: 'sally',
        userText: 'hello',
        userPic: 'http://172.31.46.30/H5Code/branch/com.systoon.activity2.0/src/images/img/user-a.png',
        addPic: 0,
        desStyle: null,
        userTitle: null,
        subTitle: null,
        userAvatarId: null,
        poster: {},
        showDes: null,
        typeMark: config.session.mark,
        cardFlag: null,
        addressFlag: false,
        address: '',
        timer: null,
        detailAddress: null,//详细地址
        ins: null, // 当前组件实例, ready时创建, focus时激活, 离开时的禁用, 都得依赖此实例
        from: null,
        isShowexpert: false,//是否显示高级设置的内容
        curMob: null
      }
    },
    ready: function () {
      this.$emit("init");
      this.$emit("addActiveBtnStyle");


      window.addEventListener('resize', function () {
      if (document.activeElement.tagName == 'INPUT' || document.activeElement.tagName == 'TEXTAREA') {
        window.setTimeout(function () {
          document.activeElement.scrollIntoViewIfNeeded();
          var contentEle = document.getElementById('add-ac-content')
          var targetHeight = contentEle.scrollTop
          contentEle.scrollTop = targetHeight + 150
        }, 0);
      }
    })
    },
    route: {
      activate: function (transition) {
        var that = this;
        //console.log("pipeline list vue.route.activate");
        that.baseParam.u_no = config.session.u_no;
        that.baseParam.uid = config.session.user_id;
        that.baseParam.c_fid = config.session.feed_id;
        that.baseParam.isgroup = 0;
        that.userTitle = config.session.title;
        that.subTitle = config.session.subtitle;
        that.userAvatarId = config.session.avatarId;
        that.cardFlag = config.cardFlag(that.baseParam.c_fid);
        that.from = that.$route.query.from ? that.$route.query.from : null;
        if (config.session.mark) {
          that.baseParam.fid = config.session.g_feed_id;
          that.baseParam.isgroup = 1;
          that.subTitle = config.session.g_subtitle;
        }

        transition.next();
      },

      deactivate: function (transition) {
        var that = this;
        $('#active-start-time').mobiscroll('cancel');
        $('#active-end-time').mobiscroll('cancel');
        $('#apply-end-time').mobiscroll('cancel');
        $('#sign-start-time').mobiscroll('cancel');
        $('#sign-end-time').mobiscroll('cancel');
        $('#active-type').mobiscroll('cancel');
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      //发布活动
      submitActive: function () {
        var that = this;
        if (that.baseParam.allow_apply == '0') {
          if (!that.subActiveClose()) {
            return;
          }
        } else if (that.baseParam.allow_apply == '1') {
          if (!that.subActiveClose() || !that.subActiveShow()) {
            return;
          }
        }
        that.$emit('subActive');
      },

      subActiveShow: function () {
        var that = this;
        that.baseParam.description = that.baseParam.description ? that.baseParam.description : "";
        if (!that.apply_end_time) {
          alert('请输入报名截止时间');
          return false;
        } else if (that.apply_end_time > that.start_time) {
          alert('报名截止时间不晚于活动开始时间');
          return false;
        } else if ((that.baseParam.price * 1 > 0 && !addActiveModule.isDigit(/^[0-9]+(.[0-9]{1,3})?$/, that.baseParam.price)) || that.baseParam.price * 1 < 0) {
          alert('请输入有效金额');
          return false;
        } else if (that.baseParam.price * 1 > 9999) {
          alert('人均费用不高于9999');
          return false;
        } else if (that.baseParam.max > 100000) {
          alert('报名人数不超过100000');
          return false;
        } else if (that.baseParam.need_checkin == 1) {
          if (!that.checkin_start_time) {
            alert('请选择签到开始时间');
            return false;
          } else if (that.checkin_start_time > that.start_time) {
            alert('签到开始时间不晚于活动开始时间');
            return false;
          } else if (!that.checkin_end_time) {
            alert('请选择签到结束时间');
            return false;
          } else if (that.checkin_end_time <= that.checkin_start_time) {
            alert('签到结束时间不早于签到开始时间');
            return false;
          }
        }
        return true;
      },
      subActiveClose: function () {
        var that = this;
        that.baseParam.description = that.baseParam.description ? that.baseParam.description : "";
        if (!that.baseParam.title) {
          alert('请输入活动标题');
          return false;
        } else if (!that.baseParam.activeTypeText) {
          alert('请选择活动类型');
          return false;
        } else if (!that.start_time) {
          alert('请选择活动开始时间');
          return false;
        } else if (!that.end_time) {
          alert('请选择活动结束时间');
          return false;
        } else if (that.start_time >= that.end_time) {
          alert('活动结束时间不早于活动开始时间');
          return false;
        } else if (!that.address) {
          alert('请选择活动地点');
          return false;
        } else if (that.baseParam.tel) {
          if (!that.baseParam.tel.match(/^(\(\d{3,4}\)|\d{3,4}(-|\s))?\d{5,14}$/) && !that.baseParam.tel.match(/^1[3|4|5|7|8]\d{9}$/)) {
            alert("请输入正确的电话号码");
            return false;
          }
        }
        return true;
        //return false;
      },
      //选择名片
      selectCard: function () {
        if (this.typeMark) {
          return;
        }
        var that = this;

        function callbackfun(e) {
          if (e.result == "cancel") {
            return false;
          }
          that.baseParam.uid = e.userId;
          that.baseParam.c_fid = e.feedId;
          that.baseParam.u_no = "";
          that.userTitle = e.title;
          that.subTitle = e.subtitle;
          that.userAvatarId = e.avatarId;
          that.cardFlag = config.cardFlag(that.baseParam.c_fid);
          api.userSys({feed_id: that.baseParam.c_fid}).then(function (data) {
          }).catch(function (data) {
            console.log(data);
          });
        }

        toonCall({
          "type": "0"
        }, "card/chooseCard", callbackfun);
      },
      //选择活动类型
      selectType: function (el) {
        var $el = $(el);
        self.curMob = $el;
        var lineHeight = 40 //行高
        var rh = lineHeight / 37.5 * window.lib.flexible.rem // 根据flexible换算后的行高

        $el.mobiscroll().scroller({
          theme: 'ios',
          display: 'bottom',
          mode: 'scroller', //日期选择模式
          lang: 'zh',
          height: rh,
          width: window.innerWidth,
          fixedWidth: [80 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem, 83 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem],
          wheels: [
            [{
              values: ["娱乐", "兴趣", "户外", "会议", "运动", "讲座沙龙", "展览", "演出"]
            }]
          ],
          onClosed: function (valueText, inst) {
            $el.mobiscroll('destroy');
            $("#mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
          },
          onBeforeShow: function () {
            $("#mob-master").addClass("mob-master-show").removeClass("mob-master-hid");
          },
          onCancel: function () {
            $("#mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
          }
        });
      },
      //添加活动海报
      addPicFn: function () {
        var that = this;
        uploadImages({
          "type": 0,
          "xLength": 375,
          "yLength": 178,
          "functionType": 2,
          "maxCount": 1,
          "ratio": 0.8
        }, callbackfun);

        function callbackfun(e) {
          if (e != "cancel" && e) {
            that.addPic = 1;
            that.baseParam.img.url = e[0];
          }
        }
      },

      //新添加活动海报
      //TODO: 相册
      addPicFnNew: function () {
        var thisModule = this;
        var option = {
          "type": 0,
          "aspectX": 2,
          "aspectY": 1,
          "functionType": 2,
          "maxCount": 1,
          "ratio": 0.8
        };
        toongine.media.chooseImage({
          params: {
            count: 1
          },
          callback: function (res) {
            uploadImgStateful(option, res, function (e) {
              if (e.code === "10") {
                console.log("获取图片数据失败");
                alert("上传图片失败,请检查网络");
              } else if (e.code === "11") {
                console.log("获取七牛token失败");
                thisModule.poster = {};
                alert("上传图片失败,请重新上传", 2000);
              } else if (e.code === "12") {
                console.log("上传图片失败，ID-->" + e.data);
                thisModule.poster = {};
              } else if (e.code === "20") {
                console.log("用户取消上传");
              } else if (e.code === "22") {
                for (var j = 0; j < e.data.length; j++) {
                  var temp = e.data[j];
                  temp.url = "";
                  temp.loading = true;
                  temp.fail = false;
                  thisModule.poster = temp;
                }

              } else if (e.code === "23") {
                //url返回
                if (thisModule.poster.id === e.data.id) {
                  thisModule.poster.url = e.data.url;
                  thisModule.poster.loading = false;
                }
              }
            });
          }
        })
      },
      placeFn: function (param) {
        var that = this;
        if (param) {
          that.addressFlag = false;
          that.baseParam.latitude = "";
          that.baseParam.longtitude = "";
        }
      },


      //选择地址
      // TODO: 选择地址
      selectPlace: function () {
        var that = this;
        toongine.location.chooseLocation({
          callback: function (res) {
            var result = res.data;
            if (result) {
              that.addressFlag = true;
              that.baseParam.latitude = result.latitude;
              that.baseParam.longtitude = result.longitude;
              that.baseParam.locate = result.address;
              that.baseParam.city = result.city

              that.address = result.address
            }

          }
        })
      },

      //允许报名开关
      controlApplyFn: function (param) {
        var that = this;
        if (param == '0') {
          that.baseParam.allow_apply = 1;
          setTimeout(function () {
            // show.scrollIntoView(false)
            document.getElementById('control-apply').scrollIntoView(true)
            // var show = document.getElementById('add-ac-content');
            // show.scrollTop = 1400
          }, 500);
        } else {
          that.baseParam.allow_apply = 0;
        }
        // that.$emit('setDefaultApplyTime');
      },
      //是否签到
      controlSignFn: function (param) {
        var that = this;
        if (param == '0') {
          that.baseParam.need_checkin = 1;
        } else {
          that.baseParam.need_checkin = 0;
        }
      },
      //是否公开
      controlShowFn: function (param) {
        var that = this;
        if (param == '0') {
          that.baseParam.publicity = 1;
        } else {
          that.baseParam.publicity = 0;
        }
      },
      //是否审核
      controlManageFn: function (param) {
        var that = this;
        if (param == '0') {
          that.baseParam.checktype = 1;
        } else {
          that.baseParam.checktype = 0;
        }
      },
      initIns: function () {
        try {
          this.selectDatetime();
        } catch (e) {
        }
      },
      //选择时间
      selectDatetime: function (el) {
        $("input").blur();
        var _self = this;
        var $el = $(el);
        _self.curMob = $el;
        var $mob_master = document.getElementById("mob-master");
        var Date_time = function (obj, options) {
          var that = this,
            h = 34, //行高
            rh = h / 37.5 * window.lib.flexible.rem, // 根据flexible换算后的行高
            i,
            len;
          that.options = {
            preset: 'date', //日期
            dateFormat: 'yy.mm.dd(DD)', // 日期格式
            dateOrder: 'yymmddDD', //面板中日期排列格式
            theme: 'ios', //皮肤样式
            mode: 'scroller', //日期选择模式
            lang: 'zh',
            display: 'bottom', //显示方式
            minDate: new Date(),
            circular: true,
            endYear: 2036,
            fixedWidth: [80 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem, 83 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem],
            height: rh,
            calendarHeight: 600,
            onClosed: function (valueText) {
              $el.mobiscroll('destroy');
              $("#mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
            },
            onBeforeShow: function () {
              $("#mob-master").addClass("mob-master-show").removeClass("mob-master-hid");
            },
            onCancel: function () {
              $("#mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
            }
          };
          if (options) {
            len = options.length;
            for (i = 0; i < len; i++) {
              that.options = options[i];
            }
          }
          try {
            obj.mobiscroll().datetime(that.options);
          } catch (e) {
          }
        };
        Date_time($el);
      },
      //去活动描述
      activeIntro: function () {
        var parentPath = location.hash.match(new RegExp(/\/[\w|\-]{1,}\//));
        parentPath = parentPath ? parentPath[0] : "/";
        this.$router.go({
          path: parentPath + "add-active/describe",
          query: {description: this.baseParam.description, images: JSON.stringify(this.baseParam.images)}
        });
      },
      //添加自定义信息
      addApplyInfo: function () {
        console.log("传值", JSON.stringify(this.baseParam.custom_field));
        var parentPath = location.hash.match(new RegExp(/\/[\w|\-]{1,}\//));
        parentPath = parentPath ? parentPath[0] : "/";
        this.$router.go({
          path: parentPath + "add-active/add-apply-info",
          query: {custom_field: JSON.stringify(this.baseParam.custom_field)}
        });
      },
      onTitleFocus: function () {
        var inputTextBox = document.getElementById('input-title');
        setInterval(function () {
          inputTextBox.scrollIntoView(true);
        }, 200)
      },
      //限制活动标题字数
      titleLength: function (text, e) {
        var that = this;
        if (text && text.length >= 30) {
          that.baseParam.title = e.target.value.substr(0, 30);
        }
      },
      moduleFocus: function(e) {
        var contentEle = document.getElementById('add-ac-content')
        var targetHeight = e.clientY + contentEle.scrollTop
        var contentEle = document.getElementById('add-ac-content')
        var targetHeight = contentEle.scrollTop
        contentEle.scrollTop = targetHeight + 100



      },
      //限制地址标题字数
      addressLength: function (text, e) {
        var that = this;
        if (text && text.length >= 20) {
          that.detailAddress = e.target.value.substr(0, 20);
        }
      },
      //是否显示高级设置
      showExpert: function () {
        var that = this;
        if (that.isShowexpert) {//显示高级设置
          that.isShowexpert = false;
        } else {
          that.isShowexpert = true;
          setTimeout(function () {
            document.getElementById('control-apply').scrollIntoView(true);
          }, 300);
//                        that.baseParam.allow_apply = 0;
        }
      }
    },
    events: {
      addActiveBtnStyle: function () {
        var $submitBtn = document.getElementById("add-active-btn-box");
        var pageH = window.screen.height;
        var top_rem = (pageH - 55 - 44) / 37.5;
//                $submitBtn.style.top = top_rem+"rem";
      },
      init: function () {
        var _self = this;

        //this.$nextTick(function () {
        _self.initIns();
        //});
      },
      setDefaultApplyTime: function () {
        var _self = this;
        if (_self.baseParam.start_time && _self.baseParam.allow_apply == 1) {
          _self.baseParam.apply_end_time = _self.baseParam.start_time;
        }
      },
      setDescription: function (descrition, images) {
        this.showDes = descrition.replace(/\r\n/g, "").replace(/\r/g, "").replace(/\n/g, "").replace(/\s/g, " ");
        //this.showDes = descrition.replace(/\r\n/g, "").replace(/\r/g, "").replace(/\n/g, "").replace(/\s/g, " ").substr(0,15);
        console.log("活动描述", descrition, this.showDes);
        //alert(this.showDes);
        this.baseParam.description = descrition;
        this.baseParam.images = images;
        if (this.showDes && this.showDes != "请输入活动介绍，必填") {
          this.desStyle = 1;
        }
      },
      setCusInfo: function (arr) {
        var that = this;
        var i;
        var len = arr.length;
        var emptyArr = [];
        for (i = 0; i < len; i++) {
          if (arr[i].value == arr[i].key) {
            console.log("赋值", JSON.stringify(arr[i]));
            emptyArr.push(arr[i]);
          }
        }
        that.baseParam.custom_field = emptyArr;
        console.log("赋值23", JSON.stringify(that.baseParam.custom_field));
      },
      subActive: function () {
        var that = this;
        that.baseParam.img = {
          url: that.poster.url,
          size: that.poster.size,
          width: that.poster.width,
          height: that.poster.height,
          imageType: that.poster.imageType
        };
        if (!that.baseParam.img.url) {
          var ind = that.activeTypeArr.indexOf(that.baseParam.activeTypeText);
          that.baseParam.img.url = config.defaultPoster[ind].url;
          console.log("默认海报", that.baseParam.img.url);
        }
        that.baseParam.price = !that.baseParam.price ? 0 : that.baseParam.price;
        that.baseParam.type = that.activeTypeArr.indexOf(that.baseParam.activeTypeText);
        that.baseParam.start_time = that.start_time ? config.dateTomiao(that.start_time) : null;
        that.baseParam.end_time = that.end_time ? config.dateTomiao(that.end_time) : null;
        that.baseParam.apply_end_time = that.apply_end_time ? config.dateTomiao(that.apply_end_time) : null;
        that.baseParam.checkin_start_time = that.checkin_start_time ? config.dateTomiao(that.checkin_start_time) : null;
        that.baseParam.checkin_end_time = that.checkin_end_time ? config.dateTomiao(that.checkin_end_time) : null;
        that.baseParam.address = that.detailAddress ? that.detailAddress : null;

        if (!config.isAllowSubmit) {
          return false;
        }
        api.addActive(that.baseParam).then(function (data) {
          info = data;
          alert("您发布的活动我们将在1个工作日内完成审核，请留意通知");
          that.$router.replace({name: "no-active-info", query: {"id": info}});
        }).catch(function (data) {
          that.baseParam.img.url = null;
          info = data;
          if (info.code && info.code != '0') {
            alert(info.msg);
          }
        });
      }
    }
  });
  return addActiveModule.module;
});
