/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "text!tplPath/add-apply-info.html"], function (Vue, config, api, tpl) {
  var addApplyInfoModule = {};
  addApplyInfoModule.module = Vue.extend({
    template: tpl,
    ready: function () {

    },
    data: function () {
      return {
        selectFlag: {
          "companyState": 0,
          "stationState": 0,
          "familyState": 0,
          "placeState": 0,
          "strongState": 0,
          "likeState": 0
        },
        info: null,
        showAlert: false,
        cus_info: this.cus_info || [],
        cus_info_top: this.cus_info_top || [],
        custom_field: this.custom_field || null,
        c_custom_field: this.c_custom_field || null,
        selectInfo: null
      }
    },
    route: {
      activate: function (transition) {
        var that = this;
        that.custom_field = JSON.parse(that.$route.query.custom_field);
        that.c_custom_field = JSON.parse(that.$route.query.custom_field);
        console.log(that.$route.query.custom_field);
        that.$emit("initApplyInfo");
        transition.next();
        //console.log("pipeline list vue.route.activate");
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      applyedInfo: function () {
        var that = this;
        var infoArrs = [];
        infoArrs = that.cus_info.concat(that.cus_info_top);
        console.log(JSON.stringify(that.cus_info_top), '8888888');
        this.$dispatch("setCusInfo", infoArrs);
        history.back();
      },
      addApply: function (ind) {
        var that = this;
        if (that.cus_info[ind].value == "姓名" || that.cus_info[ind].value == "手机号") {
          return false;
        }
        that.$emit("changeAddApply", ind);
      },
      cancelFn: function () {
        this.showAlert = false;
        this.info = null;
      },
      addApplyTop: function (ind) {
        var that = this;
        that.$emit("changeAddApplyTop", ind);
      },
      userDefined: function (flag) {
        this.text = "";
        this.showAlert = flag;
      },
      exportList: function () {
        var info = this.info || document.getElementById("register-email-input").value.trim();
        if (info.replace(/\s+/g, "").length > 0) {
          this.info = null;
          this.cus_info_top.push({key: info, value: info, id: new Date().getTime()});
        } else {
          this.info = null;
        }
        this.showAlert = false;
//                this.$emit("changeAddApplyTop");
      },
      textLen: function (param) {
        var that = this;
        if (param) {
          that.info = param.substr(0, 10);
        }
      }
    },
    events: {
      changeAddApply: function (ind) {
        var that = this;
        if (!that.cus_info[ind].value) {
          that.cus_info[ind].value = that.cus_info[ind].key;
        } else {
          that.cus_info[ind].value = null;
        }

      },
      changeAddApplyTop: function (ind) {
        var that = this;
        if (!that.cus_info_top[ind].value) {
          that.cus_info_top[ind].value = that.cus_info_top[ind].key;
        } else {
          that.cus_info_top[ind].value = null;
        }
      },
      initApplyInfo: function () {
        var that = this;
        var i;
        var j;
        var k;
        var param = that.custom_field;
        var len = param.length;
        var cusInfoLen;
        var cusInfoTopLen;
        that.cus_info = [
          {key: "姓名", value: "姓名", id: '1'},
          {key: "手机号", value: "手机号", id: '2'},
          {key: "单位", value: null, id: '3'},
          {key: "职位", value: null, id: '4'}
        ];
        that.cus_info_top = [
          {key: "邮箱", value: null, id: '11'},
          {key: "身份证", value: null, id: '5'},
          {key: "自我介绍", value: null, id: '6'},
          {key: "地址", value: null, id: '7'},
          {key: "特长", value: null, id: '8'},
          {key: "爱好", value: null, id: '9'},
          {key: "性别", value: null, id: '12'}
        ];
        cusInfoLen = that.cus_info.length;
        cusInfoTopLen = that.cus_info_top.length;
        for (i = 0; i < len; i++) {
          for (j = 0; j < cusInfoLen; j++) {
            if (param[i].id == that.cus_info[j].id && that.c_custom_field[i].value) {
              that.cus_info[j] = param[i];
              that.c_custom_field[i].value = null;
            }
          }
          for (k = 0; k < cusInfoTopLen; k++) {
            if (param[i].id == that.cus_info_top[k].id && that.c_custom_field[i].value) {
              that.cus_info_top[k] = param[i];
              that.c_custom_field[i].value = null;
            }
          }
        }
//                console.log(JSON.stringify(that.cus_info_top),"$$$$$",JSON.stringify(that.cus_info));
        for (i = 0; i < that.c_custom_field.length; i++) {
          if (that.c_custom_field[i].id <= 4 && that.c_custom_field[i].value) {
            that.cus_info.push(that.c_custom_field[i]);
          } else if (that.c_custom_field[i].id > 4 && that.c_custom_field[i].value) {
            that.cus_info_top.push(that.c_custom_field[i]);
          }
        }

//                console.log(JSON.stringify(that.cus_info_top),"$$$222",JSON.stringify(that.cus_info));
      }
    }
  });
  return addApplyInfoModule.module;
});