/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "core", "text!tplPath/apply.html"], function (Vue, config, api, core, tpl) {
  var module = Vue.extend({
    template: tpl,
    ready: function () {

    },
    data: function () {
      return {
        param: {
          ac_id: this.id || null,
          feed_id: this.feed_id || null,
          cus_info: []
        },
        userName: this.userName || null,
        avatarId: this.avatarId || null,
        userText: this.userText || null,
        subValue: this.subValue || [],
        feed_id: this.feed_id || null,
        checkType: null,
        curSelect: null
      }
    },
    route: {
      activate: function (transition) {
        //console.log("pipeline list vue.route.activate");
        var that = this;
        that.param.ac_id = that.$route.query.id;
        that.checkType = that.$route.query.checkType;
//                that.param.cus_info = JSON.parse(that.$route.query.custom_field);
        that.getCusInfo = JSON.parse(that.$route.query.custom_field) ? JSON.parse(that.$route.query.custom_field) : [];
        that.feed_id = config.session.feed_id;
        that.avatarId = config.session.avatarId;
        that.userName = config.session.title;
        that.userText = config.session.subTitle;
        that.$emit('getApplyInfo');
        transition.next();
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      nameLen: function (ind) {
        var that = this;
        var len = that.param.cus_info[ind].value.length;
        if (len > 11) {
          that.param.cus_info[ind].value = that.param.cus_info[ind].value.substr(0, 11);
        }
      },
      selectCard: function () {
        var that = this;

        function callbackfun(e) {
          if (e.result == "cancel") {
            return false;
          }
          that.feed_id = e.feedId;
          that.userName = e.title;
          that.userText = e.subTitle;
          that.avatarId = e.avatarId;
          api.userSys({feed_id: that.feed_id}).then(function (data) {
            console.log("ok");
          }).catch(function (data) {
            console.log(data);
          });
        }

        toonCall({
          "type": "0"
        }, "card/chooseCard", callbackfun);
      },
      goSearch: function () {
        this.$router.go({name: "search"})
      },
      selectSex: function (ind, index) {
        var that = this;
        that.curSelect = ind;
        that.param.cus_info[index].value = ind == 0 ? "男" : "女";
      },
      submitApply: function () {
        var that = this;
        var result;
        var i;
        var len = that.param.cus_info.length;
        that.param.feed_id = that.feed_id;
        for (i = 0; i < len; i++) {//限制条件
          switch (that.param.cus_info.id) {
            case '1'://姓名
              break;
            case '2'://手机号
              break;
            case '3'://单位
              break;
            case '4'://职位
              break;
            case '身份证'://职位
              break;
            case '6'://自我介绍
              break;
            case '7'://地址
              break;
            case '8'://学校
              break;
            case '9'://专业
              break;
            case '10'://年龄
              break;
          }

        }
        api.submitApply(that.param).then(function (data) {
          result = data;
          //that.$router.go({name:"active-info",query:{id:that.param.ac_id}});
          if (that.checkType != 0) {//审核
            alert("报名信息已提交，请耐心等待审核");
          } else {
            alert("报名成功");
          }
          that.$dispatch("refreshIndex");
          if (location.hash.indexOf("no-active-info") >= 0) {
            //refreshDetail
            that.$dispatch("refreshNOIDDetail");
            that.$router.go({name: "no-active-info", query: {id: that.param.ac_id}});
          } else if (location.hash.indexOf("signUp-CheckIn") >= 0) {
            that.$dispatch("refreshNOIDDetail");
            that.$router.go({name: "signUp-CheckIn", query: {ac_id: that.param.ac_id, title: ""}});
          } else {
            history.back();
          }

        }).catch(function (data) {
          result = data;
          if (result.code && result.code != '0') {
            alert(result.msg);
//                            that.$router.go({name:"error",query:{"text":result.msg}});
//                            that.$router.go({name:"error"});
          }
        });
      }
    },
    events: {
      getApplyInfo: function () {
        var that = this;
        var i;
        var len;
        that.subValue = that.param.cus_info;
        for (i = 0; i < that.getCusInfo.length; i++) {
          if (that.getCusInfo[i].value) {
            console.log('自定义', JSON.stringify(that.getCusInfo[i]));
            that.getCusInfo[i].value = null;
            that.param.cus_info.push(that.getCusInfo[i]);
          }
        }
      }
    }
  });
  return module;
});