/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "text!tplPath/approval-list.html"], function (Vue, config, api, tpl) {
  var approvalModule = {};

  approvalModule.offset = 0;
  approvalModule.limit = 10;
  approvalModule.loadingFlag = false;
  approvalModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        id: 0,
        showApprovalTap: 0,
        statistics: {},
        listData: [],
        nullHeight: "0",
        typeOfList: ["待审核", "已通过", "未通过"],
        noData: false,
        isShowText: false,
        isMoreDate: true,
        loadingMore: false,
        initFlag: true
      }
    },
    route: {
      activate: function (transition) {
        this.initFlag = true;
        this.id = config.returnTag.a || this.$route.query.id;
        transition.next();
        approvalModule.offset = 0;
        this.$emit("getApplyStatistics");
        this.$emit("getList");
        //this.nullHeight = (document.body.clientHeight - document.getElementById("approval-page-header").offsetHeight)+"px";
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    ready: function () {

    },
    methods: {
      changeTap: function (index) {
        //重复点击相同tap不响应
        this.initFlag = false;
        if (this.showApprovalTap === index) {
          return;
        }
        this.listData = [];
        this.noData = false;
        this.showApprovalTap = index;
        approvalModule.offset = 0;
        this.$emit("getApplyStatistics");
        this.$emit("getList");
      },
      doApply: function (index, action) {
        var thisModule = this;
        var obj = this.listData[index];
        var param = {
          apply_id: obj.id,
          ac_id: this.id,
          verify_status: action
        };
        var opt = {
          loading: true
        };
        return api.doApply(param, opt).then(function (data) {
          alert("审核成功");
          approvalModule.offset = 0;
          thisModule.$emit("getApplyStatistics");
          thisModule.$emit("getList");
          thisModule.$dispatch("refreshDetailNum");
        }).catch(function (err) {
          if (err && err.code == "1") {
            alert("审核通过人数已达报名人数上限");
          } else {
            alert("请求失败");
          }
        });
      },
      skipCard: function (param) {
        config.skipCard(param);
      },
      //列表滚动
      onScroll: function (e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        this.initFlag = false;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          if (this.isMoreDate && !approvalModule.loadingFlag) {
            this.$emit("getList");
          }

        }
        //超出一屏显示 "底线"
        var winHeight = document.body.clientHeight;
        if (scrollTop > winHeight) {
          this.isShowText = true;
        } else {
          this.isShowText = false;
        }
      }
    },
    events: {
      //获取人数统计
      getApplyStatistics: function () {
        var thisModule = this;
        var param = {
          ac_id: this.id
        };
        var opt = {
          loading: false
        };
        return api.getApplyStatistics(param, opt).then(function (data) {
          thisModule.statistics = data;
        }).catch(function (err) {
          alert("请求失败");
        });
      },
      //获取列表
      getList: function () {
        var thisModule = this;
        thisModule.loadingMore = true;
        approvalModule.loadingFlag = true;
        var param = {
          ac_id: this.id,
          type: this.showApprovalTap,
          offset: approvalModule.offset,
          limit: approvalModule.limit,
          user_id: this.user_id
        };
        var opt = {
          loading: thisModule.initFlag
        };
        return api.getApprovalList(param, opt).then(function (data) {
          data = data || [];
          thisModule.listData = data;
          if (data.length < approvalModule.limit) {
            thisModule.isMoreDate = false;
          } else {
            thisModule.isMoreDate = true;
          }

          if (thisModule.listData.length === 0) {
            thisModule.noData = true;
          }
          thisModule.$nextTick(function () {
            thisModule.loadingMore = false;
            approvalModule.loadingFlag = false;
            if (thisModule.listData.length)approvalModule.offset = thisModule.listData[thisModule.listData.length - 1].id;
          });
        }).catch(function (err) {
          alert(err.message);
        });
      }
    }
  });
  return approvalModule.module;
});