define([
  'vue',
  'text!tplPath/bbs-create.html',
  'common/config',
  'common/api'
  // ,'common/v-comments-create'
], function (Vue, tpl, config, api) {

  return Vue.extend({
    template: tpl,
    route: {
      activate: function (transition) {
        this.toUserId = this.$route.query.touid || 0;
        this.len = 0;
        if (this.toUserId) {
          document.title = "回复评论";
          config.pageTitle = "回复评论";
          try {
            setTitle("回复评论");
          } catch (e) {
          }
        }
        transition.next();
      },
      data: function (transition) {
        transition.next();
      },
      deactivate: function (transition) { // hide all plugins on this page...
        console.log('bbs-create deactivate');
        return transition.next();
      }
    },
    data: function () {
      var _self = this;
      return {
        comments_retry_num: 0,   // 微服务重试次数（目前仅限于token类错误）
        comments_retry_max: 3,   // 微服务最大重试次数

        ac_id: _self.$route.query.id || 0,
        toId: _self.$route.query.toid || 0,
        toUserId: _self.$route.query.touid || 0,

        contentMax: config.COMMENT_MAX, // 最大评论字数
        content: null, // 评论内容
        len: null,
        infoId: ''
      }
    },
    ready: function () {
      setTimeout(function () {
        document.getElementById("comments-create-txt").focus();
      })
    },
    events: {},
    methods: {
      bbsCreate: function (e) {
        var content = e.target.value;
        var len = content.length;
        this.$set('content', e.target.value);
        this.$set('len', e.target.value.length);
        if (this.len > 500) {
          this.$set('content', e.target.value);
          this.$set('len', e.target.value.length);
          e.target.value = content.substr(0, 500);
          content = e.target.value;
        } else {
          this.$set('content', e.target.value);
          this.$set('len', e.target.value.length);
        }
      },
      addComment: function () {
          var _self = this,
          url = config.COMMENT_UTL + '/v1/comment',
          params = {"appId": config.COMMENT_APPID, "token": config.COMMENT_TOKEN},
          i, ilen, j, jlen;
        this.content = document.getElementById("comments-create-txt").value;
        if (!this.content) {
          alert("无效评论字数。。。");
          console.log("无效评论字数。。。");
          return;
        }
        if (this.content.length > config.COMMENT_MAX) {
          alert("评论字数最大不能超过：" + config.COMMENT_MAX);
          console.log("评论字数最大不能超过：" + config.COMMENT_MAX);
          return;
        }
        var param = {
          ac_id: _self.ac_id,
          userId: config.session.user_id,
          content: _self.content,
          toUserId: _self.toUserId != config.session.user_id ? _self.toUserId : '', // 被回复评论人用户ID
          toId: _self.toId // 被恢复评论的ID
        };
        return api.creatComment(param).then(function (data) {
          result = data;
          _self.$dispatch("refreshCommentList");
          history.back()
        }).catch(function (data) {
          result = data;
          if (result.code && result.code != '0') {
            alert(result.msg);
          }
        });
      }
    }
  });
});
