define(["vue", "common/config", "common/api", "core", "text!tplPath/city-list.html", "pinyin"], function (Vue, config, api, core, tpl, pinyin) {
  var module = Vue.extend({
    template: tpl,
    ready: function () {

    },
    created: function () {
      this.$emit('getCityList')
    },
    data: function () {
      return {
        cityList: [],
        cityShowList: [],  //城市名数组
        showCity: [],  //展示出来的城市列表数组
        letter: [],
        city_name: '',
        historyCity: JSON.parse(window.localStorage.historyCity || "[]"),
        isClicked: false,
        isVisited: true,
        _city_name: '',
        city_id: '',
        citySearch: '',
        showCityTemp: [],
        unfound: false
      }
    },
    route: {
      deactivate: function (transition) {
        document.getElementById("search-city").blur();
        return transition.next();
      }
    },
    methods: {
      buildLetter: function () {
        var letter = []
        for (var i = 0; i < 26; i++) {
          var obj = {}
          obj.letter = String.fromCharCode((65 + i))
          obj.city = []
          letter.push(obj)
        }
        this.letter = letter
      },
      getFirstLetter: function (str) {
        return pinyin.convertToPinyin(str).charAt(0).toUpperCase()
      },
      buildCity: function () {
        var _this = this
        this.buildLetter()
        for (var i = 0; i < this.cityShowList.length; i++) {
          var _index = Number(this.getFirstLetter(this.cityShowList[i]).charCodeAt() - 65)
          if (_index >= 0 && _index < 26) {
            this.letter[_index].city.push({
              cityName: this.cityShowList[i],
              id: this.cityList[i].id,
              city_split: this.cityShowList[i].split(""),
              city_pinyin: pinyin.convertToPinyin(this.cityShowList[i]).toLowerCase()
            })
          }
        }
        // 如果letter中citylist中没有值的话，过滤这一项
        this.showCity = this.letter.filter(function (value) {
          var len = value.city.length
          return len > 0
        })
        this.showCity.forEach(function (item) {
          _this.showCityTemp.push(item)
        })
      },
      naver: function (id) { // 点击右边字母滚动
        alert(id)
        var obj = document.getElementById("down")
        var topHeight = document.getElementById(id)
        var oPos = topHeight.offsetTop - 334
        obj.scrollTop = oPos
      },
      cityFilter: function (city) {
        this.buildCity()
        var a = []
        for (var i in this.showCity) {
          a.push(this.showCity[i])
        }
        this.showCity = a.filter(function (value) {
          var showCityList = value.city
          var showCityListTemp = showCityList.filter(function (val) {
            return (val.city_pinyin.indexOf(city) > -1 || val.cityName.indexOf(city) > -1)
            return (val.cityName.indexOf(city) > -1)
          })
          value.city = showCityListTemp
          return value.city.length > 0
        })
        if (this.showCity.length === 0) {
          this.unfound = true
        }
        else if (this.citySearch == '') {
          this.unfound = false
        }
        if (this.citySearch !== '') {
          this.$nextTick(function () {
            this.highlight()
          })
        }
      },
      search: function () {
        return this.isClicked = true
      },
      buildHistoryCity: function () {
        for (var i = 0; i < this.historyCity.length; i++) {
          if (this._city_name == this.historyCity[i].cname) {
            this.historyCity.splice(i, 1)
          }
        }
        this.historyCity.unshift({cname: this._city_name, cid: this.city_id})
        if (this.historyCity.length > 3) {
          this.historyCity = this.historyCity.slice(0, 3)
        }
        localStorage.setItem("historyCity", JSON.stringify(this.historyCity))
        this.historyCity = JSON.parse(localStorage.historyCity || "[]")
      },
      goIndexList: function (index, city_index) {
        this._city_name = this.showCity[index].city[city_index].cityName
        this.city_id = this.showCity[index].city[city_index].id
        this.buildHistoryCity()
        window.sessionStorage.selectCityName = this._city_name
        window.sessionStorage.cityId = this.city_id
        window.history.back()
      },
      _goIndexList: function (index, city_index) {
        var cname = this.historyCity[index].cname
        var cid = this.historyCity[index].cid
        window.sessionStorage.selectCityName = cname
        window.sessionStorage.cityId = cid
        window.history.back()
      },
      goCurrentCity: function(val) {
        if (!val) return
        var cityNameArry = val.split('')
        var currentCity = ''
        if(cityNameArry[cityNameArry.length-1] ==='市'){
          currentCity = val.substring(0,cityNameArry.length-1)
        }else{
          currentCity = val
        }
        this.showCity.map(function(item,index){
          item.city.map(function(itm,idx){
            if(currentCity ==itm.cityName) {
              window.sessionStorage.selectCityName = currentCity
              window.sessionStorage.cityId = itm.id
              window.history.back()
            }
          })
        })
      },
      goCityList: function () {
        this.clearInput()
        return this.isClicked = false
      },
      clearInput: function () {
        return this.citySearch = ''
      },
      highlight: function () {
        for (var i = 0; i < this.showCity.length; i++) {
          for (var j = 0; j < this.showCity[i].city.length; j++) {
            var n = this.showCity[i].city[j].cityName.indexOf(this.citySearch)
            if (n == -1) {
            } else if (n > -1) {
              for (var k = 0; k < this.citySearch.length; k++) {
                var l = k + n
                document.getElementById(i + '' + j + '' + l).style.color = "#F55151"
              }
            }
          }
        }
      }
    },
    watch: {
      citySearch: function (citySearch) {
        this.cityFilter(citySearch)
      }
    },
    events: {
      getCityList: function () {
        var thisModule = this
        var param = {}
        api.getCityList(param).then(function (data) {
          data = data ? data : []
          // thisModule.cityList = data
          thisModule.cityList = data.map(function (item) {
            return {
              id: item.id,
              letter: thisModule.getFirstLetter(item.name),
              city: item.name
            }
          })
          thisModule.cityList.forEach(function (item) {
            thisModule.cityShowList.push(item.city)
          })
          thisModule.buildCity()
        })
        //获取位置
        toongine.location.getLocation({
          callback: function (res) {
            if (res.data.city) {
              thisModule.city_name = res.data.city
            }
          }
        })
      }
    }
  });
  return module;
});
