/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "text!tplPath/describe.html"], function (Vue, config, api, tpl) {
  var module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        images: [],
        description: ""
      }
    },
    ready: function () {

    },
    route: {
      activate: function (transition) {
        //console.log("pipeline list vue.route.activate");
        transition.next();
        try {
          this.images = this.$route.query.images ? JSON.parse(this.$route.query.images) : [];
          this.description = this.$route.query.description ? this.$route.query.description : "";
          document.getElementById("textarea-describe").value = this.description;
          this.images = this.images == null ? [] : this.images;
          document.getElementById('describeTextNum').innerHTML = this.description.length;
        } catch (e) {
          console.error(e);
        }

      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      //新选择图片2.0
      addPicNew: function (type) {
        if (this.images.length >= 9) {
          alert("最多只能添加9张照片", 2000);
          return;
        }
        var thisModule = this;
        var option, params;
        if (type == 1) {
          params = {
            count: 9 - this.images.length,
            sourceType: 1
          }
          // option = {
          //     "functionType": 1,
          //     "type": 1,
          //     "maxCount": 9 - this.images.length,
          //     "ratio": 0.6
          // };
        } else {
          params = {
            sourceType: 0
          }
          // option = {
          //     "functionType": 0,
          //     "type": 1,
          //     "ratio": 0.6
          // };
        }


        toongine.media.chooseImage({
          params: params,
          callback: function (res) {
            console.log(2222222)
            console.log(JSON.stringify(res))

            uploadImgStateful(option, res, function (e) {
              if (e.code === "10") {
                console.log("获取图片数据失败");
                alert("上传图片失败,请检查网络");
              } else if (e.code === "11") {
                console.log("获取七牛token失败");
                for (var o = 0; o < thisModule.images.length; o++) {
                  thisModule.images[o].fail = true;
                  thisModule.images[o].loading = false;
                }
                alert("上传图片失败,点击可重新上传", 2000);
              } else if (e.code === "12") {
                console.log("上传图片失败，ID-->" + e.data);
                for (var l = 0; l < thisModule.images.length; l++) {
                  if (thisModule.images[l].id === e.data) {
                    thisModule.images[l].fail = true;
                    thisModule.images[l].loading = false;
                  }
                }

                // alert("上传图片失败,点击可重新上传", 2000);
              } else if (e.code === "20") {
                console.log("用户取消上传");
              } else if (e.code === "22") {
                for (var j = 0; j < e.data.length; j++) {
                  var temp = e.data[j];
                  temp.url = "";
                  temp.loading = true;
                  temp.fail = false;
                  thisModule.images.push(temp);
                }

              } else if (e.code === "23") {
                console.log(23)
                //url返回
                for (var h = 0; h < thisModule.images.length; h++) {
                  if (thisModule.images[h].id === e.data.id) {
                    thisModule.images[h].url = e.data.url;
                    thisModule.images[h].loading = false;
                    break;
                  }
                }

              }

            });


          }
        })


      },
      //重新上传失败图片
      reUploadFailImg: function (index) {
        var thisModule = this;
        thisModule.images[index].fail = false;
        thisModule.images[index].loading = true;
        window.reUploadImg(thisModule.images[index], function (e) {
          if (e.code === "12") {
            console.log("上传图片失败，ID-->" + e.data);
            for (var l = 0; l < thisModule.images.length; l++) {
              if (thisModule.images[l].id === e.data) {
                thisModule.images[l].fail = true;
                thisModule.images[l].loading = false;
              }
            }
            alert("上传图片失败,点击可重新上传", 2000);
          } else if (e.code === "23") {
            //url返回
            for (var h = 0; h < thisModule.images.length; h++) {
              if (thisModule.images[h].id === e.data.id) {
                thisModule.images[h].url = e.data.url;
                thisModule.images[h].loading = false;
                break;
              }
            }
          }
        });
      },
      deleteImg: function (index) {
        this.images.splice(index, 1);
      },
      saveDescribe: function (e) {
        //处理图片
        e.stopPropagation();
        e.preventDefault();
        var arr = [], temp;
        for (var i = 0; i < this.images.length; i++) {
          if (!this.images[i].url && this.images[i].loading) {
            alert("正在上传图片");
            return;
          } else if (!this.images[i].url && this.images[i].fail) {
            alert("图片未成功上传");
            return;
          }
          temp = {
            size: this.images[i].size,
            imageType: this.images[i].imageType,
            width: this.images[i].width,
            height: this.images[i].height,
            url: this.images[i].url
          };
          arr.push(temp);
        }
        var d = document.getElementById("textarea-describe").value.replace(/^\n{1,}/, "").replace(/\n{1,}$/, "");
        document.getElementById("textarea-describe").value = d;
        //this.description = this.description.replace(/^\n{1,}/,"").replace(/\n{1,}$/,"");
        this.$dispatch("setDescription", d, arr);
        history.back();
      },
      cancel: function (e) {
        e.stopPropagation();
        history.back();
      }
    },
    events: {}
  });
  return module;
});