/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "jq", "mobiscroller", "core", "common/config", "common/api", "text!tplPath/edit-active.html"], function (Vue, $, core, mobiscroller, config, api, tpl) {
  var editActiveModule = {};
  editActiveModule.dateTomiao = function (param) {
    var time = param ? param.replace(/\(.*?\)/g, "") : null;
    if (!time) {
      return "null";
    } else {
      time = new Date(time);
      return time.getTime() / 1000;
    }
  };
  editActiveModule.isDigit = function (patrn, param) {
    if (!patrn || !param) {
      return false;
    }
    if (!patrn.test(param)) {
      return false;
    } else {
      return true;
    }
  };
  editActiveModule.module = Vue.extend({
    template: tpl,
    data: function () {
      console.log('data');
      return {
        obj: this.obj || {},
        param: this.param || {},
        id: this.id || {},
        activeTypeArr: ["娱乐", "兴趣", "户外", "展览", "演出", "会议", "运动", "讲座沙龙"],
        defaultLogo: ["images/img/exercise.png", "images/img/exhibition.png", "images/img/outdoors.png", "images/img/interest.png", "images/img/show-pic.png", "images/img/meeting.png", "images/img/recreation.png", "images/img/chair.png"],
        typeText: this.typeText || null,
        custom_field: [
          {key: "姓名", value: "姓名", id: '1'},
          {key: "手机号", value: "手机号", id: '2'}
        ],
        poster: {},
        typeMark: config.session.mark,
        addressFlag: false,
        desStyle: null,
        isShowexpert: true,//是否显示高级设置的内容
        curMob: null
      }
    },
    ready: function () {
      console.log('ready');
    },
    route: {
      activate: function (transition) {
        //console.log("pipeline list vue.route.activate");
        var that = this;
        var ind;
        that.obj = JSON.parse(that.$route.query.activeInfo) || {};//展示数据
        that.param = JSON.parse(that.$route.query.activeInfo) || {};//提交数据
        that.getActivePage();
//                console.log("编辑页",that.$route.query);
        return transition.next();
      },
      deactivate: function (transition) {
        console.log('deactivate');
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      getActivePage: function () {
        var that = this;
        if (!that.param.custom_field) {
          that.param.custom_field = that.custom_field
        }
        ind = (that.obj.type * 1);
        console.log("that.obj", that.obj.isgroup);
        console.log("that.param", that.param.isgroup);
        that.id = that.$route.query.id || {};
        that.typeText = that.activeTypeArr[ind];
        console.log("签到时间", that.obj.checkin_start_time);
        that.obj.start_time = that.obj.start_time != "0" ? config.formatTime(that.obj.start_time, 'yyyy.MM.dd(D) hh:mm') : null;
        that.obj.end_time = that.obj.end_time != "0" ? config.formatTime(that.obj.end_time, 'yyyy.MM.dd(D) hh:mm') : null;
        that.obj.apply_end_time = that.obj.apply_end_time != "0" ? config.formatTime(that.obj.apply_end_time, 'yyyy.MM.dd(D) hh:mm') : null;
        that.obj.checkin_start_time = that.obj.checkin_start_time != "0" ? config.formatTime(that.obj.checkin_start_time, 'yyyy.MM.dd(D) hh:mm') : null;
        that.obj.checkin_end_time = that.obj.checkin_end_time != "0" ? config.formatTime(that.obj.checkin_end_time, 'yyyy.MM.dd(D) hh:mm') : null;
        that.param.ac_id = that.id;
        that.poster = that.param.img;
        that.obj.isgroup = that.param.isgroup;
        if (that.obj.phone == 0 || !that.obj.phone) {
          that.obj.phone = null;
        }
        if (that.obj.locate) {
          that.addressFlag = true;
        }
        for (var i = 0; i < config.defaultPoster.length; i++) {
          if (that.poster.url == config.defaultPoster[i].url) {
            that.poster.url = "";
          }
        }
        if (that.obj.description && that.obj.description != "请输入活动描述") {
          that.desStyle = 1;
        }
      },
      //保存活动
      saveActive: function () {
        //that.allow_apply：0 不允许报名；1允许报名
        //that.checktype:1 审核；0公开
        var self = this;
        self.param.activeType = self.typeText;
        if (self.param.allow_apply == '0') {
          if (!self.subActiveClose()) {
            return;
          }
        } else if (self.param.allow_apply == '1') {
          if (!self.subActiveClose() || !self.subActiveShow()) {
            return;
          }
        }
        self.$emit('subActive');
      },
      subActiveShow: function () {
        var that = this;
        if (!that.obj.apply_end_time) {
          alert('请输入报名截止时间');
          return false;
        } else if (that.obj.apply_end_time > that.obj.start_time) {
          alert('报名截止时间不晚于活动开始时间');
          return false;
        } else if (that.param.price * 1 > 0 && !editActiveModule.isDigit(/^[0-9]+(.[0-9]{1,3})?$/, that.param.price)) {
          alert('请输入有效金额');
          return false;
        } else if (that.param.price * 1 > 9999) {
          alert('人均费用不高于9999');
          return false;
        }
        else if (that.obj.max * 1 > 0 && that.obj.max * 1 < that.obj.apply_sum * 1) {
          alert("人数上限不低于已报名人数");
          return false;
        } else if (that.param.max > 100000) {
          alert('报名人数不超过100000');
          return false;
        }
        return true;
      },
      subActiveClose: function () {
        var that = this;
        if (!that.param.title) {
          alert('请输入活动标题');
          return false;
        } else if (!that.typeText) {
          alert('请选择活动类型');
          return false;
        } else if (!that.obj.start_time) {
          alert('请选择活动开始时间');
          return false;
        } else if (!that.obj.end_time) {
          alert('请选择活动结束时间');
          return false;
        } else if (that.obj.start_time >= that.obj.end_time) {
          alert('活动结束时间不早于活动开始时间');
          return false;
        } else if (!that.obj.locate) {
          alert('请选择活动地点');
          return false;
        } else if (that.obj.phone) {
          if (!that.obj.phone.match(/^(\(\d{3,4}\)|\d{3,4}(-|\s))?\d{5,14}$/) && !that.obj.phone.match(/^1[3|4|5|7|8]\d{9}$/)) {
            alert("请输入正确的电话号码");
            return false;
          }
        }
        return true;
      },
      //选择名片
      selectCard: function () {
        var that = this;

        function callbackfun(e) {
          if (e.result == "cancel") {
            return false;
          }
          console.log("*********选择名片", e);
          that.param.uid = e.userId;
          that.param.c_fid = e.feedId;
          that.param.u_no = "";
          that.param.username = e.title;
          that.param.personal_sign = e.subtitle;
          that.param.avatar = e.avatarId;
          api.userSys({feed_id: that.param.c_fid}).then(function (data) {
            console.log("ok");
          }).catch(function (data) {
            console.log(data);
          });
        }

        toonCall({
          "type": "0"
        }, "card/chooseCard", callbackfun);
      },
      //选择活动类型
      selectType: function (el) {
        var _self = this;
        var $el = $(el);
        var $mob_master = document.getElementById("mob-master");
        _self.curMob = $el;
        var Date_time = function (obj, options) {
          var that = this,
            h = 50, //行高
            rh = h / 37.5 * window.lib.flexible.rem, // 根据flexible换算后的行高
            i,
            len;
          that.options = {
            theme: 'ios',
            display: 'bottom',
            mode: 'scroller', //日期选择模式
            lang: 'zh',
            height: rh,
            width: window.innerWidth,
            fixedWidth: window.innerWidth,
            wheels: [
              [{
                values: ["娱乐", "兴趣", "户外", "会议", "运动", "讲座沙龙", "展览", "演出"]
              }]
            ],
            onClosed: function (valueText, inst) {
              $el.mobiscroll('destroy');
              $("#mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
            },
            onBeforeShow: function () {
              $("#mob-master").addClass("mob-master-show").removeClass("mob-master-hid");
            },
            onCancel: function () {
              $("#mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
            }
          };
          if (options) {
            len = options.length;
            for (i = 0; i < len; i++) {
              that.options = options[i];
            }
          }
          obj.mobiscroll().scroller(that.options);

          //logger.log("in date_time:", obj, options);
        };

        Date_time($el);
      },
      //添加活动海报
      addPicFn: function () {
        var that = this;
        uploadImages({
          "type": 0,
          "nameSpace": "toonPlugins.active.dev.systoon.com",
          "xLength": 375,
          "yLength": 178,
          "functionType": 2,
          "maxCount": 1,
          "ratio": 0.8
        }, callbackfun);

        function callbackfun(e) {
          if (e != "cancel" && e) {
            that.addPic = 1;
            that.param.img.url = e[0];
          }
        }
      },
      //新添加活动海报
      addPicFnNew: function () {
        var thisModule = this;
        var option = {
          "type": 0,
          "aspectX": 2,
          "aspectY": 1,
          "functionType": 2,
          "maxCount": 1,
          "ratio": 0.8
        };
        toongine.media.chooseImage({
          params: {
            count: 1,
            sourceType: 2
          },
          callback: function (res) {
            uploadImgStateful(option, res, function (e) {
              if (e.code === "10") {
                console.log("获取图片数据失败");
                alert("上传图片失败,请检查网络");
              } else if (e.code === "11") {
                console.log("获取七牛token失败");
                thisModule.poster = {};
                alert("上传图片失败,请重新上传", 2000);
              } else if (e.code === "12") {
                console.log("上传图片失败，ID-->" + e.data);
                thisModule.poster = {};
              } else if (e.code === "20") {
                console.log("用户取消上传");
              } else if (e.code === "22") {
                for (var j = 0; j < e.data.length; j++) {
                  var temp = e.data[j];
                  temp.url = "";
                  temp.loading = true;
                  temp.fail = false;
                  thisModule.poster = temp;
                }

              } else if (e.code === "23") {
                //url返回
                if (thisModule.poster.id === e.data.id) {
                  thisModule.poster.url = e.data.url;
                  thisModule.poster.loading = false;
                }
              }

            });
          }
        })


      },
      //选择地址
      selectPlace: function () {
        var that = this;

        toongine.location.chooseLocation({
          callback: function (res) {
            console.log(JSON.stringify(res))
            const address = res.data
            if (address) {
              that.obj.latitude = address.latitude;
              that.obj.longtitude = address.longitude;
              that.obj.locate = address.address;
              that.addressFlag = true;
            }

          }
        })
      },

      addressFn: function (param) {
        var that = this;
        param = param ? param : "";
        if (param && param != that.param.locate) {
          that.addressFlag = false;
          that.obj.latitude = "";
          that.obj.longtitude = "";
          that.param.locate = param;
        }
      },
      addressdetail: function (param, e) {
        var that = this;
        param = param ? param : "";
        if (param && param.length >= 20) {
          that.detailAddress = e.target.value.substr(0, 20);
          that.param.address = e.target.value.substr(0, 20);
          that.obj.address = e.target.value.substr(0, 20);
        } else {
          that.detailAddress = param;
          that.param.address = param;
          that.obj.address = param;
        }
      },
      //允许报名开关
      controlApplyFn: function (param) {
        var that = this;
        if (param == '0') {
          that.param.allow_apply = 1;
          setTimeout(function () {
            document.getElementById('control-apply').scrollIntoView(true);
          }, 300);
        } else if (param == '1' && that.param.apply_sum == 0) {//编辑活动 如果有成功报名 开关不可关闭
          that.param.allow_apply = 0;
        }
      },
      //是否签到
      controlSignFn: function (param) {//签到可以开启 开启后不可关闭
        var that = this;
        if (param == '0') {
          that.param.need_checkin = 1;
        } else if (param == '1' && that.param.apply_sum == 0) {//编辑活动 如果有成功报名 开关不可关闭
          that.param.need_checkin = 0;
        }
      },
      //是否公开
      controlShowFn: function (param) {
        var that = this;
        if (param == '0') {
          that.param.publicity = 1;
        } else if (param == '1' && that.param.apply_sum == 0) {
          that.param.publicity = 0;
        }
      },
      //是否审核
      controlManageFn: function (param) {//审核开关 可以开启 开启后不可关闭
        var that = this;
        if (param == '0') {
          that.param.checktype = 1;
        } else if (param == '1' && that.param.apply_sum == 0) {//编辑活动 如果有成功报名 开关不可关闭
          that.param.checktype = 0;
        }
      },
      //选择时间
      selectDatetime: function (el) {
        console.log('开始时间');
        var _self = this;
        var $el = $(el);
        var $mob_master = document.getElementById("mob-master");
        _self.curMob = $el;
        var Date_time = function (obj, options) {
          var that = this,
            h = 34, //行高
            rh = h / 37.5 * window.lib.flexible.rem, // 根据flexible换算后的行高
            i,
            len;
          that.options = {
            preset: 'date', //日期
            dateFormat: 'yy.mm.dd(DD)', // 日期格式
            dateOrder: 'yymmddDD', //面板中日期排列格式
            theme: 'ios', //皮肤样式
            mode: 'scroller', //日期选择模式
            lang: 'zh',
            display: 'bottom', //显示方式
            minDate: new Date(),
            circular: true,
            endYear: 2036,
            fixedWidth: [80 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem, 83 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem, 50 / 37.5 * window.lib.flexible.rem],
            height: rh,
            onClosed: function (valueText) {
              $el.mobiscroll('destroy');
              $("mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
              console.log('选择的时间', valueText);
            },
            onBeforeShow: function () {
              $("mob-master").addClass("mob-master-show").removeClass("mob-master-hid");
            },
            onCancel: function () {
              $("mob-master").addClass("mob-master-hid").removeClass("mob-master-show");
            }
          };
          if (options) {
            len = options.length;
            for (i = 0; i < len; i++) {
              that.options = options[i];
            }
          }
          obj.mobiscroll().datetime(that.options);
        };
        Date_time($el);
      },
      //去活动描述
      activeIntro: function () {
        var des = this.obj.description ? this.obj.description : "";
        var img = this.param.images ? this.param.images : [];
        var parentPath = location.hash.match(new RegExp(/\/[\w|\-]{1,}\//));
        parentPath = parentPath ? parentPath[0] : "/";
        this.$router.go({
          path: parentPath + "edit-active/describe",
          query: {description: des, images: JSON.stringify(img)}
        });
      },
      //添加自定义信息
      addApplyInfo: function () {
        var parentPath = location.hash.match(new RegExp(/\/[\w|\-]{1,}\//));
        parentPath = parentPath ? parentPath[0] : "/";
        this.$router.go({
          path: parentPath + "edit-active/add-apply-info",
          query: {custom_field: JSON.stringify(this.param.custom_field)}
        });
      },
      //限制活动标题字数
      titleLength: function (text, e) {
        var that = this;
        if (text && text.length > 30) {
          that.param.title = e.target.value.substr(0, 30);
        }
      },
      showExpert: function () {
        var that = this;
        if (that.isShowexpert) {
          that.isShowexpert = false;
        } else {
          that.isShowexpert = true;
        }
      }
    },
    events: {
      subActiveShow: function () {
        var that = this;
        if (!that.obj.apply_end_time) {
          alert('请输入报名截止时间');
          return false;
        } else if (that.obj.apply_end_time > that.obj.start_time) {
          alert('报名截止时间不晚于活动开始时间');
          return false;
        } else if (!that.param.price) {
          that.param.price = 0;
        } else if (that.param.price) {
          if ((!editActiveModule.isDigit(/^[0-9]+(.[0-9]{1,3})?$/, that.obj.price)) || that.param.price * 1 < 0) {
            alert('请输入有效金额');
          }
        } else if (that.obj.max != that.param.max && that.obj.max < that.obj.apply_sum) {
          alert("人数上限不低于已报名人数");
        } else {
          if (!that.param.img.url) {
            var ind = that.activeTypeArr.indexOf(that.typeText);
            that.param.img.url = config.defaultPoster[ind].url;
            console.log("默认海报", that.param.img.url);
          }
        }
      },
      subActiveClose: function () {
        var that = this;
        if (!that.param.title) {
          alert('请输入活动标题');
          return false;
        } else if (!that.param.type) {
          alert('请选择活动类型');
          return false;
        } else if (!that.obj.start_time) {
          alert('请选择活动开始时间');
          return false;
        } else if (!that.obj.end_time) {
          alert('请选择活动结束时间');
          return false;
        } else if (that.obj.start_time > that.obj.end_time) {
          alert('活动结束时间不早于活动开始时间');
          return false;
        } else if (!that.obj.locate) {
          alert('请选择活动地点');
          return false;
        } else {
          if (!that.param.img.url) {
            that.param.img.url = "../images/img/exercise.png";
            console.log("默认海报", that.param.img.url);
          }
        }
      },
      setDefaultApplyTime: function () {
        var _self = this;
        if (_self.obj.start_time && _self.obj.allow_apply == 1) {
          _self.obj.apply_end_time = _self.obj.start_time;
        }
      },
      setDescription: function (descrition, images) {
        this.obj.description = descrition;
        console.log("活动描述", descrition);
        this.param.images = images;
        if (this.obj.description && this.obj.description != "请输入活动描述") {
          this.desStyle = 1;
        }
      },
      setCusInfo: function (arr) {
        var that = this;
        var i;
        for (i = 0; i < arr.length; i++) {
          if (!arr[i].value) {
            arr.pop(arr[i]);
          }
        }
        that.param.custom_field = arr;
        console.log("赋值", JSON.stringify(that.param.custom_field));
      },
      subActive: function () {
        var self = this;
        if (self.param.allow_apply == 0) {
          self.param.custom_field = self.custom_field;
        }
        self.param.img = {
          url: self.poster.url,
          size: self.poster.size,
          width: self.poster.width,
          height: self.poster.height,
          imageType: self.poster.imageType
        };
        if (!self.param.img.url) {
          var ind = self.activeTypeArr.indexOf(self.typeText);
          self.param.img.url = config.defaultPoster[ind].url;
          console.log("默认海报", self.param.img.url);
        }
        self.param.price = !self.param.price ? 0 : self.param.price;
        self.param.max = self.obj.max;
        self.param.locate = self.obj.locate;
        self.param.address = self.obj.address;
        self.param.latitude = self.obj.latitude;
        self.param.longtitude = self.obj.longtitude;
        self.param.type = self.activeTypeArr.indexOf(self.typeText);
        self.param.start_time = self.obj.start_time ? config.dateTomiao(self.obj.start_time) : null;
        self.param.end_time = self.obj.end_time ? config.dateTomiao(self.obj.end_time) : null;
        self.param.apply_end_time = self.obj.apply_end_time ? config.dateTomiao(self.obj.apply_end_time) : null;
        self.param.checkin_start_time = self.obj.checkin_start_time ? config.dateTomiao(self.obj.checkin_start_time) : null;
        self.param.checkin_end_time = self.obj.checkin_end_time ? config.dateTomiao(self.obj.checkin_end_time) : null;
        self.param.description = self.obj.description ? self.obj.description : null;
        self.param.phone = self.obj.phone;
        api.addActive(self.param).then(function (data) {
          self.$dispatch("refreshIndex");
          alert("您发布的活动我们将在1个工作日内完成审核，请留意通知");
          history.back();
        }).catch(function (data) {
          self.param.img.url = null;
          alert(data.msg);
        });
      }
    }
  });
  return editActiveModule.module;
});