/**
 *index-list
 *首页模块
 */
define(["vue", "common/config", "common/api", "text!tplPath/index-list.html", "jq", 'scrollComponent', "common/iscrollpage", "swiper"], function(Vue, config, api, tpl, $, ScrollComponent, IscrollFactory, Swiper) {
  var indexModule = {};
  indexModule.offset = 0;
  indexModule.limit = 10;
  indexModule.myOffset = 0;
  indexModule.loadingMyListFlag = false;
  indexModule.indexActiveItemEl;
  Vue.events = new Vue({});
  indexModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        ungroupAct: false,
        ungroupRec: false,
        scrollY: '',
        actScroll: {},
        recommentLength: '',
        name: '',
        actSwiper: 1,
        showFix: 0,
        onceAutoClick: true,
        showTap: 1,
        showMyTap: 1,
        showActiveTap: 1,
        indexListData: [],
        indexList: [],
        indexPanList: [],
        indexGroupList: [],
        bannerList: [],
        myListData: [],
        noMyListData: false,
        isMoreMyList: true,
        isShowText: false,
        typeMark: config.session.mark,
        cardFlag: null,
        loadComplete: false,
        isMoreDate: false,
        changeTabFlag: true,
        start_time: '',
        tabSwiper: null,
        noListData: false,
        amountAct: 10,
        amountGro: 10,
        amountMyApp: 10,
        amountMyPub: 10,
        page: 1,
        page2: 1,
        timer: [],
        timer2: [],
        startTimeList: [],
        startTimeList2: [],
        slideTap: 1,
      }
    },
    created: function () {
      var that = this
      this.getBannerDate();
      this.selsetedCity();
      this.$nextTick(function() {
        that.getActData(0)
      })
    },
    ready: function () {
      indexModule.init(this);
      var isUrl = window.sessionStorage.getItem('voteUrl');
      if (isUrl) {
        window.sessionStorage.clear();
        window.location.replace(isUrl)
      }
    },
    components: {
      scroll: ScrollComponent
    },
    route: {
      data: function(transition) {
        transition.next();
      },
      activate: function(transition) {
        indexModule.offset = 0;
        indexModule.limit = 10;
        transition.next();
        if (!this.typeMark) { //判断是不是组
          this.$emit("getIndexList", 1);
          this.$emit("getIndexModuleList", 1);
        } else {
          this.$emit("getGroupList", 1);
        }
      },
      deactivate: function(transition) {
        this.timer.forEach(function(time) {
          clearInterval(time);
        })
        this.timer2.forEach(function(time) {
          clearInterval(time);
        })
        return transition.next();
      }
    },
    methods: {
      scroll: function (pos) {
        this.scrollY = -pos.y
        if (pos.y == undefined) {
          this.showFix = 1
          return
        }
        if (this.showTap == 1) {
          this.sticky()
        }
      },
      sticky: function() {
        var box = this.$els.stickyBox
        var offsetTop = box.offsetTop;
        this.scrollY > offsetTop ? this.showFix = 1 : this.showFix = 0
        this.recDeleteSticky()
      },
      recDeleteSticky: function() {
        var that = this
        setTimeout(function() {
          if (that.slideTap == 2) {
            if (that.recommentLength < 2) {
              that.showFix = 0
            }
          }
        }, 0)

      },
      goPage: function(name) {
        if (name === 'search') {
          this.$router.go({
            name: name,
            query: {
              text: "活动"
            }
          });
          return
        }
        this.$router.go({
          name:name
        });
      },
      goDetailById: function(param) {
        var that = this;
        var activeId = param;
        that.$router.go({
          path: "/active-info",
          query: {
            "id": activeId
          }
        });
      },
      //跳转详情页
      goDetail: function(index, event) {
        var obj = this.indexListData[index];
        indexModule.loadingMyListFlag = event.target;
        this.$router.go({
          path: "/active-info",
          query: {
            "id": obj.uuid
          }
        });
      },
      goDetailGroup: function(index, event) {
        var obj = this.indexGroupList[index];
        indexModule.loadingMyListFlag = event.target;
        this.$router.go({
          path: "/active-info",
          query: {
            "id": obj.uuid
          }
        });
      },
      goDetailRec: function(index, event) {
        var obj = this.indexPanList[index];
        indexModule.loadingMyListFlag = event.target;
        this.$router.go({
          path: "/active-info",
          query: {
            "id": obj.uuid
          }
        });
      },
      //跳转我的活动详情页
      goMyDetail: function(index) {
        var obj = this.myListData[index];
        this.$router.go({
          path: "/no-active-info",
          query: {
            "id": obj.uuid
          }
        });
      },
      lookPlace: function(latitude, longtitude, e) {
        e.stopPropagation();
        toongine.location.openLocation({
          params: {
            latitude: Number(latitude),
            longitude: Number(longtitude)
          },
          callback: function() {
            console.log(JSON.stringify(res))
          }
        });
      },
      //切换底部tap
      changeTap: function(index) {
        var that = this

        //重复点击相同tap不响应
        if (this.showTap === index) {
          return;
        }
        this.showTap = index;

        //如果切换到我的活动且我的活动列表为空，查询
        if (index === 1 && !this.typeMark) {
          this.$nextTick(function() {
            that.getActData(0)
            that.showActiveTap = 1
          })
          this.$emit("getIndexList", 1);
          return
        } else if (index === 1 && this.typeMark) {
          this.$emit("getGroupList", 1);
        }
        if (index === 2 && this.myListData.length === 0) {
          indexModule.myOffset = 0;
          this.$emit("getMyList", 1);
        } else {
          this.$nextTick(function() {
            if (that.typeMark) {
              indexModule.scroller4.myScroll.refresh();
            }
            indexModule.scroller2.myScroll.refresh();
          });
        }
      },
      onScrollMyList: function(e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          //如果有更多数据 或者没有加载中，执行
          if (this.isMoreMyList && !indexModule.loadingMyListFlag) this.$emit("getMyList");
        }
      },
      skipCard: function(param) {
        if (param) {
          config.skipCard(param);
        }
      },
      //切换我的活动顶部tap
      changeMyActive: function(index) {
        //重复点击相同tap不响应
        if (this.showMyTap === index) {
          return;
        }
        this.noMyListData = false;
        indexModule.myOffset = 0;
        this.isMoreMyList = true;
        this.isShowText = false;
        this.showMyTap = index;
        this.$emit("getMyList", 1);
      },
      //选择城市
      selsetedCity: function() {
        if (window.sessionStorage.cityId) {
          this.name = window.sessionStorage.selectCityName
        } else {
          toongine.location.getLocation({
            callback: function(res) {
              if (res.data.city) {
                var index = res.data.city.indexOf('市');
                this.name = index === -1 ? res.data.city : res.data.city.slice(0, index)
              }
            }
          })
        }
      },
      //切换活动和推荐
      changeActiveTap: function(index) {
        this.onceAutoClick = false
        this.showActiveTap = index
        this.slideTap = index
        this.actSwiper.slideTo(index - 1);
      },

      //活动swiper
      getActData: function(num) {
        var that = this
        this.actSwiper = new Swiper(".swiper-container-act", {
          direction: "horizontal",
          autoHeight: true,
          initialSlide: num,
          followFinger: false,
          resistanceRatio: 0.2,
          onSlideChangeStart: function(swiper) {
            that.showActiveTap = swiper.activeIndex + 1;
            that.slideTap = swiper.activeIndex + 1
            that.recDeleteSticky()
            that.refresh()
          },
          onSlideChangeEnd: function(swiper) {
            if (that.onceAutoClick) {
              that.changeActiveTap(swiper.activeIndex + 1)
              return
            }
            that.onceAutoClick = true
            that.getActivityList(swiper.activeIndex + 1);
          }
        })
        that.refresh()
      },
      getActivityList: function(index) {
        this.isMoreDate = true;
        this.showActiveTap = index;
        if (index === 1) {
          this.$emit("getIndexList");
        } else if (index === 2) {
          this.$emit("getIndexModuleList");
        }
      },
      refresh: function() {
        Vue.events.$dispatch('scrollRefresh');
      },
      //顶部轮播图
      getBannerDate: function() {
        var that = this;
        var param = {};
        api.getBannerDate(param).then(function(data) {
          data = data ? data : [];
          that.bannerList = data.dataList;
          that.$nextTick(function() {
            var mySwiper = new Swiper(".swiper-container-banner", {
              direction: "horizontal",
              loop: true,
              pagination: ".swiper-pagination",
              autoplay: that.bannerList.length <= 1 ? 0 : 5000,
              autoplayDisableOnInteraction: false
            })
          })

        });
      },
      toRedirectPage: function(url) {
        window.location.href = url
      },
      onPullingDown: function() {
        if (!this.typeMark && this.showActiveTap == 1 && this.showTap == 1) {
          this.$emit("getIndexList", 1);
        } else if (!this.typeMark && this.showActiveTap == 2 && this.showTap == 1) {
          this.$emit("getIndexModuleList", 1);
        }
      },
      onPullingUp: function() {
        if (!this.typeMark && this.showActiveTap == 1 && this.showTap == 1) {
          this.$emit("getIndexList", 2);
        } else if (!this.typeMark && this.showActiveTap == 2 && this.showTap == 1) {
          this.$emit("getIndexModuleList", 2);
        }
      },
      noNewData: function(val) {
        if (val === 1) {
          Vue.events.$dispatch('noFreshData');
        } else if (val === 2) {
          this.getActData(this.showActiveTap - 1)
          setTimeout(function() {
            Vue.events.$dispatch('noMoreData');

          }, 200)
        }
      },
      newData: function(val) {
        var that = this
        if (val === 1) {
          Vue.events.$dispatch('freshData');
          setTimeout(function() {
            that.changeActiveTap(that.showActiveTap)
          }, 100)
        } else if (val === 2) {
          Vue.events.$dispatch('moreData');
          setTimeout(function() {
            that.getActData(that.showActiveTap - 1)
          }, 70)
        }
      }
    },
    events: {
      //首页活动接口请求及处理
      getIndexList: function(val) {
        var thisModule = this;
        if (val === 1) { // 1-下拉刷新；2-上划加载
          //倒计时的定时器
          thisModule.timer.forEach(function(time) {
            clearInterval(time);
          })
          thisModule.page = 1;
          thisModule.amountAct = 10;
        }
        var param = {
          limit: indexModule.limit,
          page: thisModule.page
        };
        if (thisModule.amountAct >= indexModule.limit && val) {
          return api.getIndexList(param, {
            loading: false
          }).then(function(data) {
            data = data.list&&data.list.length>0 ? data : [];
            if (data.length==0) {
              thisModule.noListData = true;
              thisModule.amountAct = 0
              thisModule.$nextTick(function() {
                thisModule.noNewData(val)
              })
            } else {
              thisModule.amountAct = data.list.length;
              // 过滤城市活动
              if (window.sessionStorage.cityId) {
                data.list = data.list.filter(function(item) {
                  return item.city_id === window.sessionStorage.cityId;
                })
              }

              if (data.list.length === 0) {
                // thisModule.noListData = true;
                thisModule.ungroupAct = true
                // thisModule.refresh()
              }
              thisModule.page++;
              thisModule.noListData = false;
              thisModule.totalPage = data.totalPage;
              thisModule.startTimeList = [];
              data.list.forEach(function(item) {
                item.now_time = Math.floor(new Date().getTime() / 1000);
                item.hasTime = config.formateTimes(item.start_time);
                thisModule.startTimeList.push(item.start_time);
              });
              if(val == 1) {
                thisModule.indexListData = data.list;
              } else if(val == 2) {
                thisModule.indexListData = thisModule.indexListData.concat(data.list);
              }
              if (data.list.length < indexModule.limit && thisModule.page == (thisModule.totalPage + 1)) {
                thisModule.isMoreData = false;
                thisModule.$nextTick(function() {
                  thisModule.noNewData(val)
                })
              } else if (data.list.length < indexModule.limit && thisModule.page === 2) {
                thisModule.isMoreData = false;
                thisModule.$nextTick(function() {
                  thisModule.noNewData(val)
                })
              } else {
                thisModule.isMoreData = true;
                thisModule.$nextTick(function() {
                  thisModule.newData(val)
                })
              }
            }

            //倒计时功能
            function timeDownActive() {
              var timeDown = setInterval(function() {
                thisModule.startTimeList.forEach(function(item, index) {
                  item = item - 1; //1s后才动，所以要-1s
                  if(data.length>0) {
                    thisModule.indexListData[(thisModule.page - 2) * 10 + index].hasTime = config.formateTimes(item);
                  }
                })
              }, 1000);
              thisModule.timer.push(timeDown);
            };

            thisModule.$nextTick(function() {
              thisModule.loadComplete = true;
              if (data.list) {
                timeDownActive();
              }
              if (this.typeMark) {
                indexModule.scroller4.myScroll.refresh();
              } else if (!this.typeMark) {
                thisModule.refresh();
              }

            });
          }).catch(function(err) {
            if (this.typeMark) {
              indexModule.scroller4.myScroll.refresh();
            } else if (!this.typeMark) {
              thisModule.refresh();
            }
            alert("获取活动失败");
            thisModule.$nextTick(function() {
              thisModule.noNewData(val)
            })
          });
        } else if (thisModule.amountAct == 0) {
          // thisModule.noListData = true;
          thisModule.$nextTick(function() {
            thisModule.noNewData(val)
          })
        } else {
          thisModule.noListData = false;
          thisModule.$nextTick(function() {
            thisModule.noNewData(val)
          })
        }
      },

      //首页推荐接口请求及处理
      getIndexModuleList: function(val) {
        var thisModule = this;
        // thisModule.changeActiveTap(2)
        if (val === 1) { // 1-下拉刷新；2-上划加载
          thisModule.timer2.forEach(function(time) {
            clearInterval(time);
          })
          thisModule.amountRec = 10;
          // thisModule.indexPanList = [];
        }
        var param = {
          offset: indexModule.offset,
          limit: indexModule.limit
        };
        if (thisModule.amountRec >= indexModule.limit && val) {
          return api.getIndexModuleList(param, {
            loading: false
          }).then(function(data) {
            data = data ? data : [];
            if (data.length === 0) {
              // thisModule.noListData = true;
              thisModule.ungroupRec = true
              thisModule.amountRec = 0
              thisModule.$nextTick(function() {
                thisModule.noNewData(val)
              })
            } else {
              thisModule.ungroupRec = false
              // thisModule.noListData = false;
              thisModule.recommentLength = data.length

              if (data.length >= indexModule.limit) {
                thisModule.amountRec = data.length - (parseInt((data.length) / 10) - 1) * 10;
              } else if (data.length < indexModule.limit) {
                thisModule.amountRec = data.length
              }
              thisModule.startTimeList2 = [];
              data.forEach(function(item, index) {
                item.now_time = Math.floor(new Date().getTime() / 1000);
                item.hasTime = config.formateTimes(item.start_time);
                thisModule.indexPanList.push(item);
                thisModule.startTimeList2.push(item.start_time)
              });
              if (indexModule.offset == 0) {
                thisModule.indexPanList = data;
              } else if(val == 1) {

                thisModule.indexPanList = data;
              }else if(val == 2){
                thisModule.indexPanList = thisModule.indexPanList.concat(data);
              }
              if (thisModule.amountRec < indexModule.limit) {
                thisModule.isMoreData = false;
                thisModule.$nextTick(function() {
                  thisModule.noNewData(val)
                })
              } else {
                thisModule.$nextTick(function() {
                  thisModule.newData(val)
                })
                thisModule.isMoreData = true;
              }
            }

            function timeDownActive2() {

              var timeDown2 = setInterval(function() {
                thisModule.startTimeList2.forEach(function(item, index) {
                  item = item - 1; //1s后才动，所以要-1s
                  if (data.length>0&&data.length <= 10) {
                    thisModule.indexPanList[index].hasTime = config.formateTimes(item);
                  } else if (data.length > 10) {
                    thisModule.indexPanList[(parseInt(data.length / 10)) * 10 + index].hasTime = config.formateTimes(item);
                  }
                })
              }, 1000);
              thisModule.timer2.push(timeDown2);
            }

            thisModule.$nextTick(function() {
              if (data) {
                timeDownActive2();
              }
              thisModule.loadComplete = true;
              thisModule.refresh();
            });
          }).catch(function(err) {
            thisModule.refresh();
            alert("获取活动失败");
          });
        } else if (thisModule.amountRec == 0) {
          // thisModule.noListData = true;
          thisModule.$nextTick(function() {
            thisModule.noNewData(val)
          })

        } else {
          thisModule.ungroupRec = false;
          // thisModule.noListData = false
          thisModule.$nextTick(function() {
            thisModule.noNewData(val)
          })

        }
      },

      //小组活动接口请求及处理
      getGroupList: function(val) {
        var thisModule = this;
        if (val === 1) { // 1-下拉刷新；2-上划加载
          if (thisModule.timer) {
            clearInterval(thisModule.timer)
          }
          thisModule.amountGro = 10;
          // thisModule.indexGroupList = [];
        }
        var param = {
          offset: indexModule.offset,
          limit: indexModule.limit
        };
        if (thisModule.amountGro >= indexModule.limit && val) {
          return api.getIndexList(param, {
            loading: false
          }).then(function(data) {
            data = data ? data : [];
            if (data.length === 0) {
              thisModule.amountGro = 0
              thisModule.noListData = true;
            } else {
              thisModule.noListData = false;
              if (data.length >= 10) {
                thisModule.amountGro = data.length - (parseInt((data.length) / 10) - 1) * 10;
              } else if (data.length < 10) {
                thisModule.amountGro = data.length
              }
              var startTimeList = [];
              data.forEach(function(item, index) {
                item.now_time = Math.floor(new Date().getTime() / 1000);
                item.hasTime = config.formateTimes(item.start_time);
                thisModule.indexGroupList.push(item);
                startTimeList.push(item.start_time)
              });
              if (indexModule.offset === 0) {
                thisModule.indexGroupList = data;
              } else if(val ===1) {
                thisModule.indexGroupList = data;
              }else if (val ===2) {
                thisModule.indexGroupList = thisModule.indexGroupList.concat(data);
              }
              if (thisModule.amountGro < indexModule.limit) {
                thisModule.isMoreData = false;
                indexModule.switchPullUpText(false, 0);
              } else {
                thisModule.isMoreData = true;
              }

              function timeDownActive() {
                var timeDown = setInterval(function() {
                  startTimeList.forEach(function(item, index) {
                    item = item - 1000; //1s后才动，所以要-1s
                    if (data.length <= 10) {
                      thisModule.indexGroupList[index].hasTime = config.formateTimes(item);
                    } else if (data.length > 10) {
                      thisModule.indexGroupList[(parseInt(data.length / 10)) * 10 + index].hasTime = config.formateTimes(item);
                    }
                  })
                }, 1000);
                thisModule.timer.push(timeDown);
              }

              thisModule.$nextTick(function() {
                if (data.length !== 0) {
                  timeDownActive()
                }
                thisModule.loadComplete = true;
                indexModule.scroller4.myScroll.refresh();
              });

            }

          }).catch(function(err) {
            indexModule.scroller4.myScroll.refresh();
            alert("获取活动失败");
          });
        } else if (thisModule.amountGro == 0) {
          thisModule.noListData = true;
        } else {
          thisModule.noListData = false;
        }
      },

      //我的接口请求及处理
      getMyList: function(val) {
        var thisModule = this;
        if (val === 1) { // 1-下拉刷新；2-上划加载
          if (thisModule.showMyTap == 1) {
            thisModule.amountMyApp = 10;
            thisModule.myListData = [];
          } else if (thisModule.showMyTap == 2) {
            thisModule.amountMyPub = 10;
            // thisModule.myListData = [];
          }
        }
        indexModule.loadingMyListFlag = true;
        var param = {
          offset: indexModule.myOffset,
          limit: indexModule.limit
        };
        //showMyTap 1-我参与的 2-我发布的
        var opt = {
          showMyTap: this.showMyTap
        };
        if (indexModule.myOffset === 0) {
          opt.loading = true;
        } else {
          opt.loading = false;
        }
        if (thisModule.amountMyApp >= 10 && opt.showMyTap == 1) {
          return api.getMyList(param, opt).then(function(data) {
            data = data ? data : [];
            if (data.length === 0) {
              thisModule.noMyListData = true;
              thisModule.amountMyApp = 0;
            } else {
              thisModule.noMyListData = false;
              if (data.length >= 10) {
                thisModule.amountMyApp = data.length - (parseInt((data.length) / 10) - 1) * 10;
              } else if (data.length < 10) {
                thisModule.amountMyApp = data.length
              }
              if (thisModule.myListData.length) indexModule.myOffset = thisModule.myListData[thisModule.myListData.length - 1].id;
              //if (val === 2) {
              if (indexModule.myOffset === 0) {
                thisModule.myListData = data;
              } else if(val ===1) {
                thisModule.myListData = data;
              }else if(val ===2) {
                thisModule.myListData = thisModule.myListData.concat(data);
              }
              //}
              if (data.length < indexModule.limit) {
                //thisModule.noMyListData = false;
                thisModule.isMoreMyList = false;
                indexModule.switchPullUpText(false, 2);
              } else {
                //thisModule.noMyListData = false;
                thisModule.isMoreMyList = true;
              }
            }
            thisModule.$nextTick(function() {
              thisModule.loadComplete = true;
              indexModule.loadingMyListFlag = false;
              console.log('indexModule.scroller2', indexModule.scroller2)
              indexModule.scroller2.myScroll.refresh();
            });
          }).catch(function(err) {
            indexModule.loadingMyListFlag = false;
            indexModule.scroller2.myScroll.refresh();
            alert("获取我的活动失败");
          });
        } else if (thisModule.amountMyApp < 10 && opt.showMyTap == 1 && thisModule.amountMyApp !== 0) {
          thisModule.noMyListData = false;
          //thisModule.isMoreMyList = true;
        } else if (thisModule.amountMyApp == 0 && opt.showMyTap == 1) {
          // thisModule.noMyListData = true;
        }
        if (thisModule.amountMyPub >= 10 && opt.showMyTap == 2) {
          return api.getMyList(param, opt).then(function(data) {
            data = data ? data : [];
            if (data.length === 0) {
              thisModule.noMyListData = true;
              thisModule.amountMyPub = 0;
            } else {
              thisModule.noMyListData = false;
              if (indexModule.myOffset === 0) {
                thisModule.myListData = data;
              } else {
                thisModule.myListData = thisModule.myListData.concat(data);
              }
              if (data.length >= 10) {
                thisModule.amountMyPub = data.length - (parseInt((data.length) / 10) - 1) * 10;
              } else if (data.length < 10) {
                thisModule.amountMyPub = data.length
              }
              if (thisModule.amountMyPub < indexModule.limit) {
                thisModule.isMoreMyList = false;
                indexModule.switchPullUpText(false, 2);
              } else {
                thisModule.isMoreMyList = true;
              }
            }
            thisModule.$nextTick(function() {
              thisModule.loadComplete = true;
              indexModule.loadingMyListFlag = false;
              indexModule.scroller2.myScroll.refresh();
            });
          }).catch(function(err) {
            indexModule.loadingMyListFlag = false;
            indexModule.scroller2.myScroll.refresh();
            alert("获取我的活动失败");
          });
        } else if (thisModule.amountMyPub < 10 && opt.showMyTap == 2 && thisModule.amountMyPub !== 0) {
          thisModule.noMyListData = false;
        } else if (thisModule.amountMyPub == 0 && opt.showMyTap == 2) {
          // thisModule.noMyListData = true;
        }
      },
      refreshIndex: function() {
        if (!this.typeMark) {
          indexModule.indexActiveItemEl = null;
          indexModule.offset = 0;
          this.$emit("getIndexList");
          indexModule.myOffset = 0;
          this.$emit("getMyList");
        } else {
          indexModule.indexActiveItemEl = null;
          indexModule.offset = 0;
          this.$emit("getGroupList");
        }
      }
    }

  });

  indexModule.init = function(thisModule) {
    if (thisModule.typeMark) {
      // 小组活动的滚动
      indexModule.scroller4 = new IscrollFactory('group-active', {
        probeType: 2,
        bounceTimeTime: 250,
        bounceEasing: 'quadratic',
        mouseWheel: false,
        scrollbars: false,
        fadeScrollbars: true,
        preventDefault: false,
        interactiveScrollbars: false,
        deceleration: 0.003
      }, pullDownAction, pullUpAction);
      indexModule.scroller4.init();
      setTimeout(function() {
        indexModule.scroller4.myScroll.refresh();
      }, 500);
      document.getElementById("group-active").addEventListener('touchmove', function(e) {
        e.preventDefault();
      }, false);

    }

    //我的的滚动
    indexModule.scroller2 = new IscrollFactory('mylist-wrapper', {
      probeType: 2,
      bounceTimeTime: 250,
      bounceEasing: 'quadratic',
      mouseWheel: false,
      scrollbars: false,
      fadeScrollbars: true,
      preventDefault: false,
      interactiveScrollbars: false,
      deceleration: 0.003
    }, pullDownAction, pullUpAction);
    indexModule.scroller2.init();
    setTimeout(function() {
      indexModule.scroller2.myScroll.refresh();
    }, 500);
    document.getElementById("mylist-wrapper").addEventListener('touchmove', function(e) {
      e.preventDefault();
    }, false);

    //下拉刷新
    function pullDownAction(theScroller) {
      /*
       typeMark -- 是否是小组
       showActiveTap -- 活动1 推荐2
       showTap -- 首页1 我的2
       showMyTap -- 我参与1 我发起的2
       */
      if (thisModule.showTap == 2 && thisModule.showMyTap == 1) {
        thisModule.$emit("getMyList", 1);
      } else if (thisModule.showTap == 2 && thisModule.showMyTap == 2) {
        thisModule.$emit("getMyList", 1);
      } else if (thisModule.typeMark && thisModule.showTap == 1) {
        thisModule.$emit("getGroupList", 1);
      }
    }

    //上划加载
    function pullUpAction(theScroller) {
      if (thisModule.showTap == 2 && thisModule.showMyTap == 1) {
        thisModule.$emit("getMyList", 2);
      } else if (thisModule.showTap == 2 && thisModule.showMyTap == 2) {
        thisModule.$emit("getMyList", 2);
      } else if (thisModule.typeMark && thisModule.showTap == 1) {
        thisModule.$emit("getGroupList", 2);
      }
    }

  };
  indexModule.switchPullUpText = function(more, index) {
    var el = document.getElementsByClassName("pullUp")[index];
    if (!el) {
      return;
    }
    if (more) {
      el.innerHTML = '<span class="pullUpIcon" id="pullUpIcon"></span><span id="pullUpLabel" class="pullUpLabel">上拉加载更多...</span>';
    } else {
      el.setAttribute("class", "no-data-text pullUp");
      el.innerHTML = '—— 我是有底线的 ——';
    }
  };
  return indexModule.module;
});
