/**
 *search
 *搜索页模块
 *     --Created by shenxiaowei on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "core", "text!tplPath/module-list.html"], function (Vue, config, api, core, tpl) {
  var indexModule = {};
//    indexModule.offset = 0;
  indexModule.page = 1;
  indexModule.limit = 10;
  indexModule.myOffset = 0;
  indexModule.loadingMyListFlag = false;
  indexModule.indexActiveItemEl;
  indexModule.module = Vue.extend({
    template: tpl,
    ready: function () {

    },
    data: function () {
      return {
        curModule: 0,
        indexListData: [],
        noMyListData: false,
        isMoreMyList: true,
        isShowText: false,
        typeMark: config.session.mark,
        loadComplete: false
      }
    },
    route: {
      activate: function (transition) {
        //console.log("pipeline list vue.route.activate");
        var that = this;
//                indexModule.offset = 0;
//                indexModule.myOffset = 0;
        indexModule.page = 1;
        that.curModule = that.$route.query.ind;
        that.curModule = that.curModule ? that.curModule : 0;
        that.$emit("getModuleList");
        transition.next();
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      changeModule: function (ind) {
        var that = this;
        if (config.isAllowSubmit) {
//                indexModule.offset = 0;
          config.isAllowSubmit = false;
          that.isShowText = false;
          indexModule.page = 1;
          indexModule.limit = 10;
          that.indexListData = [];
          that.curModule = ind;
          that.$emit("getModuleList");
        }
      },
      onScroll: function (e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          if (this.isMoreMyList && !indexModule.loadingMyListFlag) {
            this.$emit("getModuleList");
          }

        }
        //超出一屏显示 "底线"
//                var winHeight = document.body.clientHeight;
//                if(scrollTop>winHeight){
//                    this.isShowText = true;
//                }else{
//                    this.isShowText = false;
//                }
      },
      goDetail: function (param) {
        var that = this;
        var activeId = param;
        console.log("活动id----", activeId);
        that.$router.go({path: "/module-list/active-info", query: {"id": activeId}});
      }
    },
    events: {
      getModuleList: function () {
        var thisModule = this;
        indexModule.loadingMyListFlag = true;
        var param = {
          page: indexModule.page
//                    limit:indexModule.limit
        };
        var obj = {
          loading: false,
          type: thisModule.curModule
        };
        return api.getModuleList(param, obj).then(function (data) {
          data.list = data.list ? data.list : [];
          indexModule.page = data.page ? data.page : 1;
          //data = [];
          if (data.list.length <= indexModule.limit && data.page == data.totalPage) {
            thisModule.isMoreMyList = false;
          } else {
            thisModule.isMoreMyList = true;
          }
          //如果没数据
          if (data.list.length === 0 && indexModule.page === 1) {
            thisModule.noMyListData = true;
          } else {
            thisModule.noMyListData = false;
          }

          //if(indexModule.offset == 0){
          //    thisModule.indexListData = data;
          //}else{
          //    thisModule.indexListData = thisModule.indexListData.concat(data);
          //}
//                    if(data.length<indexModule.limit){
////                        indexModule.switchPullUpText(false);
//                    }
          if (indexModule.page === 1 && data.list.length < 10) {
            thisModule.indexListData = data.list;
          } else {
            thisModule.indexListData = thisModule.indexListData.concat(data.list);
          }
//                    if(thisModule.indexListData.length){
          if (thisModule.indexListData.length) {
//                        indexModule.offset = thisModule.indexListData[thisModule.indexListData.length-1].id;
            indexModule.page = indexModule.page + 1;
            indexModule.loadingMyListFlag = false;
          }
          thisModule.$nextTick(function () {
            thisModule.loadComplete = true;
            indexModule.loadingMyListFlag = false;
            if (thisModule.indexListData.length >= 3) {
              thisModule.isShowText = true;
            }
          });
          //config.loading(false);
        }).catch(function (err) {
          indexModule.loadingMyListFlag = false;
          console.log(err);
          alert("获取活动失败");
        });
      }
    }
  });
  return indexModule.module;
});