/**
 *index-list
 *活动动态
 *     --Created by Shen xiaowei on 2016/11/24 16:51.
 */
define(["vue", "common/iscrollpage", "common/config", "common/api", "text!tplPath/my-list.html"], function (Vue, IscrollFactory, config, api, tpl) {
  var indexModule = {};
  indexModule.offset = 0;
  indexModule.limit = 10;
  indexModule.myOffset = 0;
  indexModule.loadingMyListFlag = false;
  indexModule.indexActiveItemEl;
  indexModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
//                showTap:1,
        showMyTap: 1,
        indexListData: [],
        myListData: [],
        noMyListData: false,
        isMoreMyList: true,
        isShowText: false,
        typeMark: config.session.mark,
        cardFlag: null,
        loadingMore: false,//加载手势是否显示
        initFlag: true//初次加载显示小菊花
      }
    },
    ready: function () {
//            indexModule.init(this);
    },
    watch: {
      "indexListData": function (val, oldVal) {
        if (val.length > 0) {
          if (document.getElementById("pullUpIcon"))document.getElementById("pullUpIcon").style.visibility = "visible";
          if (document.getElementById("pullUpLabel"))document.getElementById("pullUpLabel").style.visibility = "visible";
        }
      }
    },
    route: {
      data: function (transition) {
        transition.next();
      },
      activate: function (transition) {//激活组件
        indexModule.offset = 0;
        indexModule.limit = 10;
        this.initFlag = true;
        this.$emit("getIndexList");
        transition.next();
//                config.loading(true);
      },
      deactivate: function (transition) {//禁用组件
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }

//            ,
//            canActivate:function(){//组件是否可以被激活
//
//            },
//            canDeactivate:function(){//组件是否可以被禁用
//
//            },
//            canReuse:function(){//组件是否可以被重用
//
//            }
    },
    methods: {
      onScrollMyList: function (e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        this.initFlag = false;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          //如果有更多数据 或者没有加载中，执行
          if (this.isMoreMyList && !indexModule.loadingMyListFlag)this.$emit("getIndexList");
        }

        //超出一屏显示 "底线"
        var winHeight = document.body.clientHeight;
        //加上页脚高度，消除误差
        var footHeight = document.getElementById("index-fade-foot").offsetHeight;

        //if(scrollTop+footHeight>winHeight){
        //    this.isShowText = true;
        //}else{
        //    this.isShowText = false;
        //}

      },
      //切换我的活动顶部tap
      changeMyActive: function (index) {
        //重复点击相同tap不响应
        if (this.showMyTap === index) {
          return;
        }
        indexModule.myOffset = 0;
        this.initFlag = false;
        this.isMoreMyList = true;
        this.isShowText = false;
        this.myListData = [];
        this.showMyTap = index;
        this.$emit("getIndexList");
      },
      //跳转发布页
      goAddActive: function () {
        this.$router.go({name: "add-active", query: {'from': '1'}});
      },
      //跳转我的活动详情页
      goMyDetail: function (index) {
        var obj = this.myListData[index];
        //this.$router.go({name:"active-info",query:{"id":obj.id}});
        this.$router.go({path: "/my-list/active-info", query: {"id": obj.uuid}});
      }
    },
    events: {
      getIndexList: function () {
        var thisModule = this;
        var i;
        var len;
        indexModule.loadingMyListFlag = true;
        thisModule.loadingMore = true;
        var param = {
          flag: 1,
          offset: indexModule.myOffset,
          limit: indexModule.limit
        };
        var opt = {
          showMyTap: this.showMyTap
        };
        if (thisModule.initFlag) {
          opt.loading = true;
        } else {
          opt.loading = false;
        }
        return api.getMyList(param, opt).then(function (data) {
          data = data ? data : [];
          if (indexModule.myOffset === 0) {
            thisModule.myListData = data;
          } else {
            thisModule.myListData = thisModule.myListData.concat(data);
          }
          for (var i = 0; i < thisModule.myListData.length; i++) {
            thisModule.myListData[i].isCurDate = config.isCurDate(thisModule.myListData[i].end_time, thisModule.myListData[i].start_time);
          }
          len = thisModule.myListData.length;
          //如果第一页没数据，显示没数据的提示
          if (indexModule.myOffset === 0 && data.length === 0) {
            thisModule.noMyListData = true;
            thisModule.isMoreMyList = false;
          } else if (data.length < indexModule.limit) {
            thisModule.noMyListData = false;
            thisModule.isMoreMyList = false;
          } else {
            thisModule.noMyListData = false;
            thisModule.isMoreMyList = true;
          }
          if (thisModule.myListData.length >= 3) {
            thisModule.isShowText = true;
          }
          if (thisModule.myListData.length)indexModule.myOffset = thisModule.myListData[thisModule.myListData.length - 1].id;
          thisModule.$nextTick(function () {
            thisModule.loadingMore = false;
            indexModule.loadingMyListFlag = false;
          });
        }).catch(function (err) {
          thisModule.myListData = [];
          thisModule.noMyListData = true;
          thisModule.isMoreMyList = false;
          indexModule.loadingMyListFlag = false;
          alert("获取活动失败");
        });
      }

    }
  });
//    indexModule.init = function(thisModule){
//        indexModule.scroller1 = new IscrollFactory('dynamic-state', {
//            probeType: 2,
//            bounceTime: 250,
//            bounceEasing: 'quadratic',
//            mouseWheel: false,
//            scrollbars: false,
//            fadeScrollbars: true,
//            preventDefault: false,
//            interactiveScrollbars: false,
//            //bindToWrapper:true,//default:false
//            deceleration:0.003//default 0.0006
//        }, pullDownAction, pullUpAction);
//        indexModule.scroller1.init();
//        setTimeout(function () {
//            indexModule.scroller1.myScroll.refresh();
//        }, 500);
//
//        document.getElementById("dynamic-state").addEventListener('touchmove', function (e) {
//            e.preventDefault();
//        }, false);
//
//        //下拉刷新
//        function pullDownAction(theScroller) {
//            indexModule.offset = 0;
//            indexModule.$emit("getMyList");
////            thisModule.$emit("getIndexList");
//        }
//
//        //上拉加载
//        function pullUpAction(theScroller) {
//            var param = {
//                flag:1,
//                offset:indexModule.offset,
//                limit:indexModule.limit
//            };
//        }
//    };
  indexModule.switchPullUpText = function (more) {
    var el = document.getElementById("pullUp");
    if (!el) {
      return;
    }
    if (more) {
      el.innerHTML = '<span class="pullUpIcon" id="pullUpIcon"></span><span id="pullUpLabel" class="pullUpLabel">上拉加载更多...</span>';
    } else {
      el.innerHTML = '. END .';
    }
  };
  return indexModule.module;
});