/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "core", "common/config", "common/api", "text!tplPath/no-active-info.html", "common/buried-point",  "base64"], function (Vue, core, config, api, tpl, buriedPoint, base64) {
  var commentParams = {
    offset: 1,
    limit: 10,
    noMore: false,
    isCommentLoading: false,
    loadingMore: false
  };
  var module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        id: this.id || null,
        res: this.res || {},
        typeText: null,
        activeSTime: null,
        activeETime: null,
        applyETime: null,
        activeType: ["娱乐", "兴趣", "户外", "展览", "演出", "会议", "运动", "讲座沙龙"],
        feed: {},
        activity_code: '',
        activity_id: '',
        goApplyFlag: false,
        activeSignSTime: "",
        activeSignETime: "",
        loadComplete: false,
        showDes: null,
        showIntro: null,
        isApply: false,
        dateFlag: true,
        changeTabFlag: true,
        commentList: null,
        commentLoading: false,
        //heartJump:false,
        attentionFlag: false,
        //getShaiList:null,
        //getShaiListFlag:false,
        //showShaiList:false,
        initFlag: true,
        mine_release_user: null,
        curPageName: null,
        statistics: {}
      }
    },
    route: {
      activate: function (transition) {
        console.log("活动详情");
        var that = this;
        that.curPageName = "no-active-info";
        that.initFlag = true;
        that.id = config.returnTag.a || that.$route.query.id;
        that.mine_release_user = config.session.toon_uid;
        commentParams.offset = 1;
        commentParams.loadingMore = false;
        if (!config.session.user_id) {
          window.location.href = config.share_url + '/toon/activity.html?module=applibrary&path=openapp&code=' + config.code + '&cardtype=1&scheme=toon';
        } else {
          that.$emit("getPageInfo");
        }
        return transition.next();
      },
      deactivate: function (transition) {
        return transition.next();
      }
    },
    methods: {
      /*评论列表关注*/
      commentAttention: function (obj, ind) {
        var that = this;
        var follow;
        var type = obj.is_follow;
        var param = {
          "user_id": config.session.user_id,
          //"toUser_id":that.res.uid,
          "toUser_id": that.commentList[ind].UserId,
          "type": type
        };
        return api.attentionUser(param, {loading: false}).then(function (data) {
          result = data;
          for (var i = 0; i < that.commentList.length; i++) {
            if (that.commentList[i].UserId == param.toUser_id) {

              that.commentList[i].is_follow = that.commentList[i].is_follow == 1 ? 0 : 1;
              follow = that.commentList[i].is_follow;
            }
          }
          config.toonNotify({
            type: 'follow', // 关注
            userId: config.session.user_id + '', // 当前用户id
            followUserId: that.commentList[ind].UserId + '', // 要关注的用户id
            status: follow // 0：未关注、1：已关注
          });
        }).catch(function (data) {
          result = data;
          console.log("关注***************", data);
        });
      },
      attention: function () {
        var that = this;
        var type = that.res.isFollw ? 0 : 1;
        type = type || 0;
        var param = {
          "user_id": config.session.user_id,
          //"toUser_id":that.res.uid,
          "toUser_id": that.res.uid,
          "type": type
        };
        return api.attentionUser(param, {loading: false}).then(function (data) {
          result = data;
          that.res.isFollw = that.res.isFollw == 1 ? 0 : 1;

          config.toonNotify({
            type: 'follow', // 关注
            userId: config.session.user_id + '', // 当前用户id
            followUserId: that.res.uid + '', // 要关注的用户id
            status: that.res.isFollw // 0：未关注、1：已关注
          });
        }).catch(function (data) {
          result = data;
          console.log("关注***************", data);
        });
      },
      /*评论列表滚动事件*/
      onScroll: function (e) {
        if (!commentParams.isCommentLoading) {
          return false;
        }
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          //如果有更多数据 或者没有加载中，执行
          if (commentParams.noMore && !commentParams.loadingMore) this.$emit("getCommentList");
        }
      },
      /*去评论*/
      creatComment: function (param) {
        var that = this;
        var obj = param ? param : {};
        var touid = param.UserId ? param.UserId : that.res.uid;
        var parentPath = location.hash.match(new RegExp(/\/[\w|\-]{1,}\//));
        parentPath = parentPath ? parentPath[0] : "/";
        that.curPageName = "";
        that.$router.go({
          path: parentPath + "no-active-info/bbs-create",
          query: {id: that.res.id, touid: touid, toid: 0}
        });
      },
      /*签到二维码*/
      goSignCode: function () {
        var that = this;
        if (that.res.allow_apply != 1) {
          return false;
        }
        var toonType;
        if (!config.session.toon_type) {
          toonType = config.toon_type ? config.toon_type : "100";
        } else if (config.session.toon_type == '102') {
          toonType = "102";
        } else {
          toonType = "100";
        }

        var code = JSON.parse(base64.decode(that.activity_code));
        code.e = 5;
        var url = config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code='+ base64.encode(JSON.stringify(code)) +'&scheme=toon&cardtype=1';

        var param = {
          url: url,
          id: that.res.id,
          title: that.res.title,
          username: that.res.username,
          subtitle: that.res.personal_sign,
          fromscholl: "北京大学"
        };

        var parentPath = location.hash.match(new RegExp(/\/[\w|\-]{1,}\//));
        parentPath = parentPath ? parentPath[0] : "/";
        that.curPageName = "";
        that.$router.go({
          path: parentPath + "active-info/activity-code",
          query: {param: JSON.stringify(param)}
        });
      },
      /*活动详情，讨论区tab切换*/
      changeTab: function () {
        this.changeTabFlag = !this.changeTabFlag;
        commentParams.isCommentLoading = !this.changeTabFlag;
        if (!this.changeTabFlag) {
          this.$emit("getCommentList");
        }
      },
      // 发起投票
      goVote: function () {
        this.res.exportMark = this.res.exportMark != 1 ? 0 : this.res.exportMark;
        window.sessionStorage.setItem('voteUrl', window.location.href);
        window.location.href = config.vote_url + "?acid=" + this.res.id + "&code=" + config.makeCode + "&isPublisher=" + this.res.exportMark;
        toongine.page.setNavigationBarTitle({
          params: {
            title: '投票'
          }
        });
      },

      // TODO 调用电话
      telTalking: function (num) {
        if(num.length < 3) {
          return;
        }
        toongine.device.makePhoneCall({
          params: num,
          callback: function (res) {
            console.log(JSON.stringify(res))
          }
        })
      },
      // 在线咨询
      lineTalking: function () {
        var that = this;
        that.isApply = false;
        if (config.session.feed_id) {
          config.chat({myFeedId: config.session.feed_id, friendFeedId: that.res.c_fid, backToPrev: "1"});
        }
      },
      goGroupChat: function (param) {
        var that = this;
        var owner_info = {};
        if (!config.session) {
          owner_info.createFeedId = that.feed.feedId;
          owner_info.feedId = that.feed.feedId;
          owner_info.userId = that.feed.userId;
          owner_info.name = that.feed.title;
          owner_info.headImage = that.feed.avatarId;
        } else {
          owner_info.createFeedId = config.session.feed_id;
          owner_info.feedId = config.session.feed_id;
          owner_info.userId = config.session.toon_uid;
          owner_info.name = config.session.title;
          owner_info.headImage = config.session.avatarId;
        }
        if ((param < 2 && that.res.exportMark == 1) && (that.res.group_id == "0" || !that.res.group_id || that.res.group_id == "cancel")) {
          alert("至少有2位报名者才可创建群聊");
        } else if (that.res.exportMark != 1 && (that.res.group_id == "0" || !that.res.group_id || that.res.group_id == "cancel")) {
          alert("活动发起者暂未创建群聊");
        } else if (param >= 2 && that.res.exportMark == 1 && (that.res.group_id == "0" || !that.res.group_id || that.res.group_id == "cancel") && that.res.exportMark == "1") {//创建群聊
          function callbackfun(e) {
            if (e != "cancel") {
              console.log(JSON.stringify(e));
              var groupChatParam = {
                id: that.res.id,
                groupID: e.result
              };
              that.res.group_id = e.result ? e.result : "";
              that.res.group_id = that.res.group_id == "cancel" ? "0" : that.res.group_id;
              api.groupChat(groupChatParam).then(function (data) {
                console.log(JSON.stringify(data));
              }).catch(function (data) {
                console.log(JSON.stringify(data));
              })
            }
          }

          var members = that.res.apply_list.slice(0, 2);
          var membersInfo = [];
          for (var i = 0; i < members.length; i++) {
            var newMemberInfo = {};
            newMemberInfo.feedId = members[i].feed_id;
            //newMemberInfo.userId = members[i].toon_uid;
            newMemberInfo.userId = members[i].user_toon_id;
            newMemberInfo.name = members[i].f_title;
            newMemberInfo.headImage = members[i].avatarId;
            membersInfo[i] = newMemberInfo;
          }
          console.log("成员信息：：：", membersInfo);
          var paramData = {
            "groupName": that.res.title,
            "title": "活动详情",
            "createFeedId": owner_info.createFeedId + "",
            "members": membersInfo,
            "feedId": owner_info.feedId + "",
            "userId": owner_info.userId + "",
            "name": owner_info.name,
            "headImage": owner_info.headImage
          };
          console.log("toon协议传入参数：：：", paramData);
          toonCall(paramData, "groupChat/create", callbackfun);
        } else if (owner_info.feedId && that.res.mixstatus != 1 && (that.res.group_id != "0" && that.res.group_id != "cancel")) {//加入群聊
          toonCall({
            "feedId": owner_info.feedId + "",
            "userId": owner_info.userId + "",
            "name": owner_info.name,
            "headImage": owner_info.headImage,
            "groupId": that.res.group_id + "",
            "title": "活动详情"
          }, "groupChat/joinMyself");
        }
      },
      addNotice: function (param) {
        if (!param) {
          return false;
        }
        this.curPageName = "";
        this.$router.go({name: "add-notice", query: {"id": param}});
      },
      //查看公告列表
      noticeList: function (param) {
        if (!param || this.res.allow_apply != 1) {
          return false;
        }
        this.curPageName = "";
        this.$router.go({name: "notice-list", query: {"id": param, flag: this.res.exportMark}});
      },
      //查看活动描述
      goActiveIntro: function () {
        var showDs = this.showDes ? this.showDes : "";
        this.curPageName = "";
        this.$router.go({name: "active-intro", query: {"showDescription": showDs, "images": images}});
      },
      //展开收起活动描述
      isShowIntro: function (ind) {
        var that = this;
        that.showIntro = ind;
        if (ind == 0) {
          document.getElementById('ac-info-content').scrollIntoView(true);
        }
      },
      //查看报名跳转
      goRegisterList: function () {
        var that = this;
        if (that.res.allow_apply != 1) {
          return false;
        }
        var applyList = this.res.apply_list;
        var applyStr = JSON.stringify(applyList);
        this.curPageName = "";
        this.$router.go({
          name: "register-list-page",
          query: {"id": that.res.id, flag: that.res.exportMark, applyList: applyStr}
        });
      },
      //查看签到跳转
      goSignList: function () {
        var that = this;
        if (that.res.allow_apply != 1) {
          return false;
        }
        this.curPageName = "";
        this.$router.go({name: "sign-list", query: {"id": that.res.id, flag: that.res.exportMark}});
      },
      //去审核列表
      goApprovalList: function () {
        var that = this;
        if (that.res.allow_apply != 1 || that.res.checktype != 1) {
          return false;
        }
        this.curPageName = "";
        this.$router.go({name: "approval-list", query: {"id": that.res.id}});
      },
      //去编辑页
      goEdit: function () {
        var that = this;
        that.res.mark = 2;
        that.curPageName = "";
        that.$router.go({
          name: "edit-active",
          query: {"id": that.res.id, activeInfo: JSON.stringify(that.res)}
        });
      },
      //去审核页面
      goManage: function () {
        var that = this;
        that.curPageName = "";
        that.$router.go({name: "approval-list", query: {"id": that.res.id}});
      },
      //去报名页面
      goApply: function () {
        //判断是否已登录
        var that = this;
        if (that.res.max != "0") {
          if (that.res.apply_sum * 1 >= that.res.max * 1) {
            alert("名额已满");
            return false;
          }
        }
        return api.getApplyUserInfo({
          user_id: config.session.user_id,
          ac_id: that.res.id
        }).then(function (data) {
          result = data;
          that.curPageName = "";
          that.$router.go({
            name: "apply",
            query: {
              "id": that.res.id,
              "custom_field": JSON.stringify(that.res.custom_field),
              checkType: that.res.checktype
            }
          });
        }).catch(function (data) {
          result = data;
          console.log("错误", result);
          if (result.code && result.code == '1') {
            alert(result.message);
          }
        });
      },
      //签到
      goSign: function () {
        var that = this;
        var result;
        var param = {
          ac_id: that.res.id
        };
        return api.getSign(param).then(function (data) {
          result = data;
          console.log(result.msg);
          alert('签到成功');
          that.$emit("getPageInfo");
        }).catch(function (data) {
          result = data;
          if (result.code && result.code != '0') {
            alert(result.msg);
          }
        });
      },
      //取消报名
      cancelApply: function (e) {
        e.stopPropagation();
        var that = this;
        var result;
        var param = {
          ac_id: that.res.id
        };
        var applyFn = function (ind) {
          console.log("继续报名");
          api.cancelApply(param).then(function (data) {
            result = data;
            alert("取消报名成功");
            that.$emit("getPageInfo");
            that.$dispatch("refreshIndex");
          }).catch(function (data) {
            result = data;
            if (result.code && result.code != '0') {
              alert(result.msg);
            }
          });
        };
        var cancelFn = function (ind) {
          console.log("取消报名");
        };
        this.$dispatch("dialog", {
          content: '确定要取消报名吗?',
          buttons: [{name: '暂不取消', func: cancelFn}, {name: '确定', func: applyFn}]
        });
      },
      // 活动专属二维码
      goQrCode: function () {
        var that = this;
        var toonType;
        if (!config.session.toon_type) {
          toonType = config.toon_type ? config.toon_type : "100";
        } else if (config.session.toon_type == '102') {
          toonType = "102";
        } else {
          toonType = "100";
        }

        // var url = config.share_url + '/toon/activity.html?module=applibrary&path=openapp&code=' + that.activity_code + '&cardtype=1&scheme=toon';
        var url = config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code='+ that.activity_code +'&scheme=toon&cardtype=1';

        var param = {
          url: url,
          id: that.res.id,
          title: that.res.title
        };
        that.curPageName = "";
        that.$router.go({name: "qr-code", query: {param: JSON.stringify(param)}});
      },
      skipCard: function () {
        var that = this;
        var feedId = that.res.isgroup == '0' ? that.res.c_fid : that.res.fid;
        config.skipCard({feedId: feedId, userId: that.res.uid});
        return false;
      },
      skipCardCode: function (obj) {
        var _userId = obj.toon_uid;
        var _fid = obj.feed_id;
        config.skipCard({feedId: _fid, userId: _userId});
      },
      //todo:查看地图
      lookPlace: function (latitude, longtitude) {
        console.log(22222)

        toongine.location.openLocation({
          params: {
            latitude: Number(latitude),
            longitude: Number(longtitude)
          },
          callback: function (res) {
            console.log(JSON.stringify(res))
          }
        })

      }
    },
    events: {
      getApplyStatistics: function () {
        //console.log("kkk",this);
        var thisModule = this;
        //var that = this;
        //this.res = {}
        //var ac_id = this.res.id
        //console.log("ac_id",this.res);
        var param = {
          ac_id: this.res.id
          //ac_id:ac_id
        };
        var opt = {
          loading: false
        };
        return api.getCheckInStatistics(param, opt).then(function (data) {
          thisModule.statistics = data;
        }).catch(function (err) {
          console.log(err);
          alert("请求失败");
        });
      },
      /*刷新待审核人数*/
      refreshDetailNum: function () {
        if (!config.session.user_id) {
          this.$emit('getNoIDDetail');
        } else {
          this.$emit("getPageInfo");
        }
      },

      /*生成code*/
      getMakeCode: function () {
        if (config.session.user_id) {
          var obj = {
            param: "shequn"
          };
          api.getMakeCode(obj).then(function (data) {
            config.makeCode = data;
          }).catch(function (data) {
            console.log("************error", data);
          });
        }
      },
      /*发布评论后跟新评论列表数据*/
      refreshCommentList: function () {
        this.curPageName = "no-active-info";
        commentParams.offset = 1;
        commentParams.noMore = false;
        commentParams.isCommentLoading = false;
        commentParams.loadingMore = false;
        this.$emit("getCommentList");
      },
      /*获取评论列表*/
      getCommentList: function () {
        var that = this;
        commentParams.loadingMore = true;
        var param = {
          ac_id: that.res.id,
          userId: that.res.uid,
          offset: commentParams.offset,
          limit: commentParams.limit
        };
        api.getCommentList(param, {loading: false}).then(function (data) {
          var curDate = new Date();
          var tempTime;
          var monthFlag;
          var dateFlag;
          var t;
          if (commentParams.offset == 1) {
            that.commentList = data;
          } else {
            that.commentList = that.commentList.concat(data);
          }

          for (var i = 0; i < that.commentList.length; i++) {
            /*处理评论时间的展示*/
            t = new Date(that.commentList[i].Tm * 1000);
            if (curDate.getFullYear() == t.getFullYear()) {//同年
              monthFlag = curDate.getMonth() == t.getMonth() ? 1 : 0;
              dateFlag = curDate.getDate() - t.getDate();
              if (monthFlag == 1 && dateFlag == 0) {//今天
                that.commentList[i].showTm = "今天" + config.formatTime(that.commentList[i].Tm, 'hh:mm');
              } else if (monthFlag == 1 && dateFlag == 1) {//昨天
                that.commentList[i].showTm = "昨天" + config.formatTime(that.commentList[i].Tm, 'hh:mm');
              } else {
                that.commentList[i].showTm = config.formatTime(that.commentList[i].Tm, 'MM-dd hh:mm');
              }
            } else {//去年及去年以前
              that.commentList[i].showTm = config.formatTime(that.commentList[i].Tm, 'yyyy-MM-dd hh:mm');
            }
          }
          if (data.length >= 10) {
            commentParams.offset = commentParams.offset + 1;
            commentParams.noMore = true;
          } else {
            commentParams.noMore = false;
          }
          that.$nextTick(function () {
            that.commentLoading = true;
            commentParams.loadingMore = false;
          });
        }).catch(function (data) {
          commentParams.loadingMore = false;
          console.log("************error", data);
        });
      },
      //刷新详情
      refreshNOIDDetail: function () {
        if (!config.session.user_id) {
          this.$emit('getNoIDDetail');
        } else {
          this.$emit("getPageInfo");
        }
      },
      getPageInfo: function () {
        var that = this;
        if (!that.id) return;
        var param = {
          ac_id: that.id,
          feed_id: config.session.feed_id,
          user_id: config.session.user_id
        };
        var info;
        //TODO res
        api.activeInfo(param, {loading: that.initFlag, control: true}).then(function (data) {
          that.res = data;

          // 埋点
          var toonType;
          if (!config.session.toon_type) {
            toonType = config.toon_type ? config.toon_type : "100";
          } else {
            toonType = config.session.toon_type;
          }
          buriedPoint({activity_id: that.id, activity_name: data.title, toon_type: toonType});

          that.$emit("getApplyStatistics");
          that.res.typeText = that.activeType[that.res.type * 1];
          that.res.checkType = that.res.checktype == '1' ? '审核' : '开放';
          that.activity_code = data.code;
          that.activity_id = data.id;
          var s_year = config.formatTime(that.res.start_time, 'yyyy-MM-dd');
          var e_year = config.formatTime(that.res.end_time, 'yyyy-MM-dd');
          var s_sign_year = config.formatTime(that.res.checkin_start_time, 'yyyy-MM-dd');
          var e_sign_year = config.formatTime(that.res.checkin_end_time, 'yyyy-MM-dd');
          if (s_year == e_year) {
            that.activeSTime = config.formatTime(that.res.start_time, 'MM月dd日D hh:mm');
            that.activeETime = config.formatTime(that.res.end_time, 'hh:mm');
          } else {
            that.activeSTime = config.formatTime(that.res.start_time, 'MM月dd日D hh:mm');
            that.activeETime = config.formatTime(that.res.end_time, 'MM月dd日D hh:mm');
          }
          if (s_sign_year == e_sign_year) {
            that.activeSignSTime = config.formatTime(that.res.checkin_start_time, 'MM月dd日D hh:mm');
            that.activeSignETime = config.formatTime(that.res.checkin_end_time, 'hh:mm');
          } else {
            that.activeSignSTime = config.formatTime(that.res.checkin_start_time, 'MM月dd日D hh:mm');
            that.activeSignETime = config.formatTime(that.res.checkin_end_time, 'MM月dd日D hh:mm');
          }
          that.applyETime = config.formatTime(that.res.apply_end_time, 'MM月dd日D hh:mm');
          that.showDes = that.res.description ? that.res.description.replace(/\r\n/g, "<br>").replace(/\r/g, "<br>").replace(/\n/g, "<br>").replace(/\s/g, "&nbsp;").replace("img&nbsp;src", "img src") : null;

          if ((that.res.description.length > 200 && that.res.images.length > 3) || that.res.description.length > 200 || that.res.images.length > 3 || (that.res.description.length < 200 && that.res.images.length > 1)) {
            that.showIntro = 0;
          }

          //todo 分享
          if (that.res.flag != -1 && that.res.status == 1 && that.res.is_group == 0) {//设置分享
            var toonParams = {
              code: that.res.code
            }
            toongine.page.setShareInfo({
              params: {
                channels: ['shareToon', 'shareToonCircle', 'shareWeChat', 'shareWeChatCircle', 'shareWeiBo', 'shareQQ', 'shareQQSpace'],
                shareToon: {
                  title: data.title,
                  describe: that.activeSTime + '-' + that.activeETime + '\n' + that.res.locate,
                  targetUrl: config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code=' + that.res.code + '&cardtype=1&scheme=toon',
                  iconUrl: data.img.url,
                  toonProtocolUrl: 'toon://toongineapp/shareback?params=' + JSON.stringify(toonParams)
                },
                shareToonCircle: {
                  title: data.title,
                  describe: that.activeSTime + '-' + that.activeETime + '\n' + that.res.locate,
                  targetUrl: config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code=' + that.res.code + '&cardtype=1&scheme=toon',
                  iconUrl: data.img.url,
                  toonProtocolUrl: 'toon://toongineapp/shareback?params=' + JSON.stringify(toonParams)
                },
                shareWeChat: {
                  title: data.title,
                  describe: that.activeSTime + '-' + that.activeETime + '\n' + that.res.locate,
                  targetUrl: config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code=' + that.res.code + '&cardtype=1&scheme=toon' + '&enter=wc',
                  iconUrl: data.img.url
                },
                shareWeChatCircle: {
                  title: data.title,
                  describe: data.title,
                  targetUrl: config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code=' + that.res.code + '&cardtype=1&scheme=toon' + '&enter=wcc',
                  iconUrl: data.img.url
                },
                shareWeiBo: {
                  title: data.title,
                  describe: data.title,
                  targetUrl: config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code=' + that.res.code + '&cardtype=1&scheme=toon' + '&enter=wb',
                  iconUrl: data.img.url
                },
                shareQQ: {
                  title: data.title,
                  describe: that.activeSTime + '-' + that.activeETime + '\n' + that.res.locate,
                  targetUrl: config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code=' + that.res.code + '&cardtype=1&scheme=toon' + '&enter=qq',
                  iconUrl: data.img.url
                },
                shareQQSpace: {
                  title: data.title,
                  describe: that.activeSTime + '-' + that.activeETime + '\n' + that.res.locate,
                  targetUrl: config.share_url + '/toon/activity.html?module=toongineapp&path=shareback&code=' + that.res.code + '&cardtype=1&scheme=toon' + '&enter=qqs',
                  iconUrl: data.img.url
                }
              }
            })

          }

          that.$nextTick(function () {
            that.loadComplete = true;
            that.$emit("getCommentList");
            if (that.loadComplete == true) {
              config.loading(false, "/activity/detailactivity" + "  2"); // 隐藏加载框---因详情页资源多，需要加载完再关loading，否则空白页时间太长
              that.$emit('getMakeCode');
              //that.$emit('getShaiCode');
            }

          });
          if (that.res.mixstatus == 1 && that.isApply) {
            that.goApply();
          }
        }).catch(function (data) {
          info = data;
          if (info.code && info.code == '-1') {
            that.curPageName = "";
            that.$router.replace({name: "del", query: {text: info.msg}});
          } else if (info.code && info.code != '0') {
            // alert(info.msg);
          }
        });
      },
      getNoIDDetail: function () {
        var that = this;
        var param = {
          ac_id: that.id,
          feed_id: config.session.feed_id,
          user_id: config.session.user_id
        };
        var info;
        api.noIDActiveInfo(param, {loading: that.initFlag, control: true}).then(function (data) {
          data.exportMark = "-1";
          that.res = data;
          that.res.typeText = that.activeType[that.res.type * 1];
          that.res.checkType = that.res.checktype == '1' ? '审核' : '开放';
          //that.heartJump = that.res.islove == 1 ? true : false;
          //that.res.heartList = that.res.heartList ? that.res.heartList :[];
          var s_year = config.formatTime(that.res.start_time, 'yyyy-MM-dd');
          var e_year = config.formatTime(that.res.end_time, 'yyyy-MM-dd');
          var s_sign_year = config.formatTime(that.res.checkin_start_time, 'yyyy-MM-dd');
          var e_sign_year = config.formatTime(that.res.checkin_end_time, 'yyyy-MM-dd');
          if (s_year == e_year) {
            that.dateFlag = true;
            that.activeSTime = config.formatTime(that.res.start_time, 'MM月dd日D hh:mm');
            that.activeETime = config.formatTime(that.res.end_time, 'hh:mm');
          } else {
            that.dateFlag = false;
            that.activeSTime = config.formatTime(that.res.start_time, 'MM月dd日D hh:mm');
            that.activeETime = config.formatTime(that.res.end_time, 'MM月dd日D hh:mm');
          }
          if (s_sign_year == e_sign_year) {
            that.activeSignSTime = config.formatTime(that.res.checkin_start_time, 'MM月dd日D hh:mm');
            that.activeSignETime = config.formatTime(that.res.checkin_end_time, 'hh:mm');
          } else {
            that.activeSignSTime = config.formatTime(that.res.checkin_start_time, 'MM月dd日D hh:mm');
            that.activeSignETime = config.formatTime(that.res.checkin_end_time, 'MM月dd日D hh:mm');
          }
          that.applyETime = config.formatTime(that.res.apply_end_time, 'MM月dd日D  hh:mm');
          that.showDes = that.res.description ? that.res.description.replace(/\r\n/g, "<br>").replace(/\r/g, "<br>").replace(/\n/g, "<br>").replace(/\s/g, "&nbsp;").replace("img&nbsp;src", "img src") : null;
          if ((that.res.description.length > 200 && that.res.images.length > 3) || that.res.description.length > 200 || that.res.images.length > 3 || (that.res.description.length < 200 && that.res.images.length > 1)) {
            that.showIntro = 0;
          }


          that.$nextTick(function () {
            that.loadComplete = true;
            that.$emit("getCommentList");
            if (that.loadComplete == true) {
              setTimeout(function () {
                config.loading(false, "/activity/detailactivity" + "  2"); // 隐藏加载框---因详情页资源多，需要加载完再关loading，否则空白页时间太长
                that.$emit('getMakeCode');
              }, 600);
            }
          });
        }).catch(function (data) {
          info = data;
          if (info.code && info.code == '-1') {
            that.curPageName = "";
            that.$router.replace({name: "del", query: {text: info.msg}});
          } else if (info.code && info.code != '0') {
            alert(info.msg);
          }
        });
      },
      //选择名片
      chooseCard: function () {
        var that = this;
        that.isApply = true;
        function callbackfun(e) {
          if (e.result == "cancel") {
            return false;
          }
          that.feed = e;
          that.$emit("loginNoID");
        }

        toonCall({
          "type": "0"
        }, "card/chooseCard", callbackfun);
      },
      //无身份登录
      loginNoID: function () {
        var that = this;
        config.loading(true);
        var param = {
          feed_id: this.feed.feedId,
          user_id: this.feed.userId
        };
        var opt = {
          loading: false
        };
        return api.noIDLogin(param, opt).then(function (data) {
          config.session = data;
          that.$emit("getPageInfo");
        }).catch(function (err) {
          alert("请求失败");
        });
      }
    }
  });
  return module;
});
