/**
 *index-list
 *首页模块
 *     --Created by Li Yubo on 2016/10/31 9:45.
 */
define(["vue", "common/iscrollpage", "common/config", "common/api", "text!tplPath/no-index-list.html"], function (Vue, IscrollFactory, config, api, tpl) {
  var indexModule = {};
  indexModule.offset = 0;
  indexModule.limit = 10;
  indexModule.myOffset = 0;
  indexModule.loadingMyListFlag = false;
  indexModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        showTap: 1,
        showMyTap: 1,
        indexListData: [],
        indexList: [],
        indexPanList: [],
        indexGroupList: [],
        bannerList: [],
        myListData: [],
        noMyListData: false,
        isMoreMyList: true,
        isShowText: false,
        typeMark: config.session.mark,
        cardFlag: null,
        loadComplete: false,
        isMoreDate: false,
        changeTabFlag: true,
        start_time: this.start_time,
      }
    },
    ready: function () {
      indexModule.init(this);
    },
    created: function () {
      if (!this.typeMark) {
        this.timeDownActive();
      } else {
        this.timeDownGroup();
      }
      this.getBannerDate();
      this.selsetedCity();
      //this.sticky();
    },
    watch: {
      "indexListData": function (val, oldVal) {
        if (val.length > 0) {
          if (document.getElementById("pullUpIcon"))document.getElementById("pullUpIcon").style.visibility = "visible";
          if (document.getElementById("pullUpLabel"))document.getElementById("pullUpLabel").style.visibility = "visible";
        }
      }
    },
    route: {
      data: function (transition) {
        transition.next();
        setTimeout(function () {
          if (indexModule.scroller1) {
            indexModule.scroller1.myScroll.refresh();
          }
        }, 500);
      },
      activate: function (transition) {
        indexModule.offset = 0;
        indexModule.limit = 10;
        transition.next();
        this.$emit("getIndexList");
        config.loading(true);
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      //跳转搜索页
      goSearch: function () {
        this.$router.go({name: "search"});
      },
      //切换底部tap
      changeTap: function (index) {
        //重复点击相同tap不响应
        if (this.showTap === index) {
          return;
        }
        this.showTap = index;
        //如果切换到我的活动且我的活动列表为空，查询
        if (index === 2 && this.myListData.length === 0) {
          indexModule.myOffset = 0;
          this.$emit("getMyList");
        } else {
          this.$nextTick(function () {
            indexModule.scroller1.myScroll.refresh();
          });
        }
      },
      //切换我的活动顶部tap
      changeMyActive: function (index) {
        //重复点击相同tap不响应
        if (this.showMyTap === index) {
          return;
        }
        indexModule.myOffset = 0;
        this.isMoreMyList = true;
        this.isShowText = false;
        this.myListData = [];
        this.showMyTap = index;
        this.$emit("getMyList");
      },
      changeActiveTap: function (index) {

        indexModule.myOffset = 0;
        //this.listData = [];
        this.isMoreDate = true;
        this.showMyTap = index;
        if (index === 1) {
          this.$emit("getIndexList");
        } else if (index === 2) {
          this.$emit("getIndexModuleList");
        }
      },
      //跳转发布页
      goAddActive: function () {
        this.$router.go({name: "add-active"});
      },
      //跳转详情页
      goDetail: function (index) {
        //TODO 根据浏览器UA判断是否在toon内，如果在toon内跳转内部无身份详情，否则跳外部详情
        var obj = this.indexListData[index];
        var toonType;
        if (!config.session.toon_type) {
          toonType = config.toon_type ? config.toon_type : "100";
        } else if (config.session.toon_type == '102') {
          toonType = "102";
        } else {
          toonType = "100";
        }
        if (navigator.userAgent.indexOf("toon") < 0 && navigator.userAgent.indexOf("Toon") < 0) {
          //TODO 调试完解注释
          location.href = location.origin + "/share/shareactivity" + "?entry=101&ac_id=" + obj.id + "&toon_type=" + toonType;
//                    this.$router.go({name:"no-active-info",query:{"id":obj.uuid}})
        } else {
          this.$router.go({name: "no-active-info", query: {"id": obj.uuid}})
        }

        //this.$router.go({name:"active-info",query:{"id":obj.id}});
        //this.$router.go({path:"/index-list/active-info",query:{"id":obj.id}});
      },
      //跳转我的活动详情页
      goMyDetail: function (index) {
        var obj = this.myListData[index];
        //this.$router.go({name:"active-info",query:{"id":obj.id}});
        this.$router.go({path: "/index-list/active-info", query: {"id": obj.uuid}});
      },
      //跳转类型搜索
      goTypeSearch: function (type) {
        this.$router.go({name: "search", query: {"type": type}});
      },
      //
      onScrollMyList: function (e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          //如果有更多数据 或者没有加载中，执行
          if (this.isMoreMyList && !indexModule.loadingMyListFlag)this.$emit("getMyList");
        }

        //超出一屏显示 "底线"
        var winHeight = document.body.clientHeight;
        //加上页脚高度，消除误差
        var footHeight = document.getElementById("index-fade-foot").offsetHeight;

        //if(scrollTop+footHeight>winHeight){
        //    this.isShowText = true;
        //}else{
        //    this.isShowText = false;
        //}

      },
      selsetedCity: function () {
        var that = this;
        var city_id = that.$route.query.city_id;
        //console.log("city_id",city_id);
        if (city_id) {
          var city_name = that.$route.query.city_name;
          that.city_name = city_name;
        } else {
          toongine.location.getLocation({
            callback: function (res) {
              console.log(JSON.stringify(res))
              if (res.data.city) {
                that.city_name = res.data.city
              }
            }
          })

        }
        //that.$emit("getIndexList");
      },
      getBannerDate: function () {
        var that = this;
        var param = {};
        api.getBannerDate(param).then(function (data) {
          data = data ? data : [];
          that.bannerList = data.dataList;
          that.$nextTick(function () {
            //new bannerScorll(document.getElementById('banner'), 30)
            var mySwiper = new Swiper(".swiper-container-banner", {
              direction: "horizontal",
              loop: true,
              pagination: ".swiper-pagination",
              autoplay: 5000,
              autoplayDisableOnInteraction: false
            })
          })

        });

      },
      //活动倒计时
      timeDownActive: function () {
        var that = this;
        var param = {};
        api.getIndexList(param, {loading: false}).then(function (data) {
          //data = data?data:[];
          //that.indexListData = data.list;
          that.indexList = [];
          var startTimeList = [];
          data.list.map(function (item, index) {
            var obj = {};
            item.now_time = Math.floor(new Date().getTime() / 1000);
            obj.now_time = item.now_time;
            obj.hasTime = config.formateTimes(item.start_time);
            obj.start_time = item.start_time;
            obj.img = item.img;
            obj.title = item.title;
            obj.end_time = item.end_time;
            obj.locate = item.locate;
            obj.price = item.price;
            obj.latitude = item.latitude;
            obj.longtitude = item.longtitude;
            obj.publicity = item.publicity;
            obj.ac_status = item.ac_status;
            obj.is_group = item.is_group;
            that.indexList.push(obj);
            startTimeList.push(item.start_time)
          });
          var timer = setInterval(function () {
            startTimeList.map(function (item, index) {
              item = item - 1000; //1s后才动，所以要-1s
              that.indexList[index].hasTime = config.formateTimes(item);
            })
          }, 1000);
          console.log("indexList", that.indexList);
          that.$nextTick(function () {
            that.timeDownRec();
          })
        });
      },
      //推荐倒计时
      timeDownRec: function () {
        var that = this;
        var param = {};
        api.getIndexModuleList(param, {loading: false}).then(function (data) {
          //data = data?data:[];
          //that.indexListData = data.list;
          that.indexPanList = [];
          var startTimeList = [];
          data.map(function (item, index) {
            var obj = {};
            item.now_time = Math.floor(new Date().getTime() / 1000);
            obj.now_time = item.now_time;
            obj.hasTime = config.formateTimes(item.start_time);
            obj.start_time = item.start_time;
            obj.img = item.img;
            obj.title = item.title;
            obj.end_time = item.end_time;
            obj.locate = item.locate;
            obj.price = item.price;
            obj.latitude = item.latitude;
            obj.longtitude = item.longtitude;
            obj.publicity = item.publicity;
            obj.is_group = item.is_group;
            obj.ac_status = item.ac_status;
            that.indexPanList.push(obj);
            startTimeList.push(item.start_time)
          });
          var timer = setInterval(function () {
            startTimeList.map(function (item, index) {
              item = item - 1000; //1s后才动，所以要-1s
              that.indexPanList[index].hasTime = config.formateTimes(item);
            })
          }, 1000);
          console.log("indexPanList", that.indexPanList);
        });
      },
      //小组倒计时
      timeDownGroup: function () {
        var that = this;
        var param = {};
        api.getIndexList(param, {loading: false}).then(function (data) {
          //data = data?data:[];
          //that.indexListData = data.list;
          that.indexGroupList = [];
          var startTimeList = [];
          //console.log("data",data.list)
          data.map(function (item, index) {
            var obj = {};
            item.now_time = Math.floor(new Date().getTime() / 1000);
            obj.now_time = item.now_time;
            obj.hasTime = config.formateTimes(item.start_time);
            obj.start_time = item.start_time;
            obj.img = item.img;
            obj.title = item.title;
            obj.end_time = item.end_time;
            obj.locate = item.locate;
            obj.price = item.price;
            obj.publicity = item.publicity;
            obj.latitude = item.latitude;
            obj.longtitude = item.longtitude;
            obj.ac_status = item.ac_status;
            obj.is_group = item.is_group;
            that.indexGroupList.push(obj);
            startTimeList.push(item.start_time)
          });
          var timer = setInterval(function () {
            startTimeList.map(function (item, index) {
              item = item - 1000; //1s后才动，所以要-1s
              that.indexGroupList[index].hasTime = config.formateTimes(item);
            })
          }, 1000);
          console.log("indexList", that.indexList);
        });
      },
    },
    events: {
      getIndexList: function () {
        var thisModule = this;
        var param = {
          flag: 1,
          offset: indexModule.offset,
          limit: indexModule.limit
        };
        return api.getNoIDIndexList(param, {loading: false}).then(function (data) {
          data = data ? data : [];
          thisModule.indexListData = data.list;

          if (data.length < indexModule.limit) {
            indexModule.switchPullUpText(false);
          }
          if (thisModule.indexListData.length)indexModule.offset = thisModule.indexListData[thisModule.indexListData.length - 1].id;
          thisModule.$nextTick(function () {
            thisModule.loadComplete = true;
            indexModule.scroller1.myScroll.refresh();
          });
          if (thisModule.$route.query.city_id) {
            thisModule.getIndexList = thisModule.getIndexList.filter(function (item) {
              return item.city_id === thisModule.$route.query.city_id;
            })
          }
          config.loading(false);
        }).catch(function (err) {
          config.loading(false);
          indexModule.scroller1.myScroll.refresh();
          alert("获取活动失败");
        });
      },
      getIndexModuleList: function () {
        var thisModule = this;
        var param = {
//                    offset:indexModule.offset,
//                    limit:indexModule.limit
        };
        return api.getIndexModuleList(param, {loading: false}).then(function (data) {
          data = data ? data : [];
          thisModule.indexListData = data;
          console.log(thisModule.indexListData);
          //console.log(JSON.stringify(thisModule.indexListData));
          if (data.length < indexModule.limit) {
            indexModule.switchPullUpText(false);
          }
          if (data.length === 0 && indexModule.offset === 0) {
            thisModule.noMyListData = true;
          } else {
            thisModule.noMyListData = false;
          }
          //if(thisModule.indexListData.length)indexModule.offset = thisModule.indexListData[thisModule.indexListData.length-1].id;
          thisModule.$nextTick(function () {
            thisModule.loadComplete = true;
            indexModule.scroller1.myScroll.refresh();
          });
          //config.loading(false);
        }).catch(function (err) {
          //config.loading(false);
          indexModule.scroller1.myScroll.refresh();
          alert("获取活动失败");
        });
      },
      getGroupList: function () {
        var thisModule = this;
        var param = {
          //g_feed_id:data.g_feed_id,
          offset: indexModule.offset,
          limit: indexModule.limit
        };
        //param.g_feed_id = data.g_feed_id;

        return api.getIndexList(param, {loading: false}).then(function (data) {
          data = data ? data : [];
          if (indexModule.offset === 0) {
            thisModule.indexListData = data;
          } else {
            thisModule.indexListData = thisModule.indexListData.concat(data);
          }
          if (data.length < indexModule.limit && data.length > 0) {
            indexModule.switchPullUpText(false);
          }
          if (data.length === 0 && indexModule.offset === 0) {
            thisModule.noMyListData = true;
          } else {
            thisModule.noMyListData = false;
          }
          if (thisModule.indexListData.length)indexModule.offset = thisModule.indexListData[thisModule.indexListData.length - 1].id;
          thisModule.$nextTick(function () {
            thisModule.loadComplete = true;
            indexModule.scroller1.myScroll.refresh();
          });
          //config.loading(false);
        }).catch(function (err) {
          //config.loading(false);
          indexModule.scroller1.myScroll.refresh();
          alert("获取活动失败");
        });
      },
      getMyList: function () {
        var thisModule = this;
        indexModule.loadingMyListFlag = true;
        var param = {
          flag: 1,
          offset: indexModule.myOffset,
          limit: indexModule.limit
        };
        var opt = {
          showMyTap: this.showMyTap
        };
        if (indexModule.myOffset === 0) {
          opt.loading = true;
        } else {
          opt.loading = false;
        }
        return api.getMyList(param, opt).then(function (data) {
          data = data ? data : [];
          thisModule.myListData = thisModule.myListData.concat(data);

          //如果第一页没数据，显示没数据的提示
          if (indexModule.myOffset === 0 && data.length === 0) {
            thisModule.noMyListData = true;
            thisModule.isMoreMyList = false;
          } else if (data.length < indexModule.limit) {
            thisModule.noMyListData = false;
            thisModule.isMoreMyList = false;
          } else {
            thisModule.noMyListData = false;
            thisModule.isMoreMyList = true;
          }
          if (thisModule.myListData.length >= 3) {
            thisModule.isShowText = true;
          }
          if (thisModule.myListData.length)indexModule.myOffset = thisModule.myListData[thisModule.myListData.length - 1].id;
          thisModule.$nextTick(function () {
            indexModule.loadingMyListFlag = false;
          });
        }).catch(function (err) {
          indexModule.loadingMyListFlag = false;
          alert("获取我的活动失败");
        });
      },
      refreshIndex: function () {
        indexModule.offset = 0;
        this.$emit("getIndexList");
        indexModule.myOffset = 0;
        this.$emit("getMyList");
      }
    }
  });
  indexModule.init = function (thisModule) {
    indexModule.scroller1 = new IscrollFactory('index-wrapper', {
      probeType: 2,
      bounceTime: 250,
      bounceEasing: 'quadratic',
      mouseWheel: false,
      scrollbars: false,
      fadeScrollbars: true,
      preventDefault: false,
      interactiveScrollbars: false,
      deceleration: 0.003//default 0.0006
    }, pullDownAction, pullUpAction);
    indexModule.scroller1.init();
    setTimeout(function () {
      indexModule.scroller1.myScroll.refresh();
    }, 500);

    document.getElementById("index-wrapper").addEventListener('touchmove', function (e) {
      e.preventDefault();
    }, false);

    //下拉刷新
    function pullDownAction(theScroller) {
      indexModule.offset = 0;
      thisModule.$emit("getIndexList");
    }

    //上拉加载
    function pullUpAction(theScroller) {
      var param = {
        flag: 1,
        offset: indexModule.offset,
        limit: indexModule.limit
      };
      return api.getNoIDIndexList(param, {loading: false}).then(function (data) {
        data = data ? data : [];
        for (var i = 0; i < data.length; i++) {
          thisModule.indexListData.push(data[i]);
        }
        if (data.length < indexModule.limit) {
          indexModule.switchPullUpText(false);
        }
        if (thisModule.indexListData.length)indexModule.offset = thisModule.indexListData[thisModule.indexListData.length - 1].id;

        thisModule.$nextTick(function () {
          indexModule.scroller1.myScroll.refresh();
        });
      }).catch(function (err) {
        indexModule.scroller1.myScroll.refresh();
        alert("获取活动失败");
      });
    }
  };
  indexModule.switchPullUpText = function (more) {
    var el = document.getElementById("pullUp");
    if (!el) {
      return;
    }
    if (more) {
      el.innerHTML = '<span class="pullUpIcon" id="pullUpIcon"></span><span id="pullUpLabel" class="pullUpLabel">上拉加载更多...</span>';
    } else {
      el.setAttribute("class", "no-data-text");
      el.innerHTML = '—— 我是有底线的 ——';
    }
  };
  return indexModule.module;
});