/**
 *index-list
 *首页模块
 *     --Created by Li Yubo on 2016/10/31 9:45.
 */
define(["vue", "common/iscrollpage", "common/config", "common/api", "text!tplPath/open-index-list.html"], function (Vue, IscrollFactory, config, api, tpl) {
  var indexModule = {};
  indexModule.offset = 0;
  indexModule.limit = 10;
  indexModule.myOffset = 0;
  indexModule.loadingMyListFlag = false;
  indexModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        showTap: 1,
        showMyTap: 1,
        indexListData: [],
        myListData: [],
        noMyListData: false,
        isMoreMyList: true,
        isShowText: false,
        typeMark: config.session.mark,
        mark: null
      }
    },
    ready: function () {
      indexModule.init(this);
    },
    watch: {
      "indexListData": function (val, oldVal) {
        if (val.length > 0) {
          if (document.getElementById("pullUpIcon"))document.getElementById("pullUpIcon").style.visibility = "visible";
          if (document.getElementById("pullUpLabel"))document.getElementById("pullUpLabel").style.visibility = "visible";
        }
      }
    },
    route: {
      data: function (transition) {
        transition.next();
        setTimeout(function () {
          if (indexModule.scroller1) {
            indexModule.scroller1.myScroll.refresh();
          }
        }, 500);
      },
      activate: function (transition) {
        indexModule.offset = 0;
        indexModule.limit = 10;
        this.mark = config.session.mark ? "2" : "1";
        transition.next();
        this.$emit("getIndexList");
        config.loading(true);
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      //跳转搜索页
      goSearch: function () {
        this.$router.go({name: "search"});
      },
      //切换底部tap
      changeTap: function (index) {
        //重复点击相同tap不响应
        if (this.showTap === index) {
          return;
        }
        this.showTap = index;
        //如果切换到我的活动且我的活动列表为空，查询
        if (index === 2 && this.myListData.length === 0) {
          indexModule.myOffset = 0;
          this.$emit("getMyList");
        } else {
          this.$nextTick(function () {
            indexModule.scroller1.myScroll.refresh();
          });
        }
      },
      //切换我的活动顶部tap
      changeMyActive: function (index) {
        //重复点击相同tap不响应
        if (this.showMyTap === index) {
          return;
        }
        indexModule.myOffset = 0;
        this.isMoreMyList = true;
        this.isShowText = false;
        this.myListData = [];
        this.showMyTap = index;
        this.$emit("getMyList");
      },
      //跳转发布页
      goAddActive: function () {
        this.$router.go({name: "add-active"});
      },
      //跳转详情页
      goDetail: function (index) {
        //TODO 根据浏览器UA判断是否在toon内，如果在toon内跳转内部无身份详情，否则跳外部详情
        var obj = this.indexListData[index];
        if (navigator.userAgent.indexOf("toon") < 0 && navigator.userAgent.indexOf("Toon") < 0) {
          //location.href = location.origin+location.pathname.replace("index.html","activity/shareactivity")+"?entry=101&ac_id="+obj.id;
          location.href = location.origin + "/share/shareactivity" + "?entry=101&ac_id=" + obj.id;
        } else {
          this.$router.go({name: "no-active-info", query: {"id": obj.uuid}})
        }

        //this.$router.go({name:"active-info",query:{"id":obj.id}});
        //this.$router.go({path:"/index-list/active-info",query:{"id":obj.id}});
      },
      goDetailById: function (param) {
        var that = this;
        var activeId = param;
        console.log("活动id----", activeId);
        that.$router.go({path: "/open-index-list/active-info", query: {"id": activeId}});
      },
      //跳转我的活动详情页
      goMyDetail: function (index) {
        var obj = this.myListData[index];
        //this.$router.go({name:"active-info",query:{"id":obj.id}});
        this.$router.go({path: "/index-list/active-info", query: {"id": obj.uuid}});
      },
      //跳转类型搜索
      goTypeSearch: function (type) {
        this.$router.go({name: "search", query: {"type": type}});
      },
      //
      onScrollMyList: function (e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          //如果有更多数据 或者没有加载中，执行
          if (this.isMoreMyList && !indexModule.loadingMyListFlag)this.$emit("getMyList");
        }

        //超出一屏显示 "底线"
        var winHeight = document.body.clientHeight;
        //加上页脚高度，消除误差
        var footHeight = document.getElementById("index-fade-foot").offsetHeight;

        //if(scrollTop+footHeight>winHeight){
        //    this.isShowText = true;
        //}else{
        //    this.isShowText = false;
        //}

      }
    },
    events: {
      getIndexList: function () {
        var thisModule = this;
        var param = {
          offset: indexModule.offset,
          limit: indexModule.limit,
          fid: config.session.feed_id,
          mark: thisModule.mark,
          frame: config.session.frame
        };
        return api.shareGetOpenList(param, {loading: false}).then(function (data) {
          data = data ? data : [];
          thisModule.indexListData = data;

          if (data.length < indexModule.limit) {
            indexModule.switchPullUpText(false);
          }
          if (thisModule.indexListData.length)indexModule.offset = thisModule.indexListData[thisModule.indexListData.length - 1].id;
          thisModule.$nextTick(function () {
            indexModule.scroller1.myScroll.refresh();
          });
          config.loading(false);
        }).catch(function (err) {
          config.loading(false);
          indexModule.scroller1.myScroll.refresh();
          alert("获取活动失败");
        });
      },
      getMyList: function () {
        var thisModule = this;
        indexModule.loadingMyListFlag = true;
        var param = {
          flag: 1,
          offset: indexModule.myOffset,
          limit: indexModule.limit
        };
        var opt = {
          showMyTap: this.showMyTap
        };
        if (indexModule.myOffset === 0) {
          opt.loading = true;
        } else {
          opt.loading = false;
        }
        return api.getMyList(param, opt).then(function (data) {
          data = data ? data : [];
          thisModule.myListData = thisModule.myListData.concat(data);

          //如果第一页没数据，显示没数据的提示
          if (indexModule.myOffset === 0 && data.length === 0) {
            thisModule.noMyListData = true;
            thisModule.isMoreMyList = false;
          } else if (data.length < indexModule.limit) {
            thisModule.noMyListData = false;
            thisModule.isMoreMyList = false;
          } else {
            thisModule.noMyListData = false;
            thisModule.isMoreMyList = true;
          }
          if (thisModule.myListData.length >= 3) {
            thisModule.isShowText = true;
          }
          if (thisModule.myListData.length)indexModule.myOffset = thisModule.myListData[thisModule.myListData.length - 1].id;
          thisModule.$nextTick(function () {
            indexModule.loadingMyListFlag = false;
          });
        }).catch(function (err) {
          indexModule.loadingMyListFlag = false;
          alert("获取我的活动失败");
        });
      },
      refreshIndex: function () {
        indexModule.offset = 0;
        this.$emit("getIndexList");
        indexModule.myOffset = 0;
        this.$emit("getMyList");
      }
    }
  });
  indexModule.init = function (thisModule) {
    indexModule.scroller1 = new IscrollFactory('index-wrapper', {
      probeType: 2,
      bounceTime: 250,
      bounceEasing: 'quadratic',
      mouseWheel: false,
      scrollbars: false,
      fadeScrollbars: true,
      preventDefault: false,
      interactiveScrollbars: false,
      deceleration: 0.003//default 0.0006
    }, pullDownAction, pullUpAction);
    indexModule.scroller1.init();
    setTimeout(function () {
      indexModule.scroller1.myScroll.refresh();
    }, 500);

    document.getElementById("index-wrapper").addEventListener('touchmove', function (e) {
      e.preventDefault();
    }, false);

    //下拉刷新
    function pullDownAction(theScroller) {
      indexModule.offset = 0;
      thisModule.$emit("getIndexList");
    }

    //上拉加载
    function pullUpAction(theScroller) {
      var param = {
        flag: 1,
        offset: indexModule.offset,
        limit: indexModule.limit
      };
      return api.getIndexList(param, {loading: false}).then(function (data) {
        data = data ? data : [];
        for (var i = 0; i < data.length; i++) {
          thisModule.indexListData.push(data[i]);
        }
        if (data.length < indexModule.limit) {
          indexModule.switchPullUpText(false);
        }
        if (thisModule.indexListData.length)indexModule.offset = thisModule.indexListData[thisModule.indexListData.length - 1].id;

        thisModule.$nextTick(function () {
          indexModule.scroller1.myScroll.refresh();
        });
      }).catch(function (err) {
        indexModule.scroller1.myScroll.refresh();
        alert("获取活动失败");
      });
    }
  };
  indexModule.switchPullUpText = function (more) {
    var el = document.getElementById("pullUp");
    if (!el) {
      return;
    }
    if (more) {
      el.innerHTML = '<span class="pullUpIcon" id="pullUpIcon"></span><span id="pullUpLabel" class="pullUpLabel">上拉加载更多...</span>';
    } else {
      el.setAttribute("class", "no-data-text");
      el.innerHTML = '—— 我是有底线的 ——';
    }
  };
  return indexModule.module;
});