/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "jq", "common/config", "common/api", "common/qrcode", "text!tplPath/qr-code.html"], function (Vue, $, config, api, Qrcode, tpl) {
  var codeModule = {};
  codeModule.init = function ($el, url) {
    var that = this;
    var qrcode = new QRCode($el, {
      width: 360,//设置宽高
      height: 360
    });
    qrcode.makeCode(url);
  };
  codeModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        id: null,
        url: null,
        el: null,
        title: null
      }
    },
    ready: function () {
      var that = this;
      that.el = document.getElementById("qr-code");
      codeModule.init(that.el, that.url);

      setTimeout(function () {
        var $img = that.el.getElementsByTagName("img")[0];
        var opacityImg = document.getElementById("qr-opacity");
        opacityImg.src = $img.src;
      }, 500);
    },
    route: {
      activate: function (transition) {
        var that = this;
        var param = JSON.parse(that.$route.query.param);
        that.id = param.id;
        that.url = param.url;
        that.title = param.title;
        //console.log("pipeline list vue.route.activate");
        transition.next();
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      //返回详情
      goInfo: function () {
        var that = this;
        history.back();
      }
    },
    events: {}
  });
  return codeModule.module;
});