/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "text!tplPath/register-list-page.html"], function (Vue, config, api, tpl) {
  var registerModule = {};
  registerModule.offset = 0;
  registerModule.limit = 10;
  registerModule.loadingFlag = false;
  registerModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        showExport: false,
        id: 0,
        listData: [],
        email: "",
        isShowText: false,
        isMoreDate: true,
        flag: null,
        show: false,
        noMyListData: false,
        loadingMore: false,
        initFlag: true
      }
    },
    ready: function () {

    },
    route: {
      activate: function (transition) {
        registerModule.offset = 0;
        this.initFlag = true;
        this.id = this.$route.query.id;
        this.flag = this.$route.query.flag;

        //处理并先行显示传过来的报名列表数据
//                var listTemp = JSON.parse(this.$route.query.applyList);

        /*                for(var i=0;i<listTemp.length;i++){
         //更多信息是否展开变量设置
         if(!listTemp[i].cus_info){
         listTemp[i].moreInfo = false;
         listTemp[i].showInfo = false;
         continue;
         }
         listTemp[i].cus_info = JSON.parse(listTemp[i].cus_info);
         listTemp[i].moreInfo = listTemp[i].cus_info.length>2?true:false;
         listTemp[i].showInfo = false;

         //提取姓名&手机字段
         listTemp[i].mainInfo ={};
         for(var j=0;j<listTemp[i].cus_info.length;j++){
         if(listTemp[i].cus_info[j].id == "1"){
         listTemp[i].mainInfo.name=listTemp[i].cus_info[j].value;
         }else if(listTemp[i].cus_info[j].id == "2"){
         listTemp[i].mainInfo.phone=listTemp[i].cus_info[j].value;
         }
         if(listTemp[i].mainInfo.name && listTemp[i].mainInfo.phone ){
         break;
         }
         }
         }*/
//                this.listData = listTemp;
//                var len = this.listData.length;
//                if(len < registerModule.limit){
//                    this.isMoreDate = false;
//                }else{
//                    this.isMoreDate = true;
//                }
//                if(len > 0 ){
//                    registerModule.offset = this.listData[len-1].id;
//                    registerModule.isShowText = true;
//                }else{
//                    registerModule.isShowText = false;
//                }
        this.$emit("getList");
        transition.next();
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      attention: function (obj, ind) {
        var that = this;
        var type = obj.is_follow == 1 ? 0 : 1;
        var param = {
          "user_id": config.session.user_id,
          //"toUser_id":that.res.uid,
          "toUser_id": obj.uid,
          "type": type
        };
        return api.attentionUser(param, {loading: false}).then(function (data) {
          result = data;
          that.listData[ind].is_follow = obj.is_follow == 1 ? 0 : 1;
          config.toonNotify({
            type: 'follow', // 关注
            userId: config.session.user_id + '', // 当前用户id
            followUserId: obj.uid + '', // 要关注的用户id
            status: that.listData[ind].is_follow // 0：未关注、1：已关注
          });
        }).catch(function (data) {
          result = data;
          console.log("关注***************", data);
        });
      },
      showExportPop: function (action) {
        this.showExport = action;
      },
      switchInfoShowStatus: function (e, index) {
        var that = this;
        e.stopPropagation();
//                that.show = !that.show;
        this.listData[index].show = !this.listData[index].show;
      },
      skipCard: function (param) {
        if (param) {
          config.skipCard(param);
        }
      },
      skipCardCopy: function (fid) {
        if (fid && this.framFlag == "-1") {
          config.skipCard(fid);
        }
      },
      //导出名单
      exportList: function () {
        //邮箱校验
        var email = this.email || document.getElementById("register-email-input").value;
        if (email.replace(/(^s*)|(s*$)/g, "").length == 0){
          alert("输入的邮箱不能为空");
          return false;
        } else if (!email.match(new RegExp(/^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((.[a-zA-Z0-9_-]{2,3}){1,2})$/))) {
          alert("请输入正确的邮箱");
          return false;
        }
        this.showExport = false;
        var param = {
          ac_id: this.id,
          mark: 1,//1代表报名;2代表签到
          email: email
        };
        var opt = {
          loading: true
        };
        return api.exportList(param, opt).then(function (data) {
          alert("导出成功", 3000);
        }).catch(function (err) {
          alert("导出失败,请稍后再试");
        });
      },
      onScroll: function (e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        this.initFlag = false;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          //如果有更多数据 或者没有加载中，执行
          if (this.isMoreDate && !registerModule.loadingFlag)this.$emit("getList");
        }

        //超出一屏显示 "底线"
        //var winHeight = document.body.clientHeight;
        //加上页脚高度，消除误差
        //var footHeight = document.getElementById("register-fade-foot").offsetHeight;
        //if(scrollTop+footHeight>winHeight){
        //    this.isShowText = true;
        //}else{
        //    this.isShowText = false;
        //}
      }
    },
    events: {
      //获取列表
      getList: function () {
        registerModule.loadingFlag = true;
        var thisModule = this;
        thisModule.loadingMore = true;
        var param = {
          ac_id: this.id,
          type: 1,
          offset: registerModule.offset,
          limit: registerModule.limit
        };
        var opt = {
          loading: thisModule.initFlag
        };
        return api.getApprovalList(param, opt).then(function (data) {
          //if(thisModule.flag == "1"){
          //处理报名信息
          //  thisModule.listDataLength = data;
          for (var i = 0; i < data.length; i++) {
            //更多信息是否展开变量设置
            data[i].show = false;
          }
          //}
          /*                    if(thisModule.flag == "1"){
           //处理报名信息
           for(var i=0;i<data.length;i++){
           //更多信息是否展开变量设置
           data[i].moreInfo = data[i].cus_info.length>2?true:false;
           data[i].showInfo = false;

           //提取姓名&手机字段
           data[i].mainInfo ={};
           for(var j=0;j<data[i].cus_info.length;j++){
           if(data[i].cus_info[j].id == "1"){
           data[i].mainInfo.name=data[i].cus_info[j].value;
           }else if(data[i].cus_info[j].id == "2"){
           data[i].mainInfo.phone=data[i].cus_info[j].value;
           }
           if(data[i].mainInfo.name && data[i].mainInfo.phone ){
           break;
           }
           }
           }
           }*/
          if (data.length == 0 && registerModule.offset == 0) {
            thisModule.noMyListData = true;
          } else {
            thisModule.noMyListData = false;
          }
          if (data.length < registerModule.limit) {
            thisModule.isMoreDate = false;
            //thisModule.noMyListData = false;
          } else {
            thisModule.isMoreDate = true;
            //thisModule.noMyListData = false;
          }
          if (registerModule.offset == 0) {
            thisModule.listData = data;
          } else {
            thisModule.listData = thisModule.listData.concat(data);
          }
          thisModule.$nextTick(function () {
            thisModule.loadingMore = false;
            registerModule.loadingFlag = false;
            if (thisModule.listData.length) {
              registerModule.offset = thisModule.listData[thisModule.listData.length - 1].id;
              registerModule.isShowText = true;
            } else {
              registerModule.isShowText = false;
            }
          });
        }).catch(function (err) {
          alert("请求失败");
        });
      }
    }
  });
  return registerModule.module;
});