/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/iscrollpage", "common/api", "text!tplPath/search.html"], function (Vue, config, IscrollFactory, api, tpl) {
  var search = {};
  search.offset = 0;
  search.limit = 10;
  search.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        type: -1,
        title: "",
        oldTitle: "",
        listData: [],
        noData: false,
        isShowText: false,
        isMoreData: true,
        nullHeight: "0",
        fromPage: "",
        timer4: [],
        startTimeList4: [],
        amountSearch: 10
      }
    },
    ready: function () {
      search.init(this);
      this.hiddenEl()
    },
    watch: {
      "listData": function (val, oldVal) {
        if (val.length > 0) {
          if (document.getElementById("pullUpIcon")) document.getElementById("pullUpIcon").style.visibility = "visible";
          if (document.getElementById("pullUpLabel")) document.getElementById("pullUpLabel").style.visibility = "visible";
        }
      }
    },
    route: {
      activate: function (transition) {
        search.offset = 0;
        search.limit = 10;
        if (transition.from.name == "dynamic-state") {
          this.fromPage = transition.from.name;
          search.limit = 20;
        }
        var type = this.$route.query.type;
        var text = this.$route.query.text;
        //this.$emit("setTitle",text);
        if (type) {
          this.type = type;
        }
        transition.next();
        if (this.type != -1) {
          this.loadMoreType();
          this.nullHeight = "100%"
        } else {
          //TODO 12月toon IOS版本更新后去掉该条件，统一执行获得焦点
//                    if(navigator.userAgent.indexOf("Android")>=0){
//                        document.getElementById("search-title").focus();
//                    }
          document.getElementById("search-title").focus();
          this.nullHeight = (document.body.clientHeight - document.getElementById("search-page-header").offsetHeight) + "px";
        }
      },
      deactivate: function (transition) {
        document.getElementById("search-title").blur();
        this.timer4.forEach(function (time) {
          clearInterval(time);
        })
        return transition.next();
      }
    },
    methods: {
      setShowDate: function () {
        var thisModule = this;
        var len = thisModule.listData.length;
        for (var j = 0; j < len; j++) {
          for (var k = j + 1; k < len; k++) {
            if (thisModule.listData[j].timeMark == thisModule.listData[k].timeMark) {
              thisModule.listData[k].timeMark = "";
            }
          }
        }
      },
      hiddenEl: function () {
        var pullUp = document.getElementById("pullUp");
        pullUp.style.display = "none";
      },
      cleanInput: function () {
        this.title = "";
      },
      //点击搜索按钮
      doSearch: function () {
        var that = this
        toongine.device.getNetworkType({
          callback: function(res) {
            if(res.code!='0'||res.data=='none'||res.data=='unknown'||res.data=='') {
              alert('网络异常')
              return
            }
            that.$emit("getSearchList", 1);
          }
        })
      },
      loadMoreSearch: function () {
        var thisModule = this;
        search.loadingFlag = true;
        var t = this.oldTitle;
        if (!t) {
          search.loadingFlag = false;
          return;
        }
        var opt = {
          loading: false,
          type: thisModule.fromPage
        };
        var param = {
          title: t,
          offset: search.offset,
          limit: search.limit
        };
        if (thisModule.fromPage == "dynamic-state") {
          param.limit = 20;
        }
        return api.search(param, opt).then(function (data) {
          data = data || [];
          if (data.length < search.limit) {
            thisModule.isMoreData = false;
          } else {
            thisModule.isMoreData = true;
          }
          thisModule.listData = thisModule.listData.concat(data);
          if (thisModule.fromPage == "dynamic-state") {
            thisModule.setShowDate();
          }
          if (thisModule.listData.length) {
            search.offset = thisModule.listData[thisModule.listData.length - 1].activity_id;
          }
          thisModule.$nextTick(function () {
            search.loadingFlag = false;
            //if (data.length !== 0) {
            //    timeDownSearch();
            //}
            if (thisModule.listData.length >= 1) {
              thisModule.isShowText = true;
            }
          });
        }).catch(function (err) {
          search.loadingFlag = false;
          alert("请求失败");
        });
      },
      loadMoreType: function () {
        var thisModule = this;
        search.loadingFlag = true;
        var param = {
          type: this.type,
          flag: 1,
          offset: search.offset,
          limit: search.limit
        };
        return api.getIndexList(param, {loading: false}).then(function (data) {
          data = data || [];
          if (data.length < search.limit) {
            thisModule.isMoreData = false;
          } else {
            thisModule.isMoreData = true;
          }
          //如果是首页没数据
          if (data.length === 0 && search.offset === 0) {
            thisModule.noData = true;
          }
          //search.offset += search.limit;
          thisModule.listData = thisModule.listData.concat(data);
          if (thisModule.listData.length) {
            search.offset = thisModule.listData[thisModule.listData.length - 1].activity_id;
          }
          thisModule.$nextTick(function () {
            search.loadingFlag = false;
            //if (data.length !== 0) {
            //    timeDownSearch();
            //}
            if (thisModule.listData.length >= 1) {
              thisModule.isShowText = true;
            }
          });
        }).catch(function (err) {
          search.loadingFlag = false;
          alert("请求失败");
        });
      },
      goAddActive: function () {
        this.$router.go({name: "add-active"});
      },
      //跳转详情页
      goDetail: function (index) {
        var obj = this.listData[index];
        //this.$router.go({name:"active-info",query:{"id":obj.id}});
        this.$router.go({path: "/search/active-info", query: {"id": obj.uuid}});
      },
      //列表滚动
      //onScroll:function(e){
      //    //如果没有更多数据 或者正在加载更多，不执行
      //    if(!this.isMoreData || search.loadingFlag) return;
      //
      //    var remain = 150;
      //    var scrollHeight = e.target.scrollHeight;
      //    var scrollTop = e.target.scrollTop;
      //    var clientHeight = e.target.offsetHeight||window.innerHeight;
      //    if(scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain){
      //        if(this.isMoreData && !search.loadingFlag){
      //            if(this.type == -1){
      //                this.loadMoreSearch();
      //            }else{
      //                this.loadMoreType();
      //            }
      //        }
      //
      //    }
      //
      //    //超出一屏显示 "底线"
      //    //var winHeight = document.body.clientHeight;
      //    //if(scrollTop>winHeight){
      //    //    this.isShowText = true;
      //    //}else{
      //    //    this.isShowText = false;
      //    //}
      //}
    },
    events: {
      setTitle: function (text) {
        if (!text) {
          return false;
        } else {
          document.title = text;
        }
        try {
          setTitle(text);
        } catch (e) {
        }
        return false;
      },
      getSearchList: function (val) {
        var thisModule = this;
        var t = this.title || document.getElementById("search-title").value;
        if (!t) {
          alert("请输入搜索内容");
          return;
        }
        this.oldTitle = t;
        if (val == 1) {  // 1-下拉刷新；2-上划加载
          if (thisModule.timer4) {
            clearInterval(thisModule.timer4)
          }
          thisModule.amountSearch = 10;
          thisModule.listData = [];
          search.offset = 0
        }
        search.loadingFlag = true;
        var param = {
          title: t,
          offset: search.offset,
          limit: search.limit
        };
        var opt = {
          loading: false,
          type: thisModule.fromPage
        };
        if (thisModule.fromPage == "dynamic-state") {
          param.limit = 20;
        }
        if (thisModule.amountSearch >= search.limit && val) {
          return api.search(param, opt).then(function (data) {
            data = data ? data : [];
            var pullUp = document.getElementById("pullUp");
            pullUp.style.display = "block";
            if (data.length == 0 && search.offset == 0) {
              thisModule.amountSearch = 0;
              thisModule.noData = true;
            }else if (data.length == 0 && search.offset != 0) {
              thisModule.amountSearch = 0;
              thisModule.noData = false;
            }else{
              thisModule.noData = false;

              if (data.length >= 10) {
                thisModule.amountSearch = data.length - (parseInt((data.length) / 10) - 1) * 10;
              } else if (data.length < 10) {
                thisModule.amountSearch = data.length
              }
              thisModule.startTimeList4 = [];
              data.forEach(function (item) {
                item.now_time = Math.floor(new Date().getTime() / 1000);
                item.hasTime = config.formateTimes(item.start_time);
                thisModule.startTimeList4.push(item.start_time);
              });
              if (search.offset == 0) {
                thisModule.listData = data;
              } else {
                thisModule.listData = thisModule.listData.concat(data);
              }
              if(thisModule.listData.length){
                search.offset = thisModule.listData[thisModule.listData.length - 1].activity_id;
              }
              if (thisModule.amountSearch < search.limit) {
                thisModule.isMoreData = false;
                search.switchPullUpText(false,0);
              } else {
                thisModule.isMoreData = true;
              }
              if (thisModule.fromPage == "dynamic-state") {
                thisModule.setShowDate();
              }
            }
            //搜索高亮
            function heightLight(t) {
              thisModule.listData.forEach(function (item) {
                console.log("22",item.title)
                var newVal = item.title.replace(t, '<span style="color:#f55151;">' + t + '</span>');
                item.title = newVal;
              })
            }

            function timeDownSearch() {
              var timeDown4 = setInterval(function () {
                thisModule.startTimeList4.forEach(function (item, index) {
                  item = item - 1000; //1s后才动，所以要-1s
                  if (data.length <= 10) {
                    thisModule.listData[index].hasTime = config.formateTimes(item);
                  } else if (data.length > 10) {
                    thisModule.listData[(parseInt(data.length / 10)) * 10 + index].hasTime = config.formateTimes(item);
                  }
                })
              }, 1000);
              thisModule.timer4.push(timeDown4);
            }
            thisModule.$nextTick(function () {
              search.loadingFlag = false;
              if (data.length != 0) {
                timeDownSearch();
                heightLight(t);
              }
              search.scroller3.myScroll.refresh();
            });
          }).catch(function (err) {
            search.scroller3.myScroll.refresh();
          });
        }else if (thisModule.amountSearch == 0 && search.offset == 0) {
          thisModule.noData = true;
        }else {
          thisModule.noData = false;
        }
      },
      refreshIndexList: function () {
        indexModule.offset = 0;
        this.$emit("getSearchList");
      }
    }
  });
  search.init = function (thisModule) {
    search.scroller3 = new IscrollFactory('search-wrapper', {
      probeType: 2,
      bounceTimeTime: 250,
      bounceEasing: 'quadratic',
      mouseWheel: false,
      scrollbars: false,
      fadeScrollbars: true,
      preventDefault: false,
      interactiveScrollbars: false,
      //bindToWrapper:true,//default:false
      deceleration: 0.003//default 0.0006
    }, pullDownAction, pullUpAction);
    search.scroller3.init();
    setTimeout(function () {
      search.scroller3.myScroll.refresh();
    }, 500);
    document.getElementById("search-wrapper").addEventListener('touchmove', function (e) {
      e.preventDefault();
    }, false);
    //下拉刷新
    function pullDownAction(theScroller) {
      thisModule.$emit("getSearchList", 1);
    }
    //上划加载
    function pullUpAction(theScroller) {
      thisModule.$emit("getSearchList", 2);
    }
  };
  search.switchPullUpText = function (more,index) {
    var el = document.getElementsByClassName("pullUp")[index];
    if (!el) {
      return;
    }
    if (more) {
      el.innerHTML = '<span class="pullUpIcon" id="pullUpIcon"></span><span id="pullUpLabel" class="pullUpLabel">上拉加载更多...</span>';
    } else {
      el.setAttribute("class", "no-data-text pullUp");
      el.innerHTML = '—— 我是有底线的 ——';
    }
  };
  return search.module;
});
