/**
 *search
 *搜索页模块
 *     --Created by Li Yubo on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "text!tplPath/sign-list.html"], function (Vue, config, api, tpl) {
  var signModule = {};
  signModule.offset = 0;
  signModule.limit = 10;
  signModule.loadingFlag = false;
  signModule.module = Vue.extend({
    template: tpl,
    data: function () {
      return {
        id: 0,
        showSignTap: 2,
        ratio: 0,
        showExport: false,
        listData: [],
        statistics: {},
        isMoreData: true,
        isShowText: false,
        showTextFlag: false,
        paddingFlag: null,
        email: "",
        flag: null,
        show: false,
        noMyListData: false,
        attentionFlag: false,
        initFlag: true,
        loadingMore: false
      }
    },
    ready: function () {

    },
    route: {
      activate: function (transition) {
        this.id = this.$route.query.id;
        this.flag = this.$route.query.flag;
        this.initFlag = true;
        signModule.offset = 0;
        console.log("签到##########", this.flag);
        if (this.flag != "1") {
          this.showSignTap = 1;
          this.$emit("getApplyStatistics");
          this.$emit("getSignList");
        } else {
          this.$emit("getApplyStatistics");
          this.$emit("getRegisterList");
        }
        transition.next();
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      attention: function (obj, ind) {
        var that = this;
        var type = obj.is_follow == 1 ? 0 : 1;
        var param = {
          "user_id": config.session.user_id,
          //"toUser_id":that.res.uid,
          "toUser_id": obj.uid,
          "type": type
        };
        return api.attentionUser(param, {loading: false}).then(function (data) {
          result = data;
          that.listData[ind].is_follow = obj.is_follow == 1 ? 0 : 1;
          config.toonNotify({
            type: 'follow', // 关注
            userId: config.session.user_id + '', // 当前用户id
            followUserId: obj.uid + '', // 要关注的用户id
            status: that.listData[ind].is_follow // 0：未关注、1：已关注
          });
        }).catch(function (data) {
          result = data;
          console.log("关注***************", data);
        });
      },
      changeSignTap: function (index, flagParam) {
        this.initFlag = false;
        if (!flagParam) {
          signModule.offset = 0;
          this.listData = [];
          //this.listDataLength = this.listData;
        }
        this.showSignTap = index;
        if (index === 2) {
          this.$emit("getApplyStatistics");
          this.$emit("getRegisterList");
        } else {
          this.$emit("getApplyStatistics");
          this.$emit("getSignList");
        }
      },
      getMoreList: function (index) {
        console.log("参与者查看签到");
        this.showSignTap = index;
        this.$emit("getSignList");
      },
      showExportPop: function (action) {
        this.showExport = action;
      },
      switchInfoShowStatus: function (e, ind) {
        var that = this;
        e.stopPropagation();
        that.listData[ind].show = !that.listData[ind].show;
//                this.listData[index].showInfo = !this.listData[index].showInfo;
      },
      skipCard: function (param) {
        if (param) {
          config.skipCard(param);
        }
      },
      skipCardCopy: function (fid) {
        if (fid && this.flag == "0") {
          config.skipCard(fid);
        }
      },
      onScroll: function (e) {
        var that = this;
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        that.initFlag = false;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          //如果有更多数据 或者没有加载中，执行
          if (this.isMoreData && !signModule.loadingFlag) {
            if (that.flag != "1") {
              this.getMoreList("1");
            } else {
              this.changeSignTap(this.showSignTap, true);
            }
          }
        }

        //超出一屏显示 "底线"
        var winHeight = document.body.clientHeight;
        //加上页脚高度，消除误差
        var footHeight = document.getElementById("sign-fade-foot").offsetHeight;

        if (scrollTop + footHeight > winHeight) {
          this.isShowText = true;
        } else {
          this.isShowText = false;
        }

      },
      //导出名单
      exportList: function () {
        //邮箱校验
        var email = this.email
        if (email.replace(/(^s*)|(s*$)/g, "").length == 0){
          alert("输入的邮箱不能为空");
          return false;
        } else if (!email.match(new RegExp(/^([a-zA-Z0-9_-])+@([a-zA-Z0-9_-])+((.[a-zA-Z0-9_-]{2,3}){1,2})$/))) {
          alert("请输入正确的邮箱");
          return false;
        }

        this.showExport = false;
        var param = {
          ac_id: this.id,
          mark: 2,//1代表报名;2代表签到
          email: email
        };
        var opt = {
          loading: true
        };
        return api.exportList(param, opt).then(function (data) {
          alert("导出成功", 3000);
        }).catch(function (err) {
          alert("导出失败,请稍后再试");
        });
      }
    },
    events: {
      //获取人数统计
      getApplyStatistics: function () {
        var thisModule = this;
        var param = {
          ac_id: this.id
        };
        var opt = {
          loading: false
        };
        return api.getCheckInStatistics(param, opt).then(function (data) {
          thisModule.statistics = data;
        }).catch(function (err) {
          console.log(err);
          alert("请求失败");
        });
      },
      getSignList: function () {
        var thisModule = this;
        thisModule.loadingMore = true;
        signModule.loadingFlag = true;
        var param = {
          ac_id: this.id,
          type: this.showSignTap,
          offset: signModule.offset,
          limit: signModule.limit
        };
        var opt = {
          loading: thisModule.initFlag
        };
        return api.getCheckInList(param, opt).then(function (data) {
          data = data || [];
          console.log(thisModule.flag);
          //thisModule.listDataLength = data;
          for (var i = 0; i < data.length; i++) {
            //更多信息是否展开变量设置
            data[i].show = false;
          }
          /*if(thisModule.flag == "1"){
           //处理报名信息
           for(var i=0;i<data.length;i++){
           //更多信息是否展开变量设置
           data[i].moreInfo = data[i].cus_info.length>2?true:false;
           data[i].showInfo = false;

           //提取姓名&手机字段
           data[i].mainInfo ={};
           for(var j=0;j<data[i].cus_info.length;j++){
           if(data[i].cus_info[j].id == "1"){
           data[i].mainInfo.name=data[i].cus_info[j].value;
           }else if(data[i].cus_info[j].id == "2"){
           data[i].mainInfo.phone=data[i].cus_info[j].value;
           }
           if(data[i].mainInfo.name && data[i].mainInfo.phone ){
           break;
           }
           }
           }
           }*/
          if (data.length == 0 && signModule.offset == 0) {
            thisModule.noMyListData = true;
          } else {
            thisModule.noMyListData = false;
          }
          if (data.length < signModule.limit) {
            thisModule.isMoreData = false;
            //thisModule.noMyListData = false;
          } else {
            thisModule.isMoreData = true;
            //thisModule.noMyListData = false;
          }
          if (signModule.offset == 0) {
            thisModule.listData = data;
          } else {
            thisModule.listData = thisModule.listData.concat(data);
          }
          if (thisModule.listData > 0 && data.length < signModule.limit) {
            thisModule.showTextFlag = true;
            thisModule.paddingFlag = 1;
          }
//                    thisModule.listData = data;
          if (thisModule.listData.length) {
            signModule.offset = thisModule.listData[thisModule.listData.length - 1].id;
            signModule.loadingFlag = false;
          }
          thisModule.$nextTick(function () {
            thisModule.loadingMore = false;
          });
        }).catch(function (err) {
          console.log(err);
          alert("请求失败");
        });
      },
      getRegisterList: function () {
        var thisModule = this;
        signModule.loadingFlag = true;
        var param = {
          ac_id: this.id,
          type: 1,
          offset: signModule.offset,
          limit: signModule.limit
        };
        var opt = {
          loading: signModule.offset === 0
        };
        return api.getApprovalList(param, opt).then(function (data) {
          data = data || [];
          for (var i = 0; i < data.length; i++) {
            //更多信息是否展开变量设置
            data[i].show = false;
          }
          /*if(thisModule.flag == "1"){
           //处理报名信息
           for(var i=0;i<data.length;i++){
           //更多信息是否展开变量设置
           data[i].moreInfo = data[i].cus_info.length>2?true:false;
           data[i].showInfo = false;

           //提取姓名&手机字段
           data[i].mainInfo ={};
           for(var j=0;j<data[i].cus_info.length;j++){
           if(data[i].cus_info[j].id == "1"){
           data[i].mainInfo.name=data[i].cus_info[j].value;
           }else if(data[i].cus_info[j].id == "2"){
           data[i].mainInfo.phone=data[i].cus_info[j].value;
           }
           if(data[i].mainInfo.name && data[i].mainInfo.phone ){
           break;
           }
           }
           }
           }*/
          if (data.length == 0 && signModule.offset == 0) {
            thisModule.noMyListData = true;
          } else {
            thisModule.noMyListData = false;
          }
          if (data.length < signModule.limit) {
            thisModule.isMoreData = false;
          } else {
            thisModule.isMoreData = true;
          }

          if (signModule.offset == 0) {
            thisModule.listData = data;
          } else {
            thisModule.listData = thisModule.listData.concat(data);
          }

//                    thisModule.listData = data;
          if (thisModule.listData.length) {
            signModule.offset = thisModule.listData[thisModule.listData.length - 1].id;
            signModule.loadingFlag = false;
          }
        }).catch(function (err) {
          console.log(err);
          alert("请求失败");
        });
      }
    }
  });
  return signModule.module;
});
