/**
 *search
 *搜索页模块
 *     --Created by shenxiaowei on 2016/10/31 10:43.
 */
define(["vue", "common/config", "common/api", "core", "text!tplPath/type-list.html"], function (Vue, config, api, core, tpl) {
  var typeModule = {
    loadingFlag: false,
//        offset:0,
    limit: 10,
    page: 1
  };
  typeModule.module = Vue.extend({
    template: tpl,
    ready: function () {
//            var that = this;
//            setTimeout(function(){
//                if(that.curType == 6 || that.curType == 7 || that.curType == 3 || that.curType == 4){
//                    var e=document.getElementById("scrollId");
//                    e.scrollLeft=window.innerWidth;
//                }
//            },500);
    },
    data: function () {
      return {
        curType: 0,
        type: 0,
        typeList: [],
        noData: false,
        isShowText: false,
        isMoreData: true,
        showModule: false,
        first: false
      }
    },
    route: {
      data: function (transition) {
        var that = this;
        transition.next();
        setTimeout(function () {
          if (that.curType == 6 || that.curType == 7 || that.curType == 3 || that.curType == 4) {
            var e = document.getElementById("scrollId");
            e.scrollLeft = window.innerWidth;
          }
        }, 500)
      },
      activate: function (transition) {
        //console.log("pipeline list vue.route.activate");
        var that = this;
        this.type = this.$route.query.type;
        this.curType = this.$route.query.type;
        this.first = true;
//                typeModule.offset = 0;
        typeModule.page = 1;
        this.$emit("getTypeList", false);
        transition.next();
      },
      deactivate: function (transition) {
        //console.log("pipeline list vue.route.deactivate");
        return transition.next();
      }
    },
    methods: {
      changeType: function (ind) {
        var that = this;
        if (config.isAllowSubmit) {
          config.isAllowSubmit = false;
          that.isShowText = false;
          that.showModule = true;
          that.curType = ind;
          that.type = ind;
//                typeModule.offset = 0;
          typeModule.page = 1;
//                    that.typeList = [];
          that.$emit("getTypeList", true);
        }
      },
      scrollToLast: function () {
        var e = document.getElementById("scrollId");
        e.scrollLeft = e.scrollWidth;
      },
      //列表滚动
      onScroll: function (e) {
        var remain = 150;
        var scrollHeight = e.target.scrollHeight;
        var scrollTop = e.target.scrollTop;
        var clientHeight = e.target.offsetHeight || window.innerHeight;
        if (scrollHeight >= remain + 50 && scrollHeight - scrollTop - clientHeight < remain) {
          if (this.isMoreData && !typeModule.loadingFlag) {
            this.$emit("getTypeList", false);
          }

        }
        //超出一屏显示 "底线"
        var winHeight = document.body.clientHeight;
//                if(scrollTop > winHeight){
//                    this.isShowText = true;
//                }else{
//                    this.isShowText = false;
//                }
      },
      goDetailById: function (id) {
        var that = this;
        var activeId = id;
        console.log("活动id----", activeId);
        that.$router.go({path: "/type-list/active-info", query: {"id": activeId}});
      }
    },
    events: {
      goToCurType: function () {
        if (this.curType == 6 || this.curType == 7 || this.curType == 3 || this.curType == 4) {
          var e = document.getElementById("scrollId");
          e.scrollLeft = window.innerWidth;
        }
      },
      getTypeList: function (flag) {
        var thisModule = this;
        typeModule.loadingFlag = true;
        var param = {
          type: this.type,
          page: typeModule.page
//                    limit:typeModule.limit
        };
        return api.getIndexList(param, {loading: false}).then(function (data) {
          data.list = data.list || [];
          typeModule.page = data.page ? data.page : 1;
          if (data.list.length <= typeModule.limit && data.page == data.totalPage) {
            thisModule.isMoreData = false;
          } else {
            thisModule.isMoreData = true;
          }
          //如果是首页没数据
//                    if(data.length === 0 && typeModule.offset === 0){
          if (data.list.length === 0 && typeModule.page === 1) {
            thisModule.noData = true;
          } else {
            thisModule.noData = false;
          }
          //search.offset += search.limit;
          if (flag) {
            thisModule.typeList = []
          }
          if (typeModule.page === 1 && data.list.length < 10) {
            thisModule.typeList = data.list;
          } else {
            thisModule.typeList = thisModule.typeList.concat(data.list);
          }
          if (data.list.length >= 10) {
//                        typeModule.offset = thisModule.typeList[thisModule.typeList.length-1].id;
            typeModule.page = typeModule.page + 1;
            typeModule.loadingFlag = false;
          }
          thisModule.$nextTick(function () {
            typeModule.loadingFlag = false;
            thisModule.showModule = true;
//                        if(thisModule.first){
//                            thisModule.first = false;
//                            var e=document.getElementById("scrollId");
//                            e.scrollLeft=window.innerWidth;
//                        }
            if (thisModule.typeList.length >= 3) {
              thisModule.isShowText = true;
            }
          });
        }).catch(function (err) {
          typeModule.loadingFlag = false;
          console.log("错误", err);
          alert("请求失败");
        });
      }
    }
  });
  return typeModule.module;
});